/*
 * Hexecute 3.0
 * BankSplit.cpp
 * copyright 2000 Mike Walston
 * 
 * This is the main file, it will hold WinMain
 */
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"


BOOL CALLBACK BankSplitProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	TCHAR szTitleName[_MAX_PATH];
	TCHAR szHamburger[100], szTemp[20];
	unsigned long a, c;
	static long HeaderSize = 0;
	static DWORD BankSize;
	std::fstream BankFile;
	switch (msg) {
	case WM_INITDIALOG:
	_tcscpy(szTitleName, Filename);

		CheckDlgButton(hWnd, IDC_4KRADIO, 1);
		return 0;
	
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
				if(IsDlgButtonChecked(hWnd, IDC_HEADERCHECK))
				{
					if(!GetDlgItemText(hWnd, IDC_HEADERSIZEEDIT, szHamburger, 19))
					{
						MessageBox(hWnd, TEXT("Please input a header size"), PROGRAM_NAME, MB_OK);
					}
					else
#ifndef UNICODE
						HeaderSize = strtol(szHamburger, NULL, 16);
#else
						HeaderSize = wcstol(szHamburger, NULL, 16);
#endif
				}
				if(IsDlgButtonChecked(hWnd, IDC_CUSTOMSIZE))
				{
					if(!GetDlgItemText(hWnd, IDC_BANKSIZEEDIT, szHamburger, 19))
					{
						MessageBox(hWnd, TEXT("Please input a bank size"), PROGRAM_NAME, MB_OK);
						return (TRUE);
					}
					else
#ifndef UNICODE
						BankSize = strtol(szHamburger, NULL, 16);
#else
						BankSize = wcstol(szHamburger, NULL, 16);
#endif
				}				
				SetCursor(LoadCursor(NULL, IDC_WAIT));
				for( a = 0, c = HeaderSize; a < ( MaxAddress / BankSize ) ; a++, c += BankSize)
				{
					wsprintf(szTitleName, Filename);
					wsprintf(szTemp, ".%08X.bank", a);
					lstrcat(szTitleName, szTemp);
					BankFile.open(szTitleName, std::ios::out | std::ios::binary);
					BankFile.write((LPCSTR)&File[c], BankSize);
					BankFile.close();										
					//lstrcat(szTitleName, ".bnk");
				}
				SetCursor(LoadCursor(NULL, IDC_ARROW));
				EndDialog(hWnd, 1);
				return (TRUE);

				case IDC_4KRADIO:
					BankSize = __4KBANK;
					return (TRUE);

				case IDC_8KRADIO:
					BankSize = __8KBANK;
					return (TRUE);
	
				case IDC_16KRADIO:
					BankSize = __16KBANK;
					return (TRUE);

				case IDC_32KRADIO:
					BankSize = __32KBANK;
					return (TRUE);

				case IDC_64KRADIO:
					BankSize = __64KBANK;
					return (TRUE);

				case IDCANCEL:
					EndDialog(hWnd, 0);
					return (TRUE);
			}
	}
	return (FALSE);
}