/*
 * Hexecute 3.0
 * ClipBoard.cpp
 * copyright 2000 Mike Walston
 *
 * the clipboard code, for copying and whatnot
 */

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <mbstring.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void CopyAsText(HWND hWnd, HGLOBAL	ClipBoardData, PTSTR pClipBoardData)
{
	char temp[50];
	int CopyLength, nihon;
	if(startHighlight > endHighlight)
	{
		nihon = startHighlight;
		startHighlight = endHighlight;
		endHighlight = nihon;
	}

	CopyLength = endHighlight - startHighlight;
	ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, CopyLength * 4 * sizeof(TCHAR));
	pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
	for(nihon = 0; nihon < CopyLength; nihon++)
	{
		if(!(nihon % 2 ))
		{
			wsprintf(temp, "%02X", GetFileByte(startHighlight + nihon));
			lstrcat(pClipBoardData, temp);
		} else {
			wsprintf(temp, "%02X ", GetFileByte(startHighlight + nihon));
			lstrcat(pClipBoardData, temp);
		}
		if(!( (nihon + 1) % 16) )
		{
			wsprintf(temp, "\r\n");
			lstrcat(pClipBoardData, temp);
		}
	}
	GlobalUnlock(ClipBoardData);
	OpenClipboard(hWnd);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, ClipBoardData);
	CloseClipboard();
	EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
	return;
}

void CopyAsCharArray(HWND hWnd, HGLOBAL	ClipBoardData, PTSTR pClipBoardData)
{
	char temp[50];
	int CopyLength, nihon;
	if(startHighlight > endHighlight)
	{
		nihon = startHighlight;
		startHighlight = endHighlight;
		endHighlight = nihon;
	}
	CopyLength = endHighlight - startHighlight;
	ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, ( ( CopyLength * 4 ) + 500 ) * sizeof(TCHAR));
	pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
	wsprintf(pClipBoardData, "/*Copied from Hexecute*/\r\nunsigned char HexData[0x%08X] {\r\n", CopyLength);
	for(nihon = 0; nihon < CopyLength - 1; nihon++)
	{
		wsprintf(temp, "0x%02X, ", GetFileByte(startHighlight + nihon));
		lstrcat(pClipBoardData, temp);
		if(!( (nihon + 1) % 8) )
		{
			wsprintf(temp, "\r\n");
			lstrcat(pClipBoardData, temp);
		}
	}
	wsprintf(temp, "0x%02X", GetFileByte(startHighlight + nihon));
	lstrcat(pClipBoardData, temp);
	lstrcat(pClipBoardData, "\r\n};");
	GlobalUnlock(ClipBoardData);
	OpenClipboard(hWnd);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, ClipBoardData);
	CloseClipboard();
	EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
	return;
}

void CopyAsShortArray(HWND hWnd, HGLOBAL ClipBoardData, PTSTR pClipBoardData)
{
	char temp[50];
	int CopyLength, nihon;
	if(startHighlight > endHighlight)
	{
		nihon = startHighlight;
		startHighlight = endHighlight;
		endHighlight = nihon;
	}
	CopyLength = endHighlight - startHighlight;
	ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, ( ( CopyLength * 4 ) + 500) * sizeof(TCHAR));
	pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
	wsprintf(pClipBoardData, "/*Copied from Hexecute*/\r\nunsigned short HexData[0x%08X] {\r\n", CopyLength / 2);
	for(nihon = 0; nihon < CopyLength - 2; nihon += 2)
	{
		if(BigEndian)
			wsprintf(temp, "0x%02X%02X, ", GetFileByte(startHighlight + nihon), GetFileByte(startHighlight + nihon + 1));
		else
			wsprintf(temp, "0x%02X%02X, ", GetFileByte(startHighlight + nihon + 1), GetFileByte(startHighlight + nihon));
		lstrcat(pClipBoardData, temp);
		if(!( (nihon + 2) % 8))
		{
			wsprintf(temp, "\r\n");
			lstrcat(pClipBoardData, temp);
		}
	}
	if( CopyLength % 2 ) // we don't have an even number of bytes
	{
		if(BigEndian)
			wsprintf(temp, "0x%02X%02X", GetFileByte(startHighlight + nihon), 0);
		else wsprintf(temp, "0x%02X%02X", 0, GetFileByte(startHighlight + nihon));
	} else {
		if(BigEndian)
			wsprintf(temp, "0x%02X%02X", GetFileByte(startHighlight + nihon), GetFileByte(startHighlight + nihon + 1));
		else wsprintf(temp, "0x%02X%02X", GetFileByte(startHighlight + nihon + 1), GetFileByte(startHighlight + nihon));
	}
						
	lstrcat(pClipBoardData, temp);
	lstrcat(pClipBoardData, "\r\n};");
	GlobalUnlock(ClipBoardData);
	OpenClipboard(hWnd);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, ClipBoardData);
	CloseClipboard();
	EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
	return;
}

void CopyAsIntArray(HWND hWnd, HGLOBAL ClipBoardData, PTSTR pClipBoardData)
{
	char temp[50], temp2[50], temp3[50], temp4[50], temp5[50];
	int CopyLength, nihon;

	if(startHighlight > endHighlight)
	{
		nihon = startHighlight;
		startHighlight = endHighlight;
		endHighlight = nihon;
	}

	CopyLength = endHighlight - startHighlight;
	ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT,(  ( CopyLength * 4 ) + 500) * sizeof(TCHAR) );
	pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
	wsprintf(pClipBoardData, "/*Copied from Hexecute*/\r\nunsigned int HexData[0x%08X] {\r\n", CopyLength / 4);
	for(nihon = 0; nihon < CopyLength - 4; nihon += 4)
	{
		if(BigEndian)
			wsprintf(temp, "0x%02X%02X%02X%02X, ", 
				GetFileByte(startHighlight + nihon), GetFileByte(startHighlight + nihon + 1),
				GetFileByte(startHighlight + nihon + 2), GetFileByte(startHighlight + nihon + 3));
		else
			wsprintf(temp, "0x%02X%02X%02X%02X, ", 
				GetFileByte(startHighlight + nihon + 3), GetFileByte(startHighlight + nihon + 2),
				GetFileByte(startHighlight + nihon + 1), GetFileByte(startHighlight + nihon));
		lstrcat(pClipBoardData, temp);
		if(!( (nihon +4 ) % 8))
		{
			wsprintf(temp, "\r\n");
			lstrcat(pClipBoardData, temp);
		}
	}
	if( CopyLength % 4 ) // we don't have an even number of bytes
	{
		wsprintf(temp, "");
		if(BigEndian)
		{
			if(nihon < CopyLength)
			{
				wsprintf(temp2, "0x%02X", GetFileByte(startHighlight + nihon));
				strcat(temp, temp2);
				nihon++;
			}
			if(nihon < CopyLength)
			{
				wsprintf(temp2, "%02X", GetFileByte(startHighlight + nihon));
				strcat(temp, temp2);
				nihon++;
			} else {
				wsprintf(temp2, "%02X", 0);
				strcat(temp, temp2);
				nihon++;
			}
			if(nihon < CopyLength)
			{
				wsprintf(temp2, "%02X", GetFileByte(startHighlight + nihon));
				strcat(temp, temp2);
				nihon++;
			} else {
				wsprintf(temp2, "%02X", 0);
				strcat(temp, temp2);
				nihon++;
			}
			if(nihon < CopyLength)
			{
				wsprintf(temp2, "%02X", GetFileByte(startHighlight + nihon));
				strcat(temp, temp2);
				nihon++;
			} else {
				wsprintf(temp2, "%02X", 0);
				strcat(temp, temp2);
				nihon++;
			}
		}
		else 
		{
			if(nihon < CopyLength)
			{
				wsprintf(temp5, "%02X", GetFileByte(startHighlight + nihon));
				nihon++;
			}
			if(nihon < CopyLength)
			{
				wsprintf(temp4, "%02X", GetFileByte(startHighlight + nihon));
				nihon++;
			} else {
				wsprintf(temp4, "%02X", 0);
				nihon++;
			}
			if(nihon < CopyLength)
			{
				wsprintf(temp3, "%02X", GetFileByte(startHighlight + nihon));
				nihon++;
			} else {
				wsprintf(temp3, "%02X", 0);
				nihon++;
			}
			if(nihon < CopyLength)
			{
				wsprintf(temp2, "%02X", GetFileByte(startHighlight + nihon));
				nihon++;
			} else {
				wsprintf(temp2, "%02X", 0);
				nihon++;
			}
			wsprintf(temp, "0x");
			strcat(temp, temp2);
			strcat(temp, temp3);
			strcat(temp, temp4);
			strcat(temp, temp5);
		}
	} else {
		if(BigEndian)
			wsprintf(temp, "0x%02X%02X%02X%02X", 
				GetFileByte(startHighlight + nihon), GetFileByte(startHighlight + nihon + 1),
				GetFileByte(startHighlight + nihon + 2), GetFileByte(startHighlight + nihon + 3));
		else wsprintf(temp, "0x%02X%02X%02X%02X", 
				GetFileByte(startHighlight + nihon + 3), GetFileByte(startHighlight + nihon + 2),
				GetFileByte(startHighlight + nihon + 1), GetFileByte(startHighlight + nihon));
	}			
	lstrcat(pClipBoardData, temp);
	lstrcat(pClipBoardData, "\r\n};");
	GlobalUnlock(ClipBoardData);
	OpenClipboard(hWnd);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, ClipBoardData);
	CloseClipboard();
	EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
	return;
}


void CopyString(char* DestinationBuffer, int ExtractionAddress, int Length) {	
	tableEntry* tempNode;
	int checkValue = 0, hehe = 0, f00b4r = 0;	
	DestinationBuffer[0] = 0x00;
	if(CurrentTable != -1) // if we have a table
	{
		if(Table[CurrentTable]->getCodepage() == 1252)
		{
			for(int a = ExtractionAddress; a < ExtractionAddress + Length; a++)
			{
				switch( Table[CurrentTable]->getWidestValue() ) {
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(a + hehe) << 24);
						hehe += 1;
						//otherwise we'll just fall through
					case 3:
						// check for 3 byte match
						checkValue += (GetFileByte(a + hehe) << 16 );
						hehe += 1;
					case 2:
						// check for 2 byte match
						checkValue += (GetFileByte(a + hehe) << 8 );
						hehe += 1;
					default:
						checkValue += GetFileByte(a + hehe);
						switch( Table[CurrentTable]->getWidestValue() ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						}
						a += hehe;
						checkValue = 0;
				}
				if(!strcmp(tempNode->string, "HEXECUTE_NEWLINE"))
					strcat(DestinationBuffer, "\r\n");
				else if (!strcmp(tempNode->string, "HEXECUTE_ENDSTRING"))
					strcat(DestinationBuffer, "\r\n \r\n");
				else 
					strcat(DestinationBuffer, tempNode->string);
			}
		}
		else
		{
			for(int a = ExtractionAddress; a < ExtractionAddress + Length; a++)
			{
				switch( Table[CurrentTable]->getWidestValue() ) {
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(a + hehe) << 24);
						hehe += 1;
						//otherwise we'll just fall through
					case 3:
						// check for 3 byte match
						checkValue += ( GetFileByte(a + hehe) << 16 );
						hehe += 1;
					case 2:
						// check for 2 byte match
						checkValue += ( GetFileByte(a + hehe) << 8 );
						hehe += 1;
					default:
						checkValue += GetFileByte(a + hehe);
						switch( Table[CurrentTable]->getWidestValue() ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						}
						a += hehe;
						checkValue = 0;
						hehe = 0;
				}
				if(!_mbscmp((const unsigned char*)tempNode->string, (const unsigned char*)"HEXECUTE_NEWLINE"))
				{
					strcat(DestinationBuffer, "\r\n");
				}
				else if (!_mbscmp((const unsigned char*)tempNode->string, (const unsigned char*)"HEXECUTE_ENDSTRING"))
				{
					strcat(DestinationBuffer, "\r\n\r\n");
				}
				else strcat(DestinationBuffer, tempNode->string);
			}
		}
	}
	// this is when we don't have a table file, and are just dumping ascii
	else {
		int f00b4r = 0;
		for(int a = ExtractionAddress; a < ExtractionAddress + Length; a++ ,f00b4r++)
		{
			DestinationBuffer[f00b4r] = GetFileByte(a);
		}
		DestinationBuffer[f00b4r] = 0;
	}
}

