/*
 * Hexecute 3.0
 * CodePagesProc.cpp
 * copyright 2000 Mike Walston
 *
 * the function that handles the enumeration of
 * system code pages
 */

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

/*

extern CodePage CPages[20];
extern int InstalledPage;

struct CodePage {
	char* name;
	UINT CodePageNum;
	HFONT font;
};
*/

void AddCodePagesToMenu(HMENU hMenu)
{
	MENUITEMINFO mii;
	mii.cbSize = sizeof(MENUITEMINFO);
	mii.fType = MFT_STRING;          
	mii.fState = MFS_ENABLED;          
	mii.fMask = MIIM_TYPE | MIIM_ID | MIIM_STATE;

	long foo[7] = { IDM_CODEPAGE0, IDM_CODEPAGE1, IDM_CODEPAGE2, IDM_CODEPAGE3, 
		IDM_CODEPAGE4, IDM_CODEPAGE5, IDM_CODEPAGE6 }; 
	for(int d = 0; d < InstalledPage; d++)
	{
		mii.wID = foo[d];
		mii.dwTypeData = CPages[d].name;
		InsertMenuItem(hMenu, (UINT)-1, TRUE, &mii);
		// All AppendMenu Calls are being replaced by InsertMenuItem
		//AppendMenu(hMenu, MF_STRING, foo[d], CPages[d].name);

	}
	if(!CleanUp)
		CheckMenuItem(hMenu, CurrentCodePage + 2, MF_BYPOSITION | MF_CHECKED);
}

int GetCPIndex(unsigned int CP)
{
	for(int a = 0; a < InstalledPage ; a++)
		if(CP == CPages[a].CodePageNum)
			return a;
	return -1;
}

int GetCPIndex(char* CP)
{
	return GetCPIndex((unsigned int)strtoul(CP, NULL, 10));
}

BOOL CALLBACK CodePagesProc(LPTSTR lpCodePageString)
{
	//LOGFONT tempLogFont;
	char localString[500];
	if(lpCodePageString[0] == 0x00)
		return 0;
	else
	{
		if(!strcmp(lpCodePageString, TEXT("874"))) {
			ZeroMemory(&CPages[InstalledPage].logFont, sizeof(LOGFONT));
			CPages[InstalledPage].logFont.lfQuality = DRAFT_QUALITY;
			CPages[InstalledPage].logFont.lfCharSet = THAI_CHARSET;
			_tcscpy(CPages[InstalledPage].logFont.lfFaceName, ThaiFontName);
			CPages[InstalledPage].logFont.lfHeight = FontHeight;								 // the height of the desired font is 12
			CPages[InstalledPage].logFont.lfWidth = 0;                          // use the default width
			CPages[InstalledPage].logFont.lfWeight = FW_NORMAL;						 // use normal thickness
			CPages[InstalledPage].logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
			DeleteObject(CPages[InstalledPage].font);
			CPages[InstalledPage].font = CreateFontIndirect(&CPages[InstalledPage].logFont);	// create the logical font
			CPages[InstalledPage].CodePageNum = strtoul(lpCodePageString, NULL, 10);
			_tcscpy(CPages[InstalledPage].FontName, ThaiFontName);
			_tcscpy(localString, lpCodePageString);
			strcat(localString, " ( Thai )");
			CPages[InstalledPage].name = (TCHAR*)GlobalAlloc( GMEM_FIXED | GMEM_ZEROINIT, ( _tcslen(localString) + 1 ) * sizeof(TCHAR) );
			_tcscpy(CPages[InstalledPage].name, localString);
			InstalledPage++;
		}
		else if(!strcmp(lpCodePageString, TEXT("932"))) {
			ZeroMemory(&CPages[InstalledPage].logFont, sizeof(LOGFONT));
			CPages[InstalledPage].logFont.lfQuality = DRAFT_QUALITY;
			CPages[InstalledPage].logFont.lfCharSet = SHIFTJIS_CHARSET;
			_tcscpy(CPages[InstalledPage].logFont.lfFaceName, JapaneseFontName);
			CPages[InstalledPage].logFont.lfHeight = FontHeight;								 // the height of the desired font is 12
			CPages[InstalledPage].logFont.lfWidth = 0;                          // use the default width
			CPages[InstalledPage].logFont.lfWeight = FW_NORMAL;						 // use normal thickness
			CPages[InstalledPage].logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
			DeleteObject(CPages[InstalledPage].font);
			CPages[InstalledPage].font = CreateFontIndirect(&CPages[InstalledPage].logFont);	// create the logical font
			CPages[InstalledPage].CodePageNum = strtoul(lpCodePageString, NULL, 10);
			_tcscpy(CPages[InstalledPage].FontName, JapaneseFontName);
			_tcscpy(localString, lpCodePageString);
			strcat(localString, " ( Japanese )");
			CPages[InstalledPage].name = (TCHAR*)GlobalAlloc( GMEM_FIXED | GMEM_ZEROINIT, ( _tcslen(localString) + 1 ) * sizeof(TCHAR) );
			_tcscpy(CPages[InstalledPage].name, localString);
			InstalledPage++;
		}
		else if (!strcmp(lpCodePageString, TEXT("936"))) {
			ZeroMemory(&CPages[InstalledPage].logFont, sizeof(LOGFONT));
			CPages[InstalledPage].logFont.lfQuality = DRAFT_QUALITY;
			CPages[InstalledPage].logFont.lfCharSet = CHINESEBIG5_CHARSET;
			_tcscpy(CPages[InstalledPage].logFont.lfFaceName, SimplifiedChineseFontName);
			CPages[InstalledPage].logFont.lfHeight = FontHeight;								 // the height of the desired font is 12
			CPages[InstalledPage].logFont.lfWidth = 0;                          // use the default width
			CPages[InstalledPage].logFont.lfWeight = FW_NORMAL;						 // use normal thickness
			CPages[InstalledPage].logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
			DeleteObject(CPages[InstalledPage].font);
			CPages[InstalledPage].font = CreateFontIndirect(&CPages[InstalledPage].logFont);	// create the logical font
			CPages[InstalledPage].CodePageNum = strtoul(lpCodePageString, NULL, 10);
			_tcscpy(CPages[InstalledPage].FontName, SimplifiedChineseFontName);
			_tcscpy(localString, lpCodePageString);
			strcat(localString, " ( Simplified Chinese )");
			CPages[InstalledPage].name = (TCHAR*)GlobalAlloc( GMEM_FIXED | GMEM_ZEROINIT, ( _tcslen(localString) + 1 ) * sizeof(TCHAR));
			_tcscpy(CPages[InstalledPage].name, localString);
			InstalledPage++;
		}
		else if (!strcmp(lpCodePageString, TEXT("949"))) {
			ZeroMemory(&CPages[InstalledPage].logFont, sizeof(LOGFONT));
			CPages[InstalledPage].logFont.lfQuality = DRAFT_QUALITY;
			CPages[InstalledPage].logFont.lfCharSet = HANGUL_CHARSET ;
			_tcscpy(CPages[InstalledPage].logFont.lfFaceName, KoreanFontName);
			CPages[InstalledPage].logFont.lfHeight = FontHeight;								 // the height of the desired font is 12
			CPages[InstalledPage].logFont.lfWidth = 0;                          // use the default width
			CPages[InstalledPage].logFont.lfWeight = FW_NORMAL;						 // use normal thickness
			CPages[InstalledPage].logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
			DeleteObject(CPages[InstalledPage].font);
			CPages[InstalledPage].font = CreateFontIndirect(&CPages[InstalledPage].logFont);	// create the logical font
			CPages[InstalledPage].CodePageNum = strtoul(lpCodePageString, NULL, 10);
			_tcscpy(CPages[InstalledPage].FontName, KoreanFontName);
			_tcscpy(localString, lpCodePageString);
			strcat(localString, " ( Korean )");
			CPages[InstalledPage].name = (TCHAR*)GlobalAlloc( GMEM_FIXED | GMEM_ZEROINIT, ( _tcslen(localString) + 1 ) * sizeof(TCHAR));
			_tcscpy(CPages[InstalledPage].name, localString);
			InstalledPage++;
		}
		else if (!strcmp(lpCodePageString, TEXT("950"))) {
			ZeroMemory(&CPages[InstalledPage].logFont, sizeof(LOGFONT));
			CPages[InstalledPage].logFont.lfQuality = DRAFT_QUALITY;
			CPages[InstalledPage].logFont.lfCharSet = CHINESEBIG5_CHARSET;
			_tcscpy(CPages[InstalledPage].logFont.lfFaceName, TraditionalChineseFontName);
			CPages[InstalledPage].logFont.lfHeight = FontHeight;								 // the height of the desired font is 12
			CPages[InstalledPage].logFont.lfWidth = 0;                          // use the default width
			CPages[InstalledPage].logFont.lfWeight = FW_NORMAL;						 // use normal thickness
			CPages[InstalledPage].logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
			DeleteObject(CPages[InstalledPage].font);
			CPages[InstalledPage].font = CreateFontIndirect(&CPages[InstalledPage].logFont);	// create the logical font
			CPages[InstalledPage].CodePageNum = strtoul(lpCodePageString, NULL, 10);
			_tcscpy(CPages[InstalledPage].FontName, TraditionalChineseFontName);
			_tcscpy(localString, lpCodePageString);
			strcat(localString, " ( Traditional Chinese )");
			CPages[InstalledPage].name = (TCHAR*)GlobalAlloc( GMEM_FIXED | GMEM_ZEROINIT, ( _tcslen(localString) + 1 ) * sizeof(TCHAR));
			_tcscpy(CPages[InstalledPage].name, localString);
			InstalledPage++;
		}

		/*
		 * getting rid of the johab stuff at the moment, i'll
		 * try to get it working once I get all the other fonts
		 * working
		 *

		else if (!strcmp(lpCodePageString, TEXT("1361"))) {
#ifdef _DEBUG		// debugging stuff
	//		MessageBox(NULL, TEXT("Entering code page 1361 setup"), PROGRAM_NAME, MB_OK);
#endif		// end debugging stuff
			ZeroMemory(&CPages[InstalledPage].logFont, sizeof(LOGFONT));
			CPages[InstalledPage].logFont.lfQuality = DRAFT_QUALITY;
			CPages[InstalledPage].logFont.lfCharSet = JOHAB_CHARSET ;
			_tcscpy(CPages[InstalledPage].logFont.lfFaceName, KoreanFontName);
			CPages[InstalledPage].logFont.lfHeight = FontHeight;								 // the height of the desired font is 12
			CPages[InstalledPage].logFont.lfWidth = 0;                          // use the default width
			CPages[InstalledPage].logFont.lfWeight = FW_NORMAL;						 // use normal thickness
			CPages[InstalledPage].logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
			CPages[InstalledPage].font = CreateFontIndirect(&CPages[InstalledPage].logFont);	// create the logical font
			CPages[InstalledPage].CodePageNum = strtoul(lpCodePageString, NULL, 10);
			_tcscpy(CPages[InstalledPage].FontName, KoreanFontName);
			_tcscpy(localString, lpCodePageString);
			strcat(localString, " ( Korean - Johab )");
			CPages[InstalledPage].name = (TCHAR*)GlobalAlloc( GMEM_FIXED | GMEM_ZEROINIT, ( _tcslen(localString) + 1 ) * sizeof(TCHAR));
			_tcscpy(CPages[InstalledPage].name, localString);
			InstalledPage++;
#ifdef _DEBUG		// debugging stuff
	//		MessageBox(NULL, TEXT("Exiting code page 1361 setup"), PROGRAM_NAME, MB_OK);
#endif		// end debugging stuff
		}
		*/
		
	}
	return true;
}