/*
 * Hexecute 3.0
 * ComboBox.cpp
 * copyright 2000 Mike Walston
 *
 * This is the file that holds combo box functions
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void SaveLastComboBoxText(HWND hWnd, char* TextValChar, char* TextRelChar,
						  char* DecimalChar, const int &Value, const int &Relative, 
						  const int &Text, const int &Decimal, const int &Hex)
{
	if(Hex) // if this is selected than nothing was possibly changed
		return;

	if(Decimal)//if decimal is selected then we get the text for the data size
	{
		GetDlgItemText(hWnd, IDC_PREFERENCES_COMBO, DecimalChar, 25);
		return;
	}

	// everything down here is text, so it's relative or value
	if(Relative)
	{
		GetDlgItemText(hWnd, IDC_PREFERENCES_COMBO, TextRelChar, 25);
		return;
	}
	else
	{
		GetDlgItemText(hWnd, IDC_PREFERENCES_COMBO, TextValChar, 25);
		return;
	}
	return;
}


void CleanUpComboBoxArray(COMBOBOXTEXT pcbtComboBoxTextArray[3])
{
	for(int c = 0; c < 3; c++)
	{
		for(int a = 0; a < pcbtComboBoxTextArray[c].iNumStrings; a++)
		{
			delete[] pcbtComboBoxTextArray[c].Text[a];
		}
		delete[] pcbtComboBoxTextArray[c].Text;
	}
}

void InitializeComboBoxArray(COMBOBOXTEXT pcbtComboBoxTextArray[3])
{
	
	// allocate space for the actual text
	// and fill with the strings for ascii relative
	pcbtComboBoxTextArray[0].iNumStrings = 6;
	pcbtComboBoxTextArray[0].Text = new char*[6];
	for(int a = 0; a < 6; a++)
		pcbtComboBoxTextArray[0].Text[a] = new char[20];
	_tcscpy( pcbtComboBoxTextArray[0].Text[0], TEXT("Caps-Low-Num"));
	_tcscpy( pcbtComboBoxTextArray[0].Text[1], TEXT("Caps-Num-Low"));
	_tcscpy( pcbtComboBoxTextArray[0].Text[2], TEXT("Num-Caps-Low"));
	_tcscpy( pcbtComboBoxTextArray[0].Text[3], TEXT("Num-Low-Caps"));
	_tcscpy( pcbtComboBoxTextArray[0].Text[4], TEXT("Low-Caps-Num"));
	_tcscpy( pcbtComboBoxTextArray[0].Text[5], TEXT("Low-Num-Caps"));

	// allocate space for the actual text
	// and fill with the strings for ascii absolute
	pcbtComboBoxTextArray[1].iNumStrings = 3;
	pcbtComboBoxTextArray[1].Text = new char*[3];
	for(int b = 0; b < 3; b++)
		pcbtComboBoxTextArray[1].Text[b] = new char[20];
	_tcscpy( pcbtComboBoxTextArray[1].Text[0], TEXT("ASCII(7-bit)"));
	_tcscpy( pcbtComboBoxTextArray[1].Text[1], TEXT("Unicode"));
	_tcscpy( pcbtComboBoxTextArray[1].Text[2], TEXT("EBCDIC"));
	
	// allocate space for the actual text
	// and fill with the strings for decimal
	pcbtComboBoxTextArray[2].iNumStrings = 12;
	pcbtComboBoxTextArray[2].Text = new char*[12];
	for(int c = 0; c < 12; c++)
		pcbtComboBoxTextArray[2].Text[c] = new char[20];
	_tcscpy( pcbtComboBoxTextArray[2].Text[0], TEXT("char"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[1], TEXT("unsigned char"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[2], TEXT("short"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[3], TEXT("unsigned short"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[4], TEXT("int"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[5], TEXT("unsigned int"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[6], TEXT("long"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[7], TEXT("unsigned long"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[8], TEXT("float"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[9], TEXT("unsigned float"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[10], TEXT("double"));
	_tcscpy( pcbtComboBoxTextArray[2].Text[11], TEXT("unsigned double"));

}


void SetComboBoxText(HWND hWnd, COMBOBOXTEXT* pcbtText)
{
	// clear the items in the combo box dropdown
	SendMessage(hWnd, CB_RESETCONTENT, 0, 0);
	
	//add the strings for the text selection
	for(int a = 0; a < pcbtText->iNumStrings; a++)
		SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)pcbtText->Text[a]);

}