/*
 * Conversions.cpp
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

// all direct access to File[index] need to be replaced with 
// FileByte(index), that way I can work with very large files
bool isValue[5];
int asteriskCounter = 0;
int HeaderSize = 0x200;

inline bool IsChange(int address)
{
	return false;
}

inline bool SetChanged(int address)
{
	return false;
}

inline bool ClearChanged(int address)
{
	return false;	
}

inline unsigned short GetUnicodeFileByte(int Address)
{
	char temp[MAX_PATH];
	if(IsPagingOn)
	{
		if(Address < ( CurrentPage.offset / 2 ) )
		{
			// here we check if the former page needs to be saved to a temp
			if(PagesAltered[CurrentPage.offset / 0x800000])
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "w+b");
				fwrite(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			CurrentPage.offset = ( Address - ( Address % 0x400000 ) * 2 );
			FileStream.seekg( CurrentPage.offset, std::ios::beg);
			if( PagesAltered[CurrentPage.offset / 0x800000] )
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "rb");
				fread(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			else
				FileStream.read((LPSTR)File, 0x800000);
		}
		else if (Address > CurrentPage.offset + 0x800000)
		{
			// here we check if the former page needs to be saved to a temp
			if(PagesAltered[CurrentPage.offset / 0x800000])
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "w+b");
				fwrite(File, sizeof(wchar_t), 0x800000, floop);
				fclose(floop);
			}
			CurrentPage.offset = ( Address - ( Address % 0x400000 ) * 2 );
			FileStream.seekg(CurrentPage.offset, std::ios::beg);
			if( PagesAltered[CurrentPage.offset / 0x800000] )
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "rb");
				fread(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			else
				FileStream.read((LPSTR)File, 0x800000);
		}
		return UnicodeFile[Address % 0x400000];
	}
	else 
		return UnicodeFile[Address];
}

inline unsigned char GetFileByte(int Address)
{
	// at the moment it doesn't do anything at all, but this way I can 
	// do the modifications that I need to do to accessing modes and
	// not have to modify too much other code
	// what I'm going to do, is just page the code in and out of here, 
	// it'll require a check every time to see if the current address 
	// is inside the current page, I'm going to use large pages though
	// 4MB probably
	// 8MB it is!
	char temp[MAX_PATH];

	if(IsPagingOn)
	{
		if(Address < CurrentPage.offset)
		{
			// here we check if the former page needs to be saved to a temp
			if(PagesAltered[CurrentPage.offset / 0x800000])
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "w+b");
				fwrite(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			CurrentPage.offset = Address - ( Address % 0x800000 );
			FileStream.seekg( CurrentPage.offset, std::ios::beg);
			if( PagesAltered[CurrentPage.offset / 0x800000] )
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "rb");
				fread(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			else
				FileStream.read((LPSTR)File, 0x800000);
		}
		else if (Address > CurrentPage.offset + 0x800000)
		{
			// here we check if the former page needs to be saved to a temp
			if(PagesAltered[CurrentPage.offset / 0x800000])
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "w+b");
				fseek(floop, 0, SEEK_SET);
				fwrite(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			CurrentPage.offset = Address - ( Address % 0x800000 );
			FileStream.seekg(CurrentPage.offset, std::ios::beg);
			if( PagesAltered[CurrentPage.offset / 0x800000] )
			{
				wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
				FILE* floop = fopen(temp, "rb");
				fread(File, sizeof(unsigned char), 0x800000, floop);
				fclose(floop);
			}
			else
				FileStream.read((LPSTR)File, 0x800000);
		}
		return File[Address % 0x800000];
	}
	else
		return File[Address];
}

inline bool SetUnicodeFileByte(int Address, unsigned short value)
{
	if(IsPagingOn)
	{
		UnicodeFile[Address % 0x400000] = value;
		PagesAltered[CurrentPage.offset / 0x800000] = 1;
	}
	else
		UnicodeFile[Address] = value;
	return true;
}

// this is my goal for january 2, 2002
inline bool SetFileByte(int Address, unsigned char value)
{
	if(IsPagingOn)
	{
		File[Address % 0x800000] = value;
		PagesAltered[CurrentPage.offset / 0x800000] = 1;
	}
	else
		File[Address] = value;
	return true;
}

inline bool IncrementFileByte(int Address, unsigned char value)
{
	if(IsPagingOn)
	{
		File[Address % 0x800000] += value;
		PagesAltered[CurrentPage.offset / 0x800000] = 1;
	}
	else
		File[Address] += value;
	return true;
}

inline DWORD SMCToLoROM(DWORD dwSMC)
{
	dwSMC -= HeaderSize;
	return ((dwSMC & 0x7F8000) << 1) | (dwSMC & 0x7FFF) | 0x8000;
}

inline DWORD LoROMToSMC(DWORD dwLoROM)
{
	return (((dwLoROM & 0xFF0000) >> 1) | (dwLoROM & 0x7FFF)) + HeaderSize;
}

inline DWORD SMCToHiROM(DWORD dwSMC)
{
	return dwSMC - HeaderSize + 0xC00000;
}

inline DWORD HiROMToSMC(DWORD dwHiROM)
{
	return dwHiROM - 0xC00000 + HeaderSize;
}

inline WORD NEStoOffset(DWORD dwNES, DWORD PageSize, DWORD StartingOffset)
{
	return (WORD)(dwNES % PageSize + StartingOffset);
}

void DoInsertConversion(TCHAR* Convert)
{
	int length = _tcslen(Convert);
	for(int a = 0; a < length; a++)
	{
		// if we have the two values we want then we'll replace them with the value
		// for a newline from a table
		if( ( Convert[a] == 0x0d ) 
		  || ( Convert[a + 1] == 0x0a ) )
		{
			Convert[a] = '*';
			for( int s = a + 1; s < length; s++)
			{
				Convert[s] = Convert[s + 1];
			}
			Convert[--length] = 0x00; // we'll make the string one short than
										// it was before
		}
	}
}

void ProcessText(char* Converted) {
	int counter = 0;
	isValue[0] = isValue[1] = isValue[2] = isValue[3] = isValue[4] = 0;
	for(unsigned int s = 0;  s < strlen(Converted); s++)
	{
		if(Converted[s] == '\\' && Converted[s + 1] == '*')
		{
			isValue[counter] = true;
			counter++;
			for(unsigned int c = s; c < strlen(Converted); c++)
			{
				Converted[c] = Converted[c + 1];
			}
			s++;
		}
		else if(Converted[s] == '*')
		{
			isValue[counter] = false;
			counter++;
		}
	}
}

char* ConvertHexToString(char* Converted) {
	char bloop;
	int length = 0, numWildCards = 0;
	asteriskCounter = 0;
	for(unsigned int s = 0; s < strlen(Converted); s++)
	{
		if(Converted[s] == '*')
		{
			numWildCards++;
		}
	}
	for(unsigned int w = 0; w < strlen(Converted); w++)
	{
		for(unsigned int q = 0; q < strlen(Converted); q++)
		{
			if(Converted[q] == 0x20)
			{
				bloop = Converted[q];
				Converted[q] = Converted[q + 1];
				Converted[q+1] = bloop;
			}
		}
	}
	for(unsigned int f = 0; f < strlen(Converted); f++)
	{
		if(Converted[f] == 0x20)
			Converted[f] = 0;
	}
	if( ( strlen(Converted) - numWildCards ) % 2)
		return NULL;
	int foo = strlen(Converted),a,b;
	char* konnichiwa = new char[foo];
	for(a = 0, b = 0; a < foo; a += 2, b++)
	{	
		if(Converted[a] == '*')
		{
			konnichiwa[b] = '*';
			a--;
			isValue[asteriskCounter++] = false;
		}
		else
		{
			konnichiwa[b] = ReturnHex((unsigned char*)Converted, a);
			if(konnichiwa[b] == '*')
				isValue[asteriskCounter++] = true;
		}
	}
	konnichiwa[b] = 0;
	return konnichiwa;
}

inline unsigned char ReturnHex(unsigned char * temp, int firstNum)
{
	unsigned char temp_val;
	unsigned char high_temp;
	unsigned char low_temp;
	if(temp[firstNum] >= 'a' && temp[firstNum] <= 'f')
	{ high_temp = hex_upper(temp[firstNum], 0x57); }
	else if(temp[firstNum] >= '0' && temp[firstNum] <= '9')
	{ high_temp = hex_upper(temp[firstNum], 0x30); }
	else if(temp[firstNum] >= 'A' && temp[firstNum] <= 'F')
	{ high_temp = hex_upper(temp[firstNum], 0x37); }
	if(temp[firstNum + 1] >= 'a' && temp[firstNum + 1] <= 'f')
	{ low_temp = hex_lower(temp[firstNum + 1], 0x57); }
	else if(temp[firstNum + 1] >= '0' && temp[firstNum + 1] <= '9')
	{ low_temp = hex_lower(temp[firstNum + 1], 0x30); }
	else if(temp[firstNum + 1] >= 'A' && temp[firstNum + 1] <= 'F')
	{ low_temp = hex_lower(temp[firstNum + 1], 0x37); }
	temp_val = high_temp + low_temp;
	return temp_val;
}

inline int hex_lower(unsigned int value, unsigned int convert_sub)
{
	return((value - convert_sub));
}

inline int hex_upper(unsigned int value, unsigned int convert_sub)
{
	return((value - convert_sub) << 4);
}

inline wchar_t MakeUnicodeBigEndian(wchar_t Swappee)
{
	return ( ( Swappee & 0xFF ) << 8 ) + ( Swappee >> 8 );
}

inline int FindPosition(int xMouse)
{
	
	int a = 0;
	for(a = 0; a < 31; a++)
	{
		// this is the old way of doing things, it immediately moves to the next character
		// after a complete covering of it by the mouse
		if( ( xMouse >= Positions[yMouse][a] ) && ( xMouse < Positions[yMouse][a + 1] ) )
		{
			if( Positions[yMouse][a] == Positions[yMouse][a - 1] )
				return a - 1;
			else return a;
		}
	}
	if( ( a == 31 ) && ( Positions[yMouse][30] == Positions[yMouse][31] ) )
		return 30;
	return a;
}

// this needs to be altered to handle large files and paging
int memcpyW(unsigned char* dest, wchar_t* wide_string, int size)
{
	unsigned char* Tempe = new unsigned char[size * 2 + 1];
	int Joe = 0;
	for(int a = 0; a < size; a++)
	{
		Tempe[Joe] = (char)(wide_string[a] & 0xFF);
		Joe++;
		Tempe[Joe] = (char)(wide_string[a] >> 8);
		Joe++;
	}
	memcpy(dest, Tempe, Joe);
	if(a == size)
	{
		delete[] Tempe;
		return 1;
	}
	else 
	{
		delete[] Tempe;
		return 0;
	}
}

int SafeMemCopy(unsigned char* dest, int offset, char* source, int size)
{
	if(IsPagingOn)
	{
		for( int a = 0; a < size; a++ )
		{
			SetFileByte(offset + a, source[a]);
		}
	}
	else
	{
		memcpy(dest + offset, source, size);
	}
	return 1;
}

int SafeMemCopyW(unsigned char* dest, int offset, wchar_t* source, int size)
{
	if(IsPagingOn)
	{
		for( int a = 0; a < size; a++ )
		{
			SetUnicodeFileByte(offset + a, source[a]);
		}
	}
	else
	{
		memcpyW(dest, source, size);
	}
	return 1;
}