/*
 * Hexecute 3.0
 * DataWinProc.cpp
 * copyright 2000 Mike Walston
 *
 * This is the file that holds WinProc for the frame window
 */

#include <windows.h>
#include <winuser.h>
#include <commctrl.h>
#include <stdio.h>
#include <wchar.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"
#pragma warning( disable : 4018 )
/*
 * This is the original Position
 * struct, but it isn't flexible
 * enough for what I needed to do
 * so I decided to replace it with
 * a dynamically allocated double
 * array that was based on how many
 * rows were visible on the screen
 * at a time
 *
 * int Positions[32] = {  10,12,15,17,
 *					   20,22,25,27,
 *					   30,32,35,37,
 *					   40,42,45,47,
 *					   50,51,52,53,
 *					   54,55,56,57,
 *					   58,59,60,61,
 *					   62,63,64,65};
 */

int PositionInit[8][32] = { 
						// byte output
					{  10,13,16,19,22,25,28,31,34,37,40,43,46,49,52,55,
					   58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73 } ,
						// word output
					{  10,12,15,17,20,22,25,27,30,32,35,37,40,42,45,47,
					   50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65 } ,
					   // 3 byte output
					{  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
					   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
						// int output
					{  10,12,14,16,19,21,23,25,28,30,32,34,37,39,41,43,
					   46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61 } ,
					   // 5 byte output
					{  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
					   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
					   // 6 byte output
					{  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
					   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
					   // 7 byte output
					{  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
					   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
					   // 8 byte output
					{  10,12,14,16,18,20,22,24,
					   27,29,31,33,35,37,39,41,
					   44,45,46,47,48,49,50,51,
					   52,53,54,55,56,57,58,59 }
				};

int CurrentPosition = 0, RealPosition = 0, HorizontalOffset = 0;
int HighlightOn = NO; // a light grey 

char f00 = 0x00;

int MaxRows(HWND hWnd)
{
	RECT rect;
	GetClientRect(hWnd, &rect);
	return ( rect.bottom / cyChar) - 1;
}

LRESULT CALLBACK DataWinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HBITMAP hbmMem, hbmOld;
	char path[MAX_PATH];
	RECT rect;
	int a;
	FILE *kanji;
    HWND hWndParent;
	HDROP hDrop;
	char slinky = 0, slinky2 = 0;
	short wslinky = 0;
	char szDrive[MAX_PATH], szDir[MAX_PATH], szName[MAX_PATH], szExt[MAX_PATH];
	static int PositionsAllocated = 0, OutputWidth, HexWidth, PizzaHut = 0;
	HDC hDC, hMemDC;
	HBRUSH hbrBkGnd;
	//RECT DrawBox;
	int result;
	historyevent heEvent;
	std::fstream floop;
	// this struct right here and the code I'll add to the drawing routing
	// is what will allow me to have direct input in all languages and with table
	// files active instead of having to use that dialog box, ph33r
	SIZE Size; // this
	PAINTSTRUCT ps;
    //BITMAP hBitmap, hOldBitmap;
	HMENU Popup;
	static int currentPage, tempCalc = 16, Position = 0, xMouse, f00b4r;
	int hehe, fwKeys, blah, wasabi, nihon,OutputWidthTemp, cyTemp1, cyTemp2, extra;
	int Endposition = 0;
	wchar_t blankness[50] = { 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000 };
	bool alreadyScrolled = false;
	TCHAR temp[500], temp2[500];

	switch(message) {
		
		case WM_CREATE:

			// end kamaitachi hack stuff for this section
			HorizontalOffset = 0;
			// allow hexecute to have files dropped in to it
			DragAcceptFiles(hWnd, TRUE);

			hDC = GetDC(hWnd); // gets the device context for hwnd so it can be used

			OutputWidth = 0;


			// this is the character output font
			ZeroMemory(&Font, sizeof(LOGFONT));
            Font.lfQuality = DRAFT_QUALITY;
			Font.lfCharSet = DEFAULT_CHARSET;
			_tcscpy(Font.lfFaceName, FontName); // sets the font face to Courier
            Font.lfHeight = FontHeight;		// the height of the desired font is 12
            Font.lfWidth = 0;                          // use the default width
            Font.lfWeight = FW_NORMAL;						 // use normal thickness
            Font.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
            hFont = CreateFontIndirect(&Font);	// create the logical font
			ZeroMemory(&Font, sizeof(LOGFONT));

			// this is the Unicode font
			ZeroMemory(&UnicodeFont, sizeof(LOGFONTW));
			UnicodeFont.lfQuality = DRAFT_QUALITY;
			UnicodeFont.lfCharSet = UNICODE_CHARSET;
			MultiByteToWideChar(1252, MB_PRECOMPOSED, UnicodeFontName, -1, UnicodeFont.lfFaceName, 32);
			UnicodeFont.lfHeight = FontHeight;		// the height of the desired font is 12
			UnicodeFont.lfWidth = 0;                          // use the default width
			UnicodeFont.lfWeight = FW_NORMAL;						 // use normal thickness
			hFontUnicode = CreateFontIndirectW(&UnicodeFont);	// create the logical font         

			// creating the font for the output of hte hex
			Font.lfQuality = DRAFT_QUALITY;
			Font.lfCharSet = DEFAULT_CHARSET;
			_tcscpy(Font.lfFaceName, HexFontName); // sets the font face to Courier
            Font.lfHeight = FontHeight;		// the height of the desired font is 12
            Font.lfWidth = 0;                          // use the default width
            Font.lfWeight = FW_NORMAL;						 // use normal thickness
            Font.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
            hFontHex = CreateFontIndirect(&Font);	// create the logical font
			
			// here we get the character font so that we can compare the hex
			// and the character to get cyChar
			if(CurrentTable == -1)
			{
				if(UnicodeOutput)
					SelectObject(hDC, hFontUnicode);
				else if(CleanUp)
					SelectObject(hDC, hFont);
				else 
					SelectObject(hDC, CPages[CurrentCodePage].font);
			}		
			else 
				SelectObject(hDC, tblFont[CurrentTable]);
			GetTextMetrics(hDC, &tm);
			cyTemp1 = tm.tmHeight + tm.tmExternalLeading;

			// here we get the hex font
			SelectObject(hDC, hFontHex); 
            GetTextMetrics(hDC, &tm);  // gets the data of the new font
            cxChar = tm.tmMaxCharWidth;  // cxChar is the width of the font letters
            cyTemp2 = tm.tmHeight + tm.tmExternalLeading;
			
			cyChar = ( cyTemp1 > cyTemp2 ? cyTemp1 : cyTemp2 ); // this is the height of the font
            ReleaseDC(hWnd, hDC); // release the device context
			
			HexWidth = 50 * cxChar;
			HexOrDec = HEX;
			HighlightOn = false;

		case WM_DISPLAYCHANGE:

			// make the scrollbar not appear yet, because it isn't
			// needed unless we do odd things with the children later
			// Set the scrollbar to good settings
			GetClientRect(hWnd, &rect);
			width = rect.right;
			height = rect.bottom;
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
      		si.nMin   = 0;
			if(!FileOpen)
				si.nMax = 0;
			else
				si.nMax	= MaxAddress / tempCalc;
			si.nPage  = height / cyChar;
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
			
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
			si.nMax = 1;
			si.nMin = 1;
			si.nPage = 1;
			currentPage = 1;
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);
			HorizontalOffset = 0;
			
			// fall through to WM_SIZE
		
		case WM_SIZE:
			GetClientRect(hWnd, &rect);
			width = rect.right;
			height = rect.bottom;

            // this is the code to be used for variable length lines
			tempCalc = width;
			tempCalc -= cxChar * 10;
			tempCalc /= cxChar;
			tempCalc /= 7;
			tempCalc *= 2;
			if(tempCalc < 4)
				tempCalc = 4;

			// down here will go code for set width lines
			tempCalc = 16;

			// Set the scrollbar to good settings
       		si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
      		si.nMin   = 0;
			if(!FileOpen)
				si.nMax = 0;
			else
			{
				si.nMax	= MaxAddress / tempCalc;
				if(!(MaxAddress % tempCalc))
					si.nMax--;
			}
			si.nPage  = height / cyChar;
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);

			si.fMask = SIF_ALL;
			si.cbSize = sizeof(SCROLLINFO);
			GetScrollInfo(hWnd, SB_HORZ, &si);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
			si.nMax = OutputWidth / cxChar;
			si.nMin = 0;
			si.nPage = width / cxChar;
			if(si.nPos > si.nMax)
				si.nPos = si.nMax;
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);
			if(OutputWidth < width)
				HorizontalOffset = 0;

			hDC = GetDC(hWnd); // gets the device context for hwnd so it can be used
			// here we get the character font so that we can compare the hex
			// and the character to get cyChar
			if(CurrentTable == -1)
			{
				if(UnicodeOutput)
					SelectObject(hDC, hFontUnicode);
				else if(CleanUp)
					SelectObject(hDC, hFont);
				else 
					SelectObject(hDC, CPages[CurrentCodePage].font);
			}		
			else 
				SelectObject(hDC, tblFont[CurrentTable]);
			GetTextMetrics(hDC, &tm);
			cyTemp1 = tm.tmHeight + tm.tmExternalLeading;

			// here we get the hex font
			SelectObject(hDC, hFontHex); 
            GetTextMetrics(hDC, &tm);  // gets the data of the new font
            cxChar = tm.tmMaxCharWidth;  // cxChar is the width of the font letters
            cyTemp2 = tm.tmHeight + tm.tmExternalLeading;
			
			cyChar = ( cyTemp1 > cyTemp2 ? cyTemp1 : cyTemp2 ); // this is the height of the font
            ReleaseDC(hWnd, hDC); // release the device context

			// here we set the info for what we need for the Positions array
			
			if(Positions != NULL)
			{
				delete[] Positions;
			}
			Positions = new int*[( rect.bottom / cyChar ) + 5];
			if(yMouse > ( rect.bottom / cyChar ))
				yMouse = rect.bottom / cyChar;
			for(wasabi = 0; wasabi < ( ( rect.bottom / cyChar ) + 1 ) ; wasabi++)
			{
				Positions[wasabi] = new int[32];
			}
			InvalidateRect(hWndData, NULL, TRUE);
			return 0;

		case WM_DROPFILES:
			hDrop = (HDROP)wParam;
			DragQueryFile(hDrop, 0, path, _MAX_PATH);

			// open file
			if(FileOpen) 
			{
				if(!Saved)
				{
					result = MessageBox(hWnd, "Would you like to save your current work?\nPress cancel to return to current file.",
               			PROGRAM_NAME, MB_YESNOCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON1	);
					if(result == IDCANCEL)
						return 0;
					else if(result == IDYES)
					{
						if(IsPagingOn)
						{
							wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
							floop.open(temp, std::ios::out | std::ios::binary);
							floop.write((LPCSTR)File, 0x800000);
							floop.close();
							for(a = 0; a < NumPages; a++)
							{
								if(PagesAltered[a])
								{
									wsprintf(temp, "hxct%04x.tmp", a);
									floop.open(temp, std::ios::in | std::ios::binary);
									floop.read((LPSTR)File, 0x800000);
									floop.close();
									remove(temp);
									kanji = fopen(Filename, "r+b");
									fseek(kanji, a * 0x800000, SEEK_SET);
									if(a + 1 == NumPages)
										fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
									else
										fwrite(File, sizeof(unsigned char), 0x800000, kanji);
									fclose(kanji);
									FileStream.close();
									FileStream.open(Filename, std::ios::in | std::ios::binary);
								}
								PagesAltered[a] = 0;
							}
						}
						else
						{
							FileStream.open(Filename, std::ios::out | std::ios::binary);
							FileStream.write((LPCSTR)File, MaxAddress);
							FileStream.close();
						}	
						Saved = true;
					}
					GlobalFree(File);
				}
				if(!NewFile)
					SavedTitle(hWnd);
				else
				{
					wsprintf(temp, "%s %d.%d.%d - [ %s ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD, TitleName);
					if(UnicodeOutput)
						strcat(temp, "Unicode");
					else if (CleanUp)
						strcat(temp, "Unicode");
					else 
					{
						strcat(temp, CPages[CurrentCodePage].name);
					}
					SetWindowText(hWnd, temp);
					NewFile = NO;
				}
			}
			_splitpath(path, szDrive, szDir, szName, szExt);
			strcat(szName, szExt);
			switch(OpenFile(GetParent(hWnd), path, szName)) {
				case MEM_ERROR:
					wsprintf(temp, "Unable to allocate %d bytes RAM for %s", MaxAddress, TitleName);
					MessageBox(hWnd, temp, PROGRAM_NAME, MB_OK);
					break;

				case FILE_NOT_FOUND:
					MessageBox(hWnd, TEXT("File not found"), PROGRAM_NAME, MB_OK); // debugging
					break;

				case FILE_OPENED:
					SendMessage(hWndData, HX_OPENFILE, WPARAM(NULL), LPARAM(NULL));
					break;

				case FILE_CANCELLED:
					break;
			}
			// force data area redraw
			InvalidateRect(hWndData, NULL, FALSE);
			SendMessage(hWndData, WM_SIZE, (WPARAM)NULL, LPARAM(NULL));
			return 0;

		case HX_OPENFILE: // special mesage adjusting the scrollbar info
			GetScrollInfo(hWnd, SB_VERT, &si);
			GetClientRect(hWnd, &rect);
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
			si.nMin = 0;
            si.nMax	= MaxAddress / tempCalc;
			si.nPage  = rect.bottom / cyChar;
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
			return 0;

		case HX_CHAR: // this is where I have passed the info from the main window to the data window
			if(!FileOpen) return 0;
			// these are the keys that do the same thing no matter what
			switch(wParam) {
				case '\t':
						
					nihon = GetKeyState(VK_SHIFT);
					if( nihon & 0x8000 )
					{

						CurrentTable--;
						if(!TotalTables)
						{
							CurrentTable = -1;
							InsideSubtable = false;
						}
						if(CurrentTable == -1)
						{
							if(CleanUp)
							{
								wsprintf(temp2, "%s %d.%d.%d - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD);
								wsprintf(temp, "[ %s ] - ASCII", TitleName);
								strcat(temp2, temp);
							}
							else
							{
								wsprintf(temp2, "%s %d.%d.%d - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD);
								wsprintf(temp, "[ %s ] - %s", TitleName, CPages[CurrentCodePage].name);
								strcat(temp2, temp);
							}
							EnableMenuItem(HexecuteMenu, ID_SPECIAL_DUMPTEXT, MF_GRAYED);
							EnableMenuItem(HexecuteMenu, ID_SPECIAL_INSERTTEXT, MF_GRAYED);
						}
						else
						{
							if(CurrentTable == -2)
								CurrentTable = TotalTables - 1;
							wsprintf(temp2, "%s %d.%d.%d - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD);
							wsprintf(temp, "[ %s ] - %s", TitleName, Table[CurrentTable]->getName());
							strcat(temp2, temp);
							Table[CurrentTable]->SetSubTable(0);
							SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
							UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
							EnableMenuItem(HexecuteMenu, ID_SPECIAL_DUMPTEXT, MF_ENABLED);
							EnableMenuItem(HexecuteMenu, ID_SPECIAL_INSERTTEXT, MF_ENABLED);
						}
						hWndParent = GetParent(hWnd);
						SetWindowText(hWndParent, temp2);
						InvalidateRect(hWnd, NULL, FALSE);
					}
					else
					{
						if(CurrentPosition >= 16)
							CurrentPosition -= 16;
						else CurrentPosition += 16;
						RealPosition = CurrentPosition;
						SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
					}
					return 0;
/*
 * For the moment we won't have redoing stuff
 * enabled because I need to think things out
 * a little more in respect to how to make it
 * do the things that it should do, correctly
 *
				case 0x19: // ctrl-y a.k.a. Redo
					Redo(History.Next(), hWnd);
					return 0;

				case 0x1A: // this should be ctrl-z
					// and it is, so this is where we need to put our 
					// undo code
					if(History.pop(heEvent))
					{
						memcpy(File + heEvent.offset, heEvent.data, heEvent.size);						
						if(heEvent.offset < CurrentStartAddress || 
							( heEvent.offset - CurrentStartAddress ) / 16 > MaxRows(hWnd) )
						{
							si.cbSize = sizeof(SCROLLINFO);
							si.fMask = SIF_ALL;
							GetScrollInfo(hWndData, SB_VERT, &si);
							si.nPos = heEvent.offset / 16;
							SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
							InvalidateRect(hWndData, NULL, FALSE);
							yMouse = 0;
						}
						CurrentPosition = heEvent.offset % 16;
						RealPosition = CurrentPosition;
						SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, heEvent.offset);
						InvalidateRect(hWnd, NULL, TRUE);

					}
					return 0;
*/
				default:
					break;
			}
			
				// character input teehee
				if(CurrentPosition > 15){					
					switch(wParam) {
						case 0:		
						default:
							if(CurrentTable == -1)
							{
								if(UnicodeOutput)
								{
									wslinky = GetUnicodeFileByte( ( CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ) ) / 2 );
									if(BigEndian)
									{
										SetUnicodeFileByte(	( CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ) ) / 2, MakeUnicodeBigEndian(wParam));
										temp[0] = wslinky >> 8;
										temp[1] = wslinky & 0xFF;
										temp[2] = 0;
									}
									else 
									{
										SetUnicodeFileByte(( CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ) ) / 2, wParam);
										temp[0] = wslinky & 0xFF;
										temp[1] = wslinky >> 8;
										temp[2] = 0;
									}
									// here we instantiate a new event, and we 
									// put it into the stack
									heEvent.size = 2;
									heEvent.data = new char[3];
									memcpy(heEvent.data, temp, 3);
									heEvent.offset = ( CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ) ) / 2 ;
									History.push(heEvent);
								}
								else
								{
									slinky = GetFileByte(CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
									SetFileByte(CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ), wParam);
									temp[0] = slinky;
									temp[1] = 0;
									heEvent.size = 1;
									heEvent.data = new char[2];
									memcpy(heEvent.data, temp, 2);
									heEvent.offset = CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 );
									History.push(heEvent);
								}
								// here we put Real Position along with Currentposition
								if(CurrentPosition == 31){
									CurrentPosition = 16;
									if ( ( si.nPos != si.nMax ) &&
										 ( ( yMouse + 1 ) == ( height / cyChar) ) )
											SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);
									else yMouse++;
								}
								else CurrentPosition++;		
								if(UnicodeOutput)
									CurrentPosition++;									
						}
						// this part is going to be a pain in the butt as it is table based
						// direct input, sort of the holy grail of romhacking text editors
						else // if(CurrentPosition == -1)
						{
							if(wParam == 0x08)
								;
							else
							{
								f00 = wParam;
								DialogBox(hInst, MAKEINTRESOURCE(IDD_TABLE_INSERT_POPUP), hWnd, TableBasedDirectInputProc);
							}
						} 
						RealPosition = CurrentPosition;
						SetCaretPos( ( Positions[yMouse][CurrentPosition] ) - ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
						if(Saved)
						{
							UnsavedTitle(GetParent(hWnd));
							Saved = false;
						}
						break;
				}
			}
			// here is hex input
			else
			{
				switch(wParam) {
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':	
					case '9':
						wParam -= 48;
							slinky = GetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(RealPosition == CurrentPosition)
							{
								// history stuff
								heEvent.data = new char;
								heEvent.data[0] = slinky;
								heEvent.size = 1;
								heEvent.offset = CurrentStartAddress + (yMouse * 16) + CurrentPosition;
								History.push(heEvent);

								// need to do a conversion on these values then use it
								SetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition, wParam << 4 );
								IncrementFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,( slinky & 0x0F ));
								SetCaretPos( ( Positions[yMouse][CurrentPosition] + 1 )/* * cxChar */- ( HorizontalOffset * cxChar), yMouse * cyChar);
								UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition + 1;
							}
							else
							{
								// history stuff
								heEvent.data = new char;
								heEvent.data[0] = slinky;
								heEvent.size = 1;
								heEvent.offset = CurrentStartAddress + (yMouse * 16) + CurrentPosition;
								History.push(heEvent);

								// need to do a conversion on these values then use it
								SetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,wParam);
								IncrementFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,( slinky & 0xF0 ));
								// here we put Real Position along with Currentposition
								if(CurrentPosition == 15){
									CurrentPosition = 0;
									if ( ( si.nPos != si.nMax ) &&
										 ( ( yMouse + 1 ) == ( height / cyChar) ) )
											SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);
									else yMouse++;
								}
								else CurrentPosition++;
								RealPosition = CurrentPosition;
								SetCaretPos( ( Positions[yMouse][CurrentPosition] )/* * cxChar */- ( HorizontalOffset * cxChar), yMouse * cyChar);
								UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));								
							}
							if(Saved)
							{
								UnsavedTitle(GetParent(hWnd));
								Saved = false;
							}
							break;

						case 'A':
						case 'B':
						case 'C':
						case 'D':
						case 'E':
						case 'F':
							wParam -= 55;
							slinky = GetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition);

							// history stuff
							heEvent.data = new char;
							heEvent.data[0] = slinky;
							heEvent.size = 1;
							heEvent.offset = CurrentStartAddress + (yMouse * 16) + CurrentPosition;
							History.push(heEvent);

							if(RealPosition == CurrentPosition)
							{
								// need to do a conversion on these values then use it
								SetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,wParam << 4);
								IncrementFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,( slinky & 0x0F ));
								SetCaretPos( ( Positions[yMouse][CurrentPosition] + 1 )/* * cxChar */- ( HorizontalOffset * cxChar), yMouse * cyChar);
								UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition + 1;
							}
							else
							{
								// need to do a conversion on these values then use it
								SetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,wParam);
								IncrementFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,( slinky & 0xF0 ));							
								// here we put Real Position along with Currentposition
								if(CurrentPosition == 15){
									CurrentPosition = 0;
									if ( ( si.nPos != si.nMax ) &&
										 ( ( yMouse + 1 ) == ( height / cyChar) ) )
											SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);
									else yMouse++;
								}
								else CurrentPosition++;
								RealPosition = CurrentPosition;
								SetCaretPos( ( Positions[yMouse][CurrentPosition] )/* * cxChar */- ( HorizontalOffset * cxChar), yMouse * cyChar);
								UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
							}
							if(Saved)
							{
								UnsavedTitle(GetParent(hWnd));
								Saved = false;
							}
							break;

						case 'a':
						case 'b':
						case 'c':
						case 'd':
						case 'e':
						case 'f':
							wParam -= 87;
							slinky = GetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition);
								
							// history stuff
							heEvent.data = new char;
							heEvent.data[0] = slinky;
							heEvent.size = 1;
							heEvent.offset = CurrentStartAddress + (yMouse * 16) + CurrentPosition;
							History.push(heEvent);

							if(RealPosition == CurrentPosition)
							{
								// need to do a conversion on these values then use it
								SetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,wParam << 4);
								IncrementFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,( slinky & 0x0F ));
								SetCaretPos( ( Positions[yMouse][CurrentPosition] + 1 )/* * cxChar*/ - ( HorizontalOffset * cxChar), yMouse * cyChar);
								UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition + 1;
							}
							else
							{
								//wsprintf(temp, "CurrentPosition = %d", CurrentPosition);
								//MessageBox(hWnd, temp, PROGRAM_NAME, MB_OK);
								// need to do a conversion on these values then use it
								SetFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,wParam);
								IncrementFileByte(CurrentStartAddress + (yMouse * 16) + CurrentPosition,( slinky & 0xF0 ));
								// here we put Real Position along with Currentposition
								if(CurrentPosition == 15){
									CurrentPosition = 0;
									if ( ( si.nPos != si.nMax ) &&
										 ( ( yMouse + 1 ) == ( height / cyChar) ) )
											SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);
									else yMouse++;
								}
								else CurrentPosition++;
								RealPosition = CurrentPosition;
								SetCaretPos( ( Positions[yMouse][CurrentPosition] )/* * cxChar */- ( HorizontalOffset * cxChar), yMouse * cyChar);
								UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
							}
							if(Saved)
							{
								UnsavedTitle(GetParent(hWnd));
								Saved = false;
							}
							break;
						
						default:
							RealPosition = CurrentPosition;
							break;
					}
			}
			HighlightOn = NO;
			InvalidateRect(hWnd, NULL, FALSE);
			return 0;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {		
				case ID_POPUP_BANKOFFSET:
					//this works now
					ViewAsHiRom = NO;
					ViewAsLoRom = NO;
					ViewAsNES	= YES;
					rect.left = 0;
					rect.right = 10 * cxChar;
					rect.top = 0;
					rect.bottom = height;
					InvalidateRect(hWnd, &rect, FALSE);
					return 0;
				
				case ID_POPUP_HIROM:
					ViewAsHiRom = YES;
					ViewAsLoRom = NO;
					ViewAsNES	= NO;
					rect.left = 0;
					rect.right = 10 * cxChar;
					rect.top = 0;
					rect.bottom = height;
					InvalidateRect(hWnd, &rect, FALSE);
					return 0;

				case ID_POPUP_LOROM:
					ViewAsHiRom = NO;
					ViewAsLoRom = YES;
					ViewAsNES	= NO;
					rect.left = 0;
					rect.right = 10 * cxChar;
					rect.top = 0;
					rect.bottom = height;
					InvalidateRect(hWnd, &rect, FALSE);
					return 0;

				case ID_POPUP_HEXDECIMAL:
					HexOrDec = HEX;
					ViewAsHiRom = NO;
					ViewAsLoRom = NO;
					ViewAsNES   = NO;
					rect.left = 0;
					rect.right = 10 * cxChar;
					rect.top = 0;
					rect.bottom = height;
					InvalidateRect(hWnd, &rect, FALSE);
					return 0;

				case ID_POPUP_DECIMAL:					
					HexOrDec = DEC;
					ViewAsHiRom = NO;
					ViewAsLoRom = NO;
					ViewAsNES   = NO;
					rect.left = 0;
					rect.right = 10 * cxChar;
					rect.top = 0;
					rect.bottom = height;
					InvalidateRect(hWnd, &rect, FALSE);
					return 0;
			}

			return 0;

		case HX_KEYDOWN:
			if(!FileOpen) return 0;
			nihon = GetKeyState(VK_SHIFT);
			wasabi = HighlightOn;
			extra = 0;
			switch(wParam) {

				case VK_INSERT:
					if(OverWrite && (!IsPagingOn))
					{
						SendMessage (StatusBar, SB_SETTEXT, 4, (LPARAM)"INS");
						OverWrite = false;
						EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_ENABLED);

					}
					else 
					{
						SendMessage(StatusBar, SB_SETTEXT, 4, (LPARAM)"OVR");					
						OverWrite = true;
						EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_GRAYED);
					}
					break;

				case VK_UP:
						GetScrollInfo(hWnd, SB_VERT, &si);
						if( ( yMouse || si.nPos ) && ( nihon < 0 ) )
						{
							endHighlight -= tempCalc;
							HighlightOn = YES;
						}
						else if ( yMouse || si.nPos )
						{
							startHighlight = CurrentStartAddress + ( ( yMouse - 1 ) * tempCalc ) + ( CurrentPosition % tempCalc );
							endHighlight = startHighlight;
							HighlightOn = NO;
							CutAndCopyDisableMenu();
						}
						if( ( ! yMouse ) && ( CurrentStartAddress >= tempCalc ) )
						{
							SendMessage(hWnd, WM_VSCROLL, SB_LINEUP, 0);
						}
						else if( ! ( ( ! si.nPos ) && ( ! yMouse ) ) )
							yMouse--;
						RealPosition = CurrentPosition;
						if((!yMouse) && (!si.nPos))
							;
						else {
							// this is where history handling of up arrow goes
						}
						if(Positions[yMouse][CurrentPosition] == Positions[yMouse][CurrentPosition - 1])
						{
							CurrentPosition++;
							if(!HighlightOn)
								startHighlight++;
							endHighlight++;
							RealPosition = CurrentPosition;
						}
						break;

				case VK_DOWN:
						GetScrollInfo(hWnd, SB_VERT, &si);	
						if( ( endHighlight + 16 < MaxAddress ) && ( nihon < 0 ))
						{
							endHighlight += 16;
							HighlightOn = YES;
						}
						else if ( endHighlight + 16 < MaxAddress )
						{
							startHighlight = CurrentStartAddress + ( ( yMouse + 1 ) * tempCalc ) + ( CurrentPosition % tempCalc );
							endHighlight = startHighlight;
							HighlightOn = NO;

						}
						GetClientRect(hWnd, &rect);
						// this is when we're on the last row
						if( ( ( yMouse + 1 ) == ( rect.bottom / cyChar) ) &&
							( ( si.nPos + yMouse ) != si.nMax) ) 
						{
							// this is where history handling of down arrow goes									
							SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);					
						}
						// this is for all the other rows
						else if ( ( ( yMouse + 1 ) < ( rect.bottom / cyChar ) ) && 
							        (si.nPos != si.nMax) )
						{
							yMouse++;
							// this is where history handling of down arrow goes				
						}
						if( ( ( yMouse + 1 ) == ( rect.bottom / cyChar) ) && 
							        ( ( si.nPos + yMouse ) == si.nMax) )
						{
							if ( CurrentPosition > 15 ) blah = CurrentPosition - 16;
							else blah = CurrentPosition;
							f00 = (char)(MaxAddress % tempCalc);
							if(f00 == 0)
								f00 = 16;
							if ( blah >= f00 )
								yMouse--;
						}
						RealPosition = CurrentPosition;
						if(Positions[yMouse][CurrentPosition] == Positions[yMouse][CurrentPosition - 1])
						{
							CurrentPosition--;
							if(!HighlightOn)
								startHighlight--;
							endHighlight--;
							RealPosition = CurrentPosition;
						}
						if((CurrentPosition % 16) + CurrentStartAddress + (yMouse * 16) >= MaxAddress)
						{
							yMouse--;
							return 0;
						}
						break;

				case VK_LEFT:
						if(Positions[yMouse][CurrentPosition - 1] == Positions[yMouse][CurrentPosition - 2])
						{
							// here we're going to put our code for handling the highlighting of multiple
							// byte characters
							extra = 1;
							//wsprintf(temp, "CurrentPosition = %d", CurrentPosition);
							//MessageBox(hWnd, TEXT("We're moving left over a double byte character"), PROGRAM_NAME, MB_OK);
						}
						GetScrollInfo(hWnd, SB_VERT, &si);
						if( ( endHighlight - 1 != -1 ) && ( nihon < 0 ))
						{
							if(extra)
								endHighlight--;
							endHighlight--;
							HighlightOn = YES;
						}
						else if ( endHighlight - 1 != -1 )
						{
							if(extra) // dbcs
							{
								if( ( CurrentPosition != 1 ) && ( CurrentPosition != 17 ) )
									startHighlight = CurrentStartAddress + ( ( yMouse ) * tempCalc ) + ( ( CurrentPosition - 2 ) % tempCalc );
								else startHighlight = CurrentStartAddress + ( ( yMouse - 1 ) * tempCalc ); 
							}
							else // single byte characters
							{
								if(CurrentPosition && ( CurrentPosition != 16) )
									startHighlight = CurrentStartAddress + ( ( yMouse ) * tempCalc ) + ( ( CurrentPosition - 1 ) % tempCalc );
								else startHighlight = CurrentStartAddress + ( ( yMouse - 1 ) * tempCalc ); 
							}
							endHighlight = startHighlight;
							HighlightOn = NO;

						}
						if( CurrentPosition == 0 )
						{
							if( ( ! yMouse ) && (  CurrentStartAddress >= tempCalc ) )
							{
								SendMessage(hWnd, WM_VSCROLL, SB_LINEUP, 0);
								// all occurances of this at the moment are simply for testing
								//CalcPosition(Positions, ( MaxAddress / tempCalc ) + yMouse );
								CurrentPosition = 15;
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
							}
							else if( ! ( ( ! si.nPos ) && ( ! yMouse ) ) )
							{
								CurrentPosition = 15;
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
								yMouse--;
							}
						}
						else if (CurrentPosition == 16 )
						{
							if( ( ! yMouse ) && (  CurrentStartAddress >= tempCalc ) )
							{
								SendMessage(hWnd, WM_VSCROLL, SB_LINEUP, 0);
								// all occurances of this at the moment are simply for testing
								//CalcPosition(Positions, ( MaxAddress / tempCalc ) + yMouse );
								CurrentPosition = 31;
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
							}

							else if( ! ( ( ! si.nPos ) && ( ! yMouse ) ) )
							{
								if(extra) // DBCS
								{
									CurrentPosition = 30;
								}
								else // SBCS
								{
									CurrentPosition = 31;
								}
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
								yMouse--;
							}
						}
						else
						{
							if(extra)
								CurrentPosition--;
							CurrentPosition--;
							// here we put Real Position along with Currentposition
							RealPosition = CurrentPosition;
						}
						if( ( !yMouse ) && ( !si.nPos ) && 
							( (CurrentPosition == 16 ) || ( CurrentPosition == 0 ) ) )
							;
						else {
							// this is where history handling of left arrow goes					
						}
						break;
				case VK_RIGHT:
						if((CurrentPosition % 16) + CurrentStartAddress + (yMouse * 16) + 1  >= MaxAddress)
						{
							return 0;
						}
						if(Positions[yMouse][CurrentPosition] == Positions[yMouse][CurrentPosition + 1])
						{
							// here we're going to put our code for handling the highlighting of multiple
							// byte characters
							extra = 1;
						}
						GetScrollInfo(hWnd, SB_VERT, &si);
						if( ( endHighlight + 1 < MaxAddress ) && ( nihon < 0 ))
						{
							if(extra) // we want to move over a character that takes two bytes
							{
								endHighlight++; // add an extra byte to the highlighting
							}
							endHighlight++;
							HighlightOn = YES;
						}
						else if ( endHighlight + 1 < MaxAddress )
						{
							if(extra)
							{
								if( ( CurrentPosition == 14 ) || ( CurrentPosition == 30 ) )
									startHighlight = CurrentStartAddress + ( ( yMouse + 1 ) * tempCalc );
								else startHighlight = CurrentStartAddress + ( ( yMouse) * tempCalc )  + ( ( CurrentPosition + 2 ) % tempCalc );
							}
							else // the single character movement
							{
								if( ( CurrentPosition == 15 ) || ( CurrentPosition == 31 ) )
									startHighlight = CurrentStartAddress + ( ( yMouse + 1 ) * tempCalc );
								else startHighlight = CurrentStartAddress + ( ( yMouse) * tempCalc )  + ( ( CurrentPosition + 1 ) % tempCalc );
							}
							endHighlight = startHighlight;
							HighlightOn = NO;
						}

						GetClientRect(hWnd, &rect);
						// this is the last row
						if	( 
								(
									( 
										yMouse + 1 
									) 
										== 
									( 
										rect.bottom / cyChar
									) 
								)
								&& 
								( 
									(
										( 
										si.nPos + yMouse 
										) 
										== 
										si.nMax
									)

								) 
							)
						{
							if( CurrentPosition > 15 ) blah = CurrentPosition - 16;
							else blah = CurrentPosition;
							f00 = (char)(MaxAddress % tempCalc);
							if(f00 == 0)
								f00 = tempCalc;
							if(extra) // moving over a 2 char value again
							{
								if( ( blah + 2 ) < f00 )
								{
									CurrentPosition +=2;
									// here we put Real Position along with Currentposition
									RealPosition = CurrentPosition;
									// this is where history handling of right arrow goes
								}
							}
							else // if we are just moving over a one character value
							{
								if( ( blah + 1 ) < f00 )
								{
									CurrentPosition++;
									// here we put Real Position along with Currentposition
									RealPosition = CurrentPosition;
									// this is where history handling of right arrow goes
								}
							}
							break;
						}
						else if( CurrentPosition == 15 )
						{
							if ( ( si.nPos != si.nMax ) &&
								 ( ( yMouse + 1 ) == ( rect.bottom / cyChar) ) )
							{
								SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);
								// all occurances of this at the moment are simply for testing
								CurrentPosition = 0;
								RealPosition = CurrentPosition;
								// this is where history handling of right arrow goes
							}
							else
							{
								CurrentPosition = 0;
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
								yMouse++;
								// this is where history handling of right arrow goes
							}
						}
						else if ( CurrentPosition == 31 || ( ( CurrentPosition == 30 ) && extra )  )
						{
							if ( ( si.nPos != si.nMax ) &&
								 ( ( yMouse + 1 ) == ( rect.bottom / cyChar) ) )
							{
								SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0);
								// all occurances of this at the moment are simply for testing
								//CalcPosition(Positions, ( MaxAddress / tempCalc ) + yMouse );
								CurrentPosition = 16;
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
								// this is where history handling of right arrow goes
							}
							else
							{
								CurrentPosition = 16;
								// here we put Real Position along with Currentposition
								RealPosition = CurrentPosition;
								yMouse++;
								// this is where history handling of right arrow goes
							}
						}
						else
						{
							if(extra)
								CurrentPosition++;
							CurrentPosition++;
							// here we put Real Position along with Currentposition
							RealPosition = CurrentPosition;
								// this is where history handling of right arrow goes

						}
						if((CurrentPosition % 16) + CurrentStartAddress + (yMouse * 16) >= MaxAddress)
						{
							CurrentPosition--;
							return 0;
						}
						break;
				
				// this is the case when a user wants to repeat their most recent search
				case VK_F3:
						if(Value) {
							wasabi = ValueSearch(searching, strlen(searching), CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(wasabi)
							{
								CurrentPosition = ( wasabi % 16 );
								RealPosition = CurrentPosition;
								if(CurrentTable == -1)
									CurrentPosition += 16;
								yMouse = 0;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								GetScrollInfo(hWndData, SB_VERT, &si);
								si.nPos = ( wasabi - ( wasabi % 16 ) ) / 16 ;
								SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
								InvalidateRect(hWndData, NULL, FALSE);
							}
						} else {
							wasabi = RelativeSearch(searching, strlen(searching), CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(wasabi)
							{
								CurrentPosition = ( wasabi % 16 );
								RealPosition = CurrentPosition;
								if(CurrentTable == -1)
									CurrentPosition += 16;
								yMouse = 0;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								GetScrollInfo(hWndData, SB_VERT, &si);
								si.nPos = ( wasabi - ( wasabi % 16 ) ) / 16 ;
								SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
								InvalidateRect(hWndData, NULL, FALSE);
							}
						}
						break;
				case VK_PRIOR:
						si.cbSize = sizeof(SCROLLINFO);
						si.fMask = SIF_ALL;
						GetScrollInfo(hWndData, SB_VERT, &si);
						si.nPos -= si.nPage;
						SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
						InvalidateRect(hWndData, NULL, FALSE);
						break;
				case VK_NEXT:
						si.cbSize = sizeof(SCROLLINFO);
						si.fMask = SIF_ALL;
						GetScrollInfo(hWndData, SB_VERT, &si);
						si.nPos += si.nPage;
						SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
						InvalidateRect(hWndData, NULL, FALSE);
						break;
				case VK_HOME:
						if( CurrentPosition >= 16 )
							CurrentPosition = 16;
						else
							CurrentPosition = 0;
						RealPosition = CurrentPosition;
						if( GetKeyState(VK_CONTROL) & 0x8000)
						{
							if(nihon < 0 )
							{
								endHighlight = 0;
								HighlightOn = YES;
								CutAndCopyEnableMenu();
							}
							else
							{
								startHighlight = 0;
								endHighlight = startHighlight;
								HighlightOn = NO;
								CutAndCopyDisableMenu();
							}
							yMouse = 0;
							si.cbSize = sizeof(SCROLLINFO);
							si.fMask = SIF_ALL;
							GetScrollInfo(hWndData, SB_VERT, &si);
							si.nPos = si.nMin;
							SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
							InvalidateRect(hWndData, NULL, FALSE);							;
						}
						else
						{
							if( nihon < 0 )
							{
								endHighlight = CurrentStartAddress + ( ( yMouse) * tempCalc ) + ( CurrentPosition % tempCalc );;
								HighlightOn = YES;
								CutAndCopyEnableMenu();
							}
							else
							{
								startHighlight = CurrentStartAddress + ( ( yMouse) * tempCalc ) + ( CurrentPosition % tempCalc );
								endHighlight = startHighlight;
								HighlightOn = NO;
								CutAndCopyDisableMenu();
							}
							InvalidateRect(hWndData, NULL, FALSE);	
						}
						SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
						InvalidateRect(hWndData, NULL, FALSE);
						alreadyScrolled = false;
						SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
						return 0;
				case VK_END:
						if( CurrentPosition < 16 )
							CurrentPosition = 15;
						else
							CurrentPosition = 31;
						RealPosition = CurrentPosition;
						if( GetKeyState(VK_CONTROL) & 0x8000)
						{
							if(nihon < 0 )
							{
								GetClientRect(hWnd, &rect);
								yMouse = rect.bottom / cyChar - 1;
								endHighlight = MaxAddress;
								HighlightOn = YES;
								CutAndCopyEnableMenu();
							}
							else
							{
								CurrentPosition = 0;
								RealPosition = CurrentPosition;
								yMouse = 0;
								startHighlight = MaxAddress;
								endHighlight = startHighlight;
								HighlightOn = NO;
								CutAndCopyDisableMenu();
							}
							si.cbSize = sizeof(SCROLLINFO);
							si.fMask = SIF_ALL;
							GetScrollInfo(hWndData, SB_VERT, &si);
							si.nPos = si.nMax;
							SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
							InvalidateRect(hWndData, NULL, FALSE);							;
						}
						else
						{
							if( nihon < 0 )
							{
								endHighlight = CurrentStartAddress + ( ( yMouse) * tempCalc ) + ( CurrentPosition % tempCalc );;
								HighlightOn = YES;
								CutAndCopyEnableMenu();
							}
							else
							{
								startHighlight = CurrentStartAddress + ( ( yMouse) * tempCalc ) + ( CurrentPosition % tempCalc );
								endHighlight = startHighlight;
								HighlightOn = NO;
								CutAndCopyDisableMenu();
							}
							InvalidateRect(hWndData, NULL, FALSE);	
						}
						break;

				case VK_CONTROL:
						break;
			}
			InvalidateRect(hWnd, NULL, FALSE);
			if(Positions != NULL)
			{
				if(CurrentPosition < 16 || CurrentTable == -1)
					if(RealPosition == CurrentPosition)
					{
						SetCaretPos( Positions[yMouse][CurrentPosition]- ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
					}
					else 
					{
						SetCaretPos( Positions[yMouse][CurrentPosition] + cxChar - ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
					}
				else 
				{
					SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
					UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
				}
			}
			return 0;

		case WM_HSCROLL:

            ZeroMemory(&si, sizeof(SCROLLINFO));
            si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_ALL;
			GetScrollInfo(hWnd, SB_HORZ, &si);
			switch(LOWORD(wParam)) {
				case SB_LEFT:
					si.nPos = si.nMin;
					si.fMask = SIF_POS;
					HorizontalOffset = si.nPos;
					break;
				case SB_RIGHT:
					si.nPos = si.nMax;
					HorizontalOffset = si.nPos;
					si.fMask = SIF_POS;
					break;
				case SB_LINELEFT:
					if(si.nPos == 0)
						break;
					si.nPos -= 1;
					HorizontalOffset--;
					si.fMask = SIF_POS;
					break;
				case SB_LINERIGHT:
					if( ( si.nPos + si.nPage ) == si.nMax)
						break;
					si.nPos += 1;
					HorizontalOffset++;
					si.fMask = SIF_POS;
					break;
				case SB_THUMBTRACK:
					si.nPos = si.nTrackPos;
					HorizontalOffset = si.nTrackPos;
					break;
			}
			
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);
			InvalidateRect(hWnd, NULL, FALSE);
			alreadyScrolled = false;
			SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
			UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
			return 0;

		case WM_VSCROLL:
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_ALL;
			GetScrollInfo(hWnd, SB_VERT, &si);

			switch(LOWORD(wParam)) {
				case SB_TOP:	// if moved all the way to the top
               		si.nPos = si.nMin;
					break;

				case SB_BOTTOM: // if moved all the way to the bottom
               		si.nPos = si.nMax;
					break;

				case SB_LINEUP: // if moved one line up
               		si.nPos -= 1;
					break;

				case SB_LINEDOWN: // if moved one line down
					si.nPos += 1;
					break;

				case SB_PAGEUP:  // if moved one page up
					si.nPos -= si.nPage;
					break;

				case SB_PAGEDOWN:  // if moved one page down
               		si.nPos += si.nPage;
					break;

				case SB_THUMBTRACK:  // if the thumbscroll is being used
					si.nPos = si.nTrackPos;
					break;

				default:
               		break;
			}
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
			InvalidateRect(hWnd, NULL, FALSE);
			alreadyScrolled = false;
			SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
			UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
			return 0;

		case WM_LBUTTONDOWN:
			/// if we don't have an open file then it really doesn't matter does it?
			if(!FileOpen) return 0;
			CutAndCopyDisableMenu();
			xMouse = LOWORD(lParam);
			yMouse = HIWORD(lParam);
			// if the click is inside the address area
			// and can simply be ignored
			// actually that's not true now, as I'll use those
			// clicks to place the caret at the first value on the row
			yMouse = ( ( yMouse - ( yMouse % cyChar ) ) / cyChar );
			if(CurrentStartAddress + (yMouse * 16) >= MaxAddress)
			{
				yMouse--;
			}
			if(xMouse < ( ( 9 * cxChar )  - ( HorizontalOffset * cxChar))) 
			{
				CurrentPosition = 0;
				startHighlight = CurrentStartAddress + (yMouse * tempCalc);
			}
			else
			{
				CurrentPosition = FindPosition(xMouse  + ( HorizontalOffset * cxChar) );
				startHighlight = CurrentStartAddress + (yMouse * tempCalc) + (CurrentPosition % tempCalc);
			}
			RealPosition = CurrentPosition;
			//if((CurrentPosition % 16) + CurrentStartAddress + (yMouse * 16) >= MaxAddress)
			//{
			//	yMouse--;
			//}
			SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);	
			UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
			if(HighlightOn) {
				HighlightOn = NO;
				InvalidateRect(hWnd, NULL, FALSE);
			}
			endHighlight = startHighlight;
			CutAndCopyDisableMenu();
			InvalidateRect(hWnd, NULL, FALSE);
			return 0;

		case WM_CONTEXTMENU:	// and here, Right Mouse Button Down
			if(FileOpen)
			{
				GetCursorPos(&CursorPoint);
				ScreenToClient(hWnd, &CursorPoint);

				if( CursorPoint.x < ( 9 * cxChar ) )
				{
					Popup = LoadMenu(hInst, TEXT("POPUPADDRESS"));
					Popup = GetSubMenu(Popup, 0);
					ClientToScreen(hWnd, &CursorPoint);
					TrackPopupMenu(Popup, TPM_LEFTALIGN | TPM_LEFTBUTTON, CursorPoint.x, CursorPoint.y, 0, hWnd, NULL);
					// ALL DELETEMENU CALLS ARE TEMPORARY
					DestroyMenu(Popup);
				}

			}
			return 0;

/*			
		case WM_MOUSEWHEEL:
			wsprintf(temp, "%d", HIWORD(wParam));
			MessageBox(hWnd, temp, PROGRAM_NAME, MB_OK);
			return 0;
*/			
		case WM_MOUSEMOVE:
			// here we handle mouse movement, but only when the
			// left mouse button is down, which means something is being
			// highlighted, it's quite a pain in the butt when it comes
			// to having to do highlighting of table file based text, as
			// you can't simply do coordinate based calculations to find
			// out what you need to highlight.
			
			// if we don't have an open file then it really doesn't matter does it?
			if(!FileOpen) return 0;				

			fwKeys = wParam;
			if( fwKeys & MK_LBUTTON ) // if the left button is being held down
			{
				HighlightOn = YES;
				xMouse = LOWORD(lParam);				
				yMouse = HIWORD(lParam);
				yMouse = ( ( yMouse - ( yMouse % cyChar ) ) / cyChar );
				if(CurrentStartAddress + (yMouse * 16) >= MaxAddress)
				{
					yMouse--;
				}
				if(xMouse < ( ( 9 * cxChar )  - ( HorizontalOffset * cxChar)) ) 
				{
					endHighlight = CurrentStartAddress + ( yMouse  * tempCalc);
					CurrentPosition = 0;
				}
				else
				{
					CurrentPosition = FindPosition(xMouse   + ( HorizontalOffset * cxChar) );
					endHighlight = CurrentStartAddress + (yMouse * tempCalc) + (CurrentPosition % tempCalc);
				}
				RealPosition = CurrentPosition;
				SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);	
				UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
				InvalidateRect(hWnd, NULL, FALSE);
				CutAndCopyEnableMenu();
			}
			return 0;

		case WM_ERASEBKGND: // now windows thinks we've handled it
			return 0;

		case WM_PAINT:
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_ALL;
			InsideSubtable = false;
			GetScrollInfo(hWnd, SB_VERT, &si);

			GetClientRect(hWnd, &rect);


			hDC = BeginPaint(hWnd, &ps);
			hMemDC = CreateCompatibleDC(hDC);
			hbmMem = CreateCompatibleBitmap(hDC,
                                    rect.right-rect.left,
                                    rect.bottom-rect.top);
			hbmOld = (HBITMAP)SelectObject(hMemDC, hbmMem);

			hbrBkGnd = CreateSolidBrush(0x00FFFFFF);
			FillRect(hMemDC, &rect, hbrBkGnd);
			DeleteObject(hbrBkGnd);

			OutputWidth = 0;
	
			SelectObject(hMemDC, hFontHex); 	// makes hdc use the new font

			hbrBkGnd = CreateSolidBrush(AddressBGColor);
			int crapdoggy = si.nPos * 16;

			if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
			{
				if(ViewAsHiRom)
					wsprintf(temp, "%08X ", SMCToHiROM(crapdoggy));
				else if( ViewAsLoRom) // if (ViewAsHiRom)
					wsprintf(temp, "%08X ", SMCToLoROM(crapdoggy));
				else if ( ViewAsNES ) // else if (ViewAsLoRom)
				{
					if( (crapdoggy / NESPageSize ) < 0xFFFF)
						wsprintf(temp, "%04X:", ( crapdoggy ) / NESPageSize);
					else
						wsprintf(temp, "0000:");
					wsprintf(temp2, "%04X", NEStoOffset(crapdoggy, NESPageSize, NESOffset));
					lstrcat(temp, temp2);
				}
			}
			else if(HexOrDec == HEX) // if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
				wsprintf(temp, "%08X ", crapdoggy);
			else // if(HexOrDec == HEX)
				wsprintf(temp, "%08i ", crapdoggy);
			GetTextExtentPoint32(hMemDC, temp, 9, &Size);
			rect.right = Size.cx;
			FillRect(hMemDC, &rect, hbrBkGnd);
			DeleteObject(hbrBkGnd);

			if(!FileOpen)
			{
				;
			}
			else
			{
				int a = si.nPos,
					b = a + rect.bottom / cyChar + 1, // make it print enough to fill the screen including one partial row
					c = 0,
					color = 0x00FF0000,
					specialCalc = 0,
					AxtempCalc = 0,
					CtimescyChar = 0,
					AxtempCalcplusD = 0,
					AxtempCalcplusQ = 0,
					CarryOver = 0;
				bool lastrow = false, lastodd = false;
				// calculate how much we can have on here
				// variable width lines
				tempCalc = rect.right;
				tempCalc -= cxChar * 10;
				tempCalc /= cxChar;
				tempCalc /= 7;
				tempCalc *= 2;
				if(tempCalc	< 4)
					tempCalc = 4;

				// set width lines
				tempCalc = 16;

				specialCalc = (MaxAddress % tempCalc);
				if(specialCalc == 0)
					specialCalc = 16;
				AxtempCalc = a * tempCalc;
				CurrentStartAddress = AxtempCalc;
				while(a < b)
				{
					AxtempCalc = a * tempCalc;
					CtimescyChar = c * cyChar;
					if(UnicodeOutput && (a < si.nMax))
					{
						DrawLineUnicode(hWnd, hMemDC, AxtempCalc, NESPageSize, NESOffset,
							CtimescyChar, HexWidth, specialCalc, tempCalc, OutputWidthTemp,
							hehe, CarryOver, c, Size, AxtempCalcplusQ);
						if(OutputWidthTemp > OutputWidth)
							OutputWidth = OutputWidthTemp;
						OutputWidthTemp = 0;
						SelectObject(hMemDC, hFontHex);
					}
					else if(UnicodeOutput && (a == si.nMax))
					{
						DrawLastLineUnicode(hWnd, hMemDC, AxtempCalc, NESPageSize, NESOffset,
							CtimescyChar, HexWidth, specialCalc, tempCalc, OutputWidthTemp,
							hehe, CarryOver, c, Size, AxtempCalcplusQ);
						if(OutputWidthTemp > OutputWidth)
							OutputWidth = OutputWidthTemp;
						OutputWidthTemp = 0;
						SelectObject(hMemDC, hFontHex);
					}
					else if(a == si.nMax )
					{
						DrawLastLine(hWnd, hMemDC, AxtempCalc, NESPageSize, NESOffset,
							CtimescyChar, HexWidth, specialCalc, tempCalc, OutputWidthTemp,
							hehe, CarryOver, c, Size, AxtempCalcplusQ);
						if(OutputWidthTemp > OutputWidth)
							OutputWidth = OutputWidthTemp;
						OutputWidthTemp = 0;
						SelectObject(hMemDC, hFontHex);
					}
					else if(a > si.nMax )
					{
						;
					}
					else
					{
						DrawLine(hWnd, hMemDC, AxtempCalc, NESPageSize, NESOffset,
							CtimescyChar, HexWidth, specialCalc, tempCalc, OutputWidthTemp,
							hehe, CarryOver, c, Size, AxtempCalcplusQ);

						SelectObject(hMemDC, hFontHex);
					}
				a++;
				c++;
				LeftOverChars[c] = CarryOver;
				if(OutputWidthTemp > OutputWidth)
					OutputWidth = OutputWidthTemp;
				OutputWidthTemp = 0;
			}
			if(CurrentPosition < 16 || CurrentTable == -1)
				if(RealPosition == CurrentPosition)
				{
					SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
					UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
				}
				else 
				{
					SetCaretPos( Positions[yMouse][CurrentPosition] + cxChar - ( HorizontalOffset * cxChar), yMouse * cyChar);
					UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
				}
			else 
			{
				SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
				UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
			}

			}
			si.fMask = SIF_ALL;
			si.cbSize = sizeof(SCROLLINFO);
			GetScrollInfo(hWnd, SB_HORZ, &si);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
			si.nMax = OutputWidth / cxChar;
			si.nMin = 0;
			si.nPage = width / cxChar;
			if(si.nPos > si.nMax)
				si.nPos = si.nMax;
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);
			if(OutputWidth < width)
				HorizontalOffset = 0;
			
			GetClientRect(hWnd, &rect);
			
			if(FileOpen)
			{
				// this section needs to be altered slightly because at the moment if you are on
				// the first byte of a 2 byte value (and probably 1 and 2 of a 3 and 1,2,3 of a 4
				// then the line doesn't get drawn
				PizzaHut = 0;
				if(CurrentPosition > 15 )
				{
					switch(GroupSize) {
						case 1:
							MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
							// here we do our compensating that underlines the entire multiple bytes of a multi byte char
							while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
								PizzaHut++;
							LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar) - cxChar, ( ( yMouse + 1 ) * cyChar) - 2);
							break;
						case 2:
							if( ! ( ( CurrentPosition + 1 ) % 2 ) )
							{
								MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
								// here we do our compensating that underlines the entire multiple bytes of a multi byte char
								while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
									PizzaHut++;
								LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
							}
							else
							{
								MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
								// here we do our compensating that underlines the entire multiple bytes of a multi byte char
								while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
									PizzaHut++;
								LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
							}
							break;
						case 4:
							if( ! ( ( CurrentPosition + 1 ) % 4 ) )
							{
								MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
								// here we do our compensating that underlines the entire multiple bytes of a multi byte char
								while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
									PizzaHut++;
								LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
							}
							else
							{
								MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
								// here we do our compensating that underlines the entire multiple bytes of a multi byte char
								while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
									PizzaHut++;
								LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
							}
							break;
						case 8:
							if( ! ( ( CurrentPosition + 1 ) % 8 ) )
							{
								MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
								// here we do our compensating that underlines the entire multiple bytes of a multi byte char
								while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
									PizzaHut++;
								LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
							}
							else
							{
								MoveToEx(hMemDC, Positions[yMouse][CurrentPosition - 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
								// here we do our compensating that underlines the entire multiple bytes of a multi byte char
								while(Positions[yMouse][CurrentPosition + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 1])
									PizzaHut++;
								LineTo(hMemDC, Positions[yMouse][CurrentPosition - 15 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
							}
							break;
					} // switch(GroupSize) 
				}
				else
				{
					MoveToEx(hMemDC, Positions[yMouse][CurrentPosition + 16] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2, NULL);
					// here we do our compensating that underlines the entire multiple bytes of a multi byte char
					while(Positions[yMouse][CurrentPosition + 16 + PizzaHut] == Positions[yMouse][CurrentPosition + PizzaHut + 17])
						PizzaHut++;
					LineTo(hMemDC, Positions[yMouse][CurrentPosition + 17 + PizzaHut] - ( HorizontalOffset * cxChar), ( ( yMouse + 1 ) * cyChar) - 2);
				}
			}

			BitBlt(hDC, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top,
					hMemDC, 0, 0, SRCCOPY);

			SelectObject(hMemDC, hbmOld);
			DeleteObject(hbmOld);
			DeleteObject(hbmMem);
			DeleteDC(hMemDC);

			EndPaint(hWnd, &ps);
			return 0;
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}


void UpdateStatusBar(HWND hWnd, int NewAddress)
{
	char temp[100], temp2[100];
	if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
	{
		if(ViewAsHiRom)
			wsprintf(temp, "Offset: %08X ", SMCToHiROM(NewAddress));
		else if( ViewAsLoRom) // if (ViewAsHiRom)
			wsprintf(temp, "Offset: %08X ", SMCToLoROM(NewAddress));
		else if ( ViewAsNES ) // else if (ViewAsLoRom)
		{
			if( (NewAddress / NESPageSize ) < 0xFFFF)
				wsprintf(temp, "Offset: %04X:", ( NewAddress ) / NESPageSize);
			else
				wsprintf(temp, "0000:");
			wsprintf(temp2, "%04X ", NEStoOffset(NewAddress, NESPageSize, NESOffset));
			lstrcat(temp, temp2);
		}
	}
	else if(HexOrDec == HEX) // if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
		wsprintf(temp, "Offset: %08X ", NewAddress);
	else // if(HexOrDec == HEX)
		wsprintf(temp, "Offset: %08i ", NewAddress);
//	wsprintf(temp, "Offset: %08x", NewAddress);
	SendMessage (hWnd, SB_SETTEXT, 3, (LPARAM)temp);
}