/*
 * Hexecute 3.0
 * DumpProc.cpp
 * copyright 2000 Mike Walston
 *
 * This is the file that holds WinProc for the script dumper
 * and the script dumper itself
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include <mbstring.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void Dump(char* filename, int ExtractionAddress, int Length, int clean) {	
	tableEntry* tempNode;
	int checkValue = 0, hehe = 0, herro = 0;
	char temp[100];
	std::ofstream dumpFileStream(filename);
	if(!clean)
	{
		wsprintf(temp, "<%08x>\r\n", ExtractionAddress);
		dumpFileStream.write(temp, strlen(temp));
	}
	if(TotalTables != 0)
	{
		if(Table[CurrentTable]->getCodepage() == 1252)
		{
			for(int a = ExtractionAddress; a < ExtractionAddress + Length; a++)
			{
				switch( Table[CurrentTable]->getWidestValue() ) {
					case 4:
						// check for 4 byte value
						checkValue += ( GetFileByte(a + hehe) << 24);
						hehe += 1;
						//otherwise we'll just fall through
					case 3:
						// check for 3 byte match
						checkValue += ( GetFileByte(a + hehe) << 16 );
						hehe += 1;
					case 2:
						// check for 2 byte match
						checkValue += ( GetFileByte(a + hehe) << 8 );
						hehe += 1;
					default:
						checkValue += GetFileByte(a + hehe);
						switch( Table[CurrentTable]->getWidestValue() ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						}
						a += hehe;
						herro = checkValue;
						checkValue = 0;
						hehe = 0;
				}
				if(!strcmp(tempNode->string, "HEXECUTE_NEWLINE"))
				{
					dumpFileStream.write("\r\n", 2);
				}
				else if (!strcmp(tempNode->string, "HEXECUTE_ENDSTRING"))
				{
					dumpFileStream.write("\r\n\r\n", 4);
					if(!clean)
					{
						wsprintf(temp, "<%08x>\r\n", a + 1);
						dumpFileStream.write(temp, strlen(temp));
					}
				}
				else 
				{
					if(tempNode == &emptyNode)
					{
						if(clean)
							dumpFileStream.write(tempNode->string, strlen(tempNode->string));
						else 
						{
							wsprintf(temp, "<%x>", herro);
							dumpFileStream.write(temp, strlen(temp));
						}
					}
					else
						dumpFileStream.write(tempNode->string, strlen(tempNode->string));
				}
			}
		}
		// far east table files
		else
		{
			for(int a = ExtractionAddress; a < ExtractionAddress + Length; a++)
			{
				switch( Table[CurrentTable]->getWidestValue() ) {
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(a + hehe) << 24);
						hehe += 1;
						//otherwise we'll just fall through
					case 3:
						// check for 3 byte match
						checkValue += ( GetFileByte(a + hehe) << 16 );
						hehe += 1;
					case 2:
						// check for 2 byte match
						checkValue += ( GetFileByte(a + hehe) << 8 );
						hehe += 1;
					default:
						checkValue += GetFileByte(a + hehe);
						switch( Table[CurrentTable]->getWidestValue() ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						}
						a += hehe;
						checkValue = 0;
						hehe = 0;
				}
				if(!_mbscmp((const unsigned char*)tempNode->string, (const unsigned char*)"HEXECUTE_NEWLINE"))
				{
					dumpFileStream.write("\r\n", 2);
				}
				else if (!_mbscmp((const unsigned char*)tempNode->string, (const unsigned char*)"HEXECUTE_ENDSTRING"))
				{
					dumpFileStream.write("\r\n\r\n", 4);
					if(!clean)
					{
						wsprintf(temp, "<%08x>\r\n", a + 1);
						dumpFileStream.write(temp, strlen(temp));
					}
				}
				else dumpFileStream.write(tempNode->string, _mbstrlen(tempNode->string));
			}
		}
	}
	// this is when we don't have a table file, and are just dumping ascii
	else {
		;
	}
	dumpFileStream.close();
}

BOOL CALLBACK DumpProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int HexOrDec = 0;
	int MASK[4] = { 0xFF, 0xFF00, 0xFF0000, 0xFF000000 } ;
	LPTSTR path = (LPTSTR)malloc(_MAX_PATH);
	ZeroMemory(path, sizeof(path));
	OPENFILENAME ofn;
	char temp[MAX_PATH],/*temp2[500],*/ filename[MAX_PATH];
	static char szTitleName[50];
	int  r = 0, ExtractionAddress, Length;
	char kore[100];
	switch(message){
		case WM_INITDIALOG:
			if(lParam != NULL)
			{
				wsprintf(kore, "%X", Dumpy.offset);
				SetDlgItemText(hWnd, IDC_EDIT3, kore);
				wsprintf(kore, "%X", Dumpy.length);
				SetDlgItemText(hWnd, IDC_EDIT4, kore);
				CheckDlgButton(hWnd, IDC_CHECK_CLEAN, BST_CHECKED);
			}
			else
			{
				wsprintf(kore, "%X", CurrentStartAddress + (yMouse * 16) + CurrentPosition);
				SetDlgItemText(hWnd, IDC_EDIT3, kore); // set the insertion address to where the caret is
				SetDlgItemText(hWnd, IDC_EDIT4, "0");	// set the insertion length to zero
				CheckDlgButton(hWnd, IDC_CHECK_CLEAN,BST_CHECKED);
			}
			return (TRUE);
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_DUMPBROWSE:
					ZeroMemory(&ofn, sizeof(OPENFILENAME));
					ZeroMemory(path, _MAX_PATH);
					ofn.lStructSize = sizeof(OPENFILENAME);
					ofn.hwndOwner = hWnd;
					ofn.lpstrFilter = (LPSTR)Filters;
					ofn.nMaxFile = MAX_PATH;
					ofn.nMaxFileTitle = MAX_PATH;
					ofn.lpstrFile = path;
					ofn.lpstrFileTitle = TitleName;
					ofn.lpstrTitle = "Save as...";
					ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
	
					// if we get a file name
					if(!GetSaveFileName(&ofn))
					{	
						return TRUE;
					} else {
						SetDlgItemText(hWnd, IDC_EDIT1, path);
					}			
					return (TRUE);
			
				case IDOK:
					// here I put in my shtuff for calling the 
					// dumper with the address, length and filename
					// here we get the file name
					GetDlgItemText(hWnd, IDC_EDIT1, temp, MAX_PATH);
					if(!_tcslen(temp))
					{
						MessageBox(hWnd, "Please give a file name", PROGRAM_NAME, MB_OK);
						return 0;
					}
					_tcscpy(filename, temp);
					// here we get the offset
					GetDlgItemText(hWnd, IDC_EDIT3, temp, 100);
					ExtractionAddress = strtoul(temp, NULL, 16);
					// here we get the length of the extraction
					GetDlgItemText(hWnd, IDC_EDIT4, temp, 100);
					Length = strtoul(temp, NULL, 16);
					Dump(filename, ExtractionAddress, Length, (IsDlgButtonChecked(hWnd, IDC_CHECK_CLEAN) == BST_CHECKED)?1:0);
					free(path);
					EndDialog(hWnd, 1);
					return (TRUE);
			
				case IDCANCEL:
					free(path);
					EndDialog(hWnd, 0);
					return (TRUE);
			}

	}
	return 0;
}

int DumpPositions()
{
	std::fstream outblah;
	outblah.open("positions.dmp", std::ios::out);
	for(int a = 0; a < 32; a ++)
	{
		outblah << " Positions[ " << 0 << "][" << a << "] = " << Positions[0][a] << std::endl;
	}
	return 1;
}