/*
 * Hexecute 3.0
 * ExpandFile.cpp
 * copyright 2000 Mike Walston
 * 
 * This is the main file, it will hold WinMain
 */


#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

#pragma warning( disable : 4244 )

BOOL CALLBACK ExpandFileProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hWndParent = GetParent(hWnd);
	unsigned char* Expanded, InitializeByte = 0x00;
	static int ExpandSize = 0x20000;
	TCHAR szHamburger[100];
	switch (msg) {
		case WM_INITDIALOG:
			CheckDlgButton(hWnd, IDC_128KRADIO, 1);
			return 0;
	
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
				if(IsDlgButtonChecked(hWnd, IDC_CUSTOMSIZE))
				{
					if(!GetDlgItemText(hWnd, IDC_EXPANDSIZEEDIT, szHamburger, 19))
					{
						MessageBox(hWnd, TEXT("Please input an expansion size"), PROGRAM_NAME, MB_OK);
						return (TRUE);
					}
					else
						ExpandSize = strtol(szHamburger, NULL, 16);
				}				
				SetCursor(LoadCursor(NULL, IDC_WAIT));
				Expanded = (unsigned char*)GlobalAlloc(GMEM_FIXED , MaxAddress + ExpandSize);
				if(!GetDlgItemText(hWnd, IDC_FILLBYTEEDIT, szHamburger, 19))
				{
					;
				}
				else
				{
					InitializeByte = strtol(szHamburger, NULL, 16);
				}
				memset(Expanded, InitializeByte, MaxAddress + ExpandSize);

				// needs to be fixed for the expansion of large files 3/2/2
				memcpy(Expanded, File, MaxAddress);
				GlobalFree(File);
				File = Expanded;
				UnicodeFile = (wchar_t*)File;
				MaxAddress += ExpandSize;
				SetCursor(LoadCursor(NULL, IDC_ARROW));
				SendMessage(hWndParent, WM_SIZE, wParam, lParam);
				EndDialog(hWnd, 1);
				return (TRUE);
				
				case IDC_128KRADIO:
					ExpandSize = 0x20000;
					return (TRUE);

				case IDC_256KRADIO:
					ExpandSize = 0x40000;
					return (TRUE);
	
				case IDC_512KRADIO:
					ExpandSize = 0x80000;
					return (TRUE);

				case IDC_1024KRADIO:
					ExpandSize = 0x100000;
					return (TRUE);

				case IDC_2048KRADIO:
					ExpandSize = 0x200000;
					return (TRUE);

				case IDCANCEL:
					EndDialog(hWnd, 0);
					return (TRUE);
			}
	}	
	return (FALSE);
}