/*
 * Hexecute 3.0
 * FindProc.h
 * copyright 2000 Mike Walston
 *
 * This is the file that holds WinProc for the file search dialog
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

int goToAddress = 0;
int wasabi;
TCHAR searching[100];
char* tempA;
char prevSearches[10][100];
int numPrevSearches = 0;

void ShowFindSpecial(HWND hWnd)
{
	HWND hWndTemp;
	long TempWindowLong = 0;
	RECT rect;

	// intialize rect
	rect.left = 101;
	rect.right = 180;
	rect.top = 35;
	rect.bottom = 78;

	// hide the checkbox
	hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_CHECK);
	TempWindowLong = GetWindowLong(hWndTemp, GWL_STYLE);
	// when I want to make it appear again, I need
	// to remove the following comment
	//TempWindowLong ^= WS_VISIBLE;
	SetWindowLong(hWndTemp, GWL_STYLE, TempWindowLong);

	// hide the combo box
	hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
	TempWindowLong = GetWindowLong(hWndTemp, GWL_STYLE);
	TempWindowLong ^= WS_VISIBLE;
	SetWindowLong(hWndTemp, GWL_STYLE, TempWindowLong);

	// hide the static lable for the combo box
	hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_LABEL);
	TempWindowLong = GetWindowLong(hWndTemp, GWL_STYLE);
	TempWindowLong ^= WS_VISIBLE;
	SetWindowLong(hWndTemp, GWL_STYLE, TempWindowLong);

	InvalidateRect(hWnd, NULL, TRUE);
}

int Decimal = 0, Hex = 0, LastWasHex = 0;

BOOL CALLBACK FindProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	OPENFILENAME ofn;
	HWND hWndParent = GetParent(hWnd), hWndTemp;
	static COMBOBOXTEXT pcbtArrayComboBoxes[3];
	static int LastWasHex = 0;
	static bool CaseSensitive = false, MotorolaByteOrder = false;
	static TCHAR TextValChar[25] = { TEXT("ASCII") }, 
		 TextRelChar[25] = { TEXT("Caps-Low-Num") }, 
		 DecimalChar[25] = { TCHAR("char") }, temp[100], temp2[100], path[MAX_PATH], TitleName[_MAX_PATH];
	long TempWindowLong = 0;
	int a;
	switch(message) {
		case WM_INITDIALOG:
			
			// get the window handle of the combo box and fill with strings
			hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
			InitializeComboBoxArray(pcbtArrayComboBoxes);
			
			for(a  = 0; a < numPrevSearches ;a++)
				SendDlgItemMessage(hWnd, IDC_SEARCHCOMBO, CB_ADDSTRING, 0, (LPARAM)prevSearches[a]);
			if(numPrevSearches)
				SetDlgItemText(hWnd, IDC_SEARCHCOMBO, prevSearches[numPrevSearches - 1]);

			// initialize dialog stuff
			wsprintf(temp, "%08x", MaxAddress);
			SetDlgItemText(hWnd, IDC_EDIT_START, TEXT("00000000"));
			SetDlgItemText(hWnd, IDC_EDIT_END, temp);
			SetDlgItemText(hWnd, IDC_SEARCHSTRING, TEXT(""));
			CheckDlgButton(hWnd, IDC_RADIO_VALSEARCH, 1);
			CheckDlgButton(hWnd, IDC_RADIO_TEXTINPUT, 1);
			SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[1]);
			SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)TextValChar);
			Text = 1;
			Value = 1;
			SetFocus(GetDlgItem(hWnd, IDC_SEARCHCOMBO));
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				//when the radio button for value search is selected
				case IDC_RADIO_VALSEARCH:

					// check for all possible previous selections and save
					SaveLastComboBoxText(hWnd, TextValChar, TextRelChar, DecimalChar,
										 Value, Relative, Text, Decimal, Hex);

					// set it for value search
					Value = 1;
					Relative = 0;

					//set the combo box title text to what it needs to be
					if(Text)
					{
						if(LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						CheckDlgButton(hWnd, IDC_PREFERENCES_CHECK, CaseSensitive);
						SetDlgItemText(hWnd, IDC_PREFERENCES_CHECK, TEXT("&Case Sensitive"));
						SetDlgItemText(hWnd, IDC_PREFERENCES_LABEL, TEXT("Character Set:"));

						// get the window handle of the combo box and fill with strings
						hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
						SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[1]);
						
						// still in test mode, but should restore previous selection
						SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)TextValChar);

						LastWasHex = 0;
					}
					else if(Decimal)
					{
						if(LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						CheckDlgButton(hWnd, IDC_PREFERENCES_CHECK, MotorolaByteOrder);
						SetDlgItemText(hWnd, IDC_PREFERENCES_CHECK, TEXT("&Big Endian"));
						SetDlgItemText(hWnd, IDC_PREFERENCES_LABEL, TEXT("Data Size:"));
						
						// get the window handle of the combo box and fill with strings
						hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
						SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[2]);

						// still in test mode, but should restore previous selection
						SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)DecimalChar);
						
						LastWasHex = 0;
					}
					else // if hex
					{	
						if(!LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						LastWasHex = 1;
					}
					break;

				//when the radio button for relative search is selected
				case IDC_RADIO_RELSEARCH:

					// check for all possible previous selections and save
					SaveLastComboBoxText(hWnd, TextValChar, TextRelChar, DecimalChar,
										 Value, Relative, Text, Decimal, Hex);

					// set it for relative search
					Value = 0;
					Relative = 1;

					//set the combo box title text to what it needs to be
					if(Text)
					{
						if(LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						CheckDlgButton(hWnd, IDC_PREFERENCES_CHECK, CaseSensitive);
						SetDlgItemText(hWnd, IDC_PREFERENCES_CHECK, TEXT("&Case Sensitive"));
						SetDlgItemText(hWnd, IDC_PREFERENCES_LABEL, TEXT("Font Table Layout:"));

						// get the window handle of the combo box and fill with strings
						hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
						SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[0]);

						// still in test mode, but should restore previous selection
						SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)TextRelChar);
						
						LastWasHex = 0;
					}
					else if(Decimal)
					{
						if(LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						CheckDlgButton(hWnd, IDC_PREFERENCES_CHECK, MotorolaByteOrder);
						SetDlgItemText(hWnd, IDC_PREFERENCES_CHECK, TEXT("&Big Endian"));
						SetDlgItemText(hWnd, IDC_PREFERENCES_LABEL, TEXT("Data Size:"));

						// get the window handle of the combo box and fill with strings
						hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
						SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[2]);

						// still in test mode, but should restore previous selection
						SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)DecimalChar);
						
						LastWasHex = 0;
					}
					else // if hex
					{	
						if(!LastWasHex)
							ShowFindSpecial(hWnd);
						LastWasHex = 1;
					}
					break;
			
				//when the radio button for text input is selected
				case IDC_RADIO_TEXTINPUT:

					// check for all possible previous selections and save
					SaveLastComboBoxText(hWnd, TextValChar, TextRelChar, DecimalChar,
										 Value, Relative, Text, Decimal, Hex);

					// set values for text input
					Text = 1;
					Hex = 0;

					//set the combo box title text to what it needs to be
					if(Value)
					{
						if(LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						CheckDlgButton(hWnd, IDC_PREFERENCES_CHECK, CaseSensitive);
						SetDlgItemText(hWnd, IDC_PREFERENCES_CHECK, TEXT("&Case Sensitive"));
						SetDlgItemText(hWnd, IDC_PREFERENCES_LABEL, TEXT("Character Set:"));

						// get the window handle of the combo box and fill with strings
						hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
						SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[1]);

						// still in test mode, but should restore previous selection
						SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)TextValChar);
					}
					else // if relative
					{	
						if(LastWasHex) // if our combobox is hidden
							ShowFindSpecial(hWnd);
						CheckDlgButton(hWnd, IDC_PREFERENCES_CHECK, CaseSensitive);
						SetDlgItemText(hWnd, IDC_PREFERENCES_CHECK, TEXT("&Case Sensitive"));
						SetDlgItemText(hWnd, IDC_PREFERENCES_LABEL, TEXT("Font Table Layout:"));
						
						// get the window handle of the combo box and fill with strings
						hWndTemp = GetDlgItem(hWnd, IDC_PREFERENCES_COMBO);
						SetComboBoxText(hWndTemp, &pcbtArrayComboBoxes[0]);

						// still in test mode, but should restore previous selection
						SendMessage(hWndTemp, CB_SELECTSTRING, -1, (LPARAM)TextRelChar);

					}
					LastWasHex = 0;
					break;

				//when the radio button for hex input is selected
				case IDC_RADIO_HEXINPUT:
					
					// check for all possible previous selections and save
					SaveLastComboBoxText(hWnd, TextValChar, TextRelChar, DecimalChar,
										 Value, Relative, Text, Decimal, Hex);

					//set values for hex input
					Text = 0;
					Hex = 1;

					if(!LastWasHex)
						ShowFindSpecial(hWnd);
					LastWasHex = 1;

					break;
				
				case IDC_PREFERENCES_CHECK:
					if(Text)
						CaseSensitive ^= true;
					else // if hex
						MotorolaByteOrder ^= true;

					break;

				case IDC_BROWSE_BUTTON:
					ZeroMemory(&ofn, sizeof(OPENFILENAME));
					ZeroMemory(path, _MAX_PATH);
					ofn.lStructSize = sizeof(OPENFILENAME);
					ofn.hwndOwner = hWnd;
					ofn.lpstrFilter = (LPSTR)Filters;
					ofn.nMaxFile = MAX_PATH;
					ofn.nMaxFileTitle = MAX_PATH;
					ofn.lpstrFile = path;
					ofn.lpstrFileTitle = TitleName;
					ofn.lpstrTitle = "Save as...";
					ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;

					if(GetSaveFileName(&ofn))
					{
						SetDlgItemText(hWnd, IDC_DUMP_FILENAME, path);
					}
					else
						;


					break;

				case IDOK:
					EnableMenuItem(HexecuteMenu, ID_EDIT_FINDNEXT, MF_ENABLED);
					GetDlgItemText(hWnd, IDC_SEARCHCOMBO, temp, 100);
					_tcscpy(searching, temp);
					// my selection code works now
					if(Text) {
						strcpy(prevSearches[numPrevSearches], temp);
						numPrevSearches++;
						ProcessText(temp);
						if(Value) { // if we're just doing a string search
							wasabi = ValueSearch(temp, strlen(temp), CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(wasabi)
							{
								CurrentPosition = ( wasabi % 16 );
								RealPosition = CurrentPosition;
								if(CurrentTable == -1)
									CurrentPosition += 16;
								yMouse = 0;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								GetScrollInfo(hWndData, SB_VERT, &si);
								si.nPos = ( wasabi - ( wasabi % 16 ) ) / 16 ;
								SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
								InvalidateRect(hWndData, NULL, FALSE);
								EndDialog(hWnd, 1);
							}
							else 
							{
								EndDialog(hWnd, 0);
							}
						} else { // here we're doing a relative search
							wasabi = RelativeSearch(temp, strlen(temp),  CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(wasabi)
							{
								CurrentPosition = ( wasabi % 16 );
								RealPosition = CurrentPosition;
								if(CurrentTable == -1)
									CurrentPosition += 16;
								yMouse = 0;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								GetScrollInfo(hWndData, SB_VERT, &si);
								si.nPos = ( wasabi - ( wasabi % 16 ) ) / 16 ;
								SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
								InvalidateRect(hWndData, NULL, FALSE);
								EndDialog(hWnd, 1);
							}
							else 
							{
								EndDialog(hWnd, 0);						
							}
						}
					} else {
						tempA = ConvertHexToString(searching);
						if(tempA == NULL)
						{
							MessageBox(hWnd, "Please input a hex string with complete bytes", PROGRAM_NAME, MB_OK);
							break;
						}
						strcpy(prevSearches[numPrevSearches], searching);
						numPrevSearches++;
						if(Value) { // again, a regular value search
							//wasabi = ValueSearch(searching, strlen(searching), CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							wasabi = ValueSearch(tempA, strlen(tempA), CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(wasabi)
							{
								CurrentPosition = ( wasabi % 16 );
								RealPosition = CurrentPosition;
								yMouse = 0;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								GetScrollInfo(hWndData, SB_VERT, &si);
								si.nPos = ( wasabi - ( wasabi % 16 ) ) / 16 ;
								SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
								InvalidateRect(hWndData, NULL, FALSE);
								//delete[] tempA;
								EndDialog(hWnd, 1);
							}
							else 
							{
								//delete[] tempA;
								EndDialog(hWnd, 0);
							}
						} else { // mmhmm, a relative hex search.  whatever floats their boat
							//wasabi = RelativeSearch(searching, strlen(searching),  CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							wasabi = RelativeSearch(tempA, strlen(tempA),  CurrentStartAddress + (yMouse * 16) + CurrentPosition);
							if(wasabi)
							{
								CurrentPosition = ( wasabi % 16 );
								RealPosition = CurrentPosition;
								yMouse = 0;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								GetScrollInfo(hWndData, SB_VERT, &si);
								si.nPos = ( wasabi - ( wasabi % 16 ) ) / 16 ;
								SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
								InvalidateRect(hWndData, NULL, FALSE);
								//delete[] tempA;
								EndDialog(hWnd, 1);
							}
							else
							{
								//delete[] tempA;
								EndDialog(hWnd, 0);	
							}
						}
					}
					CleanUpComboBoxArray(pcbtArrayComboBoxes);
					EndDialog(hWnd, 1);
					break;

				case IDCANCEL:
					CleanUpComboBoxArray(pcbtArrayComboBoxes);
					EndDialog(hWnd, 0);
					break;

			}

	}
	return 0;
}

BOOL CALLBACK GoToProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char strings[100];
	switch(message) {
		case WM_INITDIALOG:
			return 0;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					if(!GetDlgItemText(hWnd, IDC_EDIT1, strings, 10))
					{
						MessageBox(hWnd, "Please input an offset", PROGRAM_NAME, MB_OK);
						return 0;
					}
					goToAddress = strtoul(strings, NULL, 16);
					EndDialog(hWnd,1);
					break;
				case IDCANCEL:
					EndDialog(hWnd,0);
					break;
			}
	}
	return 0;
}