/*
 * Hexecute 3.0
 * History.cpp
 * copyright 2000 Mike Walston
 *
 * This holds the HISTORY class and all history related functions
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

// constructor, default size 4096
historyStack::historyStack()
{
	size = 4096; // 4k worth of undo
	top = -1;
	stackPtr = new historyevent[ size ];
}

// constructor, default size 4096
historyStack::historyStack(int foo)
{
	size = foo; // 4k worth of undo
	top = -1;
	stackPtr = new historyevent[ size ];
}


// push an element onto the stack
// return true if it works, false if it doesn't

bool historyStack::push( const historyevent &pushValue )
{
	if ( !isFull() ) {
		stackPtr[ ++top ] = pushValue; // put it in the stack
		EnableMenuItem(HexecuteMenu, ID_EDIT_UNDO, MF_ENABLED);
		return true; // the push worked
	}
	return false; // unable to push onto the stack
}

// pop an element off the stack
// return true if it works, false if it doesn't
bool historyStack::pop(historyevent &popValue )
{
	if( !isEmpty() ) {
		popValue = stackPtr[ top-- ];
		EnableMenuItem(HexecuteMenu, ID_EDIT_UNDO, MF_ENABLED);
		return true;
	} else EnableMenuItem(HexecuteMenu, ID_EDIT_UNDO, MF_GRAYED);
	return false; // pop unsuccessful
}