/*
 * Hexecute 3.0
 * Menu.cpp
 * copyright 2000 Mike Walston
 *
 * This file contains the functions for manipulating the status bar
 */

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void DefaultMenu()
{
	EnableMenuItem(HexecuteMenu, ID_HELP_ABOUTTHEAUTHOR, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_FILE_NEW, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_OPEN, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_CLOSE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_FILE_SAVE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_FILE_SAVEAS, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_FILE_EXIT, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_UNDO, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_REDO, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_DELETE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_SELECTALL, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_SELECTLINE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_FIND, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_REPLACE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_GOTO, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_FINDNEXT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_TABLES_OPENTABLE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_SPLITFILE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_EXPANDFILE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_DUMPTEXT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_INSERTTEXT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_OPTIONS_DATAVIEWER, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_VIEW_STATUSBAR, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_VIEW_TOOLBARS, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_OPTIONS_PREFERENCES, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_HELP_CONTENTS, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_HELP_SEARCH, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_HELP_INDEX, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_HELP_TIPOFTHEDAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_HELP_ABOUTHEXECUTE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_TEXT, MF_GRAYED);		
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_CHARARRAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_SHORTARRAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_LONGARRAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_OPTIONS_CLEANUPOUTPUT, MF_ENABLED);
	
}

void FileOpenedMenu()
{
	EnableMenuItem(HexecuteMenu, ID_HELP_ABOUTTHEAUTHOR, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_FILE_NEW, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_OPEN, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_CLOSE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_SAVE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_SAVEAS, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_FILE_EXIT, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_UNDO, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_REDO, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_DELETE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_SELECTALL, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_SELECTLINE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_FIND, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_REPLACE, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_GOTO, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_SELECTALL, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_SELECTLINE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_TABLES_OPENTABLE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_SPLITFILE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_EXPANDFILE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_SPECIAL_INSERTTEXT, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_OPTIONS_DATAVIEWER, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_VIEW_STATUSBAR, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_VIEW_TOOLBARS, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_OPTIONS_PREFERENCES, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_HELP_CONTENTS, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_HELP_SEARCH, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_HELP_INDEX, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_HELP_TIPOFTHEDAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_HELP_ABOUTHEXECUTE, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_OPTIONS_CLEANUPOUTPUT, MF_ENABLED);
}

void CutAndCopyEnableMenu()
{
	if(!IsPagingOn && !OverWrite)
		EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_ENABLED);
	else EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYSTRING, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_TEXT, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_CHARARRAY, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_SHORTARRAY, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_LONGARRAY, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPY, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYSTRING, MF_ENABLED);
	EnableMenuItem(HexecuteMenu, ID_COPY_SELECTED, MF_ENABLED);	
}

void CutAndCopyDisableMenu()
{
	EnableMenuItem(HexecuteMenu, ID_EDIT_CUT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYSTRING, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_TEXT, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_CHARARRAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_SHORTARRAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYAS_LONGARRAY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPY, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_EDIT_COPYSTRING, MF_GRAYED);
	EnableMenuItem(HexecuteMenu, ID_COPY_SELECTED, MF_GRAYED);	
}

void CodePageMenu(HWND hWnd, int CHECKED)
{
	char *szHamburger, szCheeseBurger[50];
	int iTitleLength;
	wsprintf(szCheeseBurger, " ");
	if(CHECKED == ID_OPTIONS_TEXTCODEPAGE_UNICODEBIGENDIAN)
	{
		CheckMenuItem(HexecuteMenu, ID_OPTIONS_TEXTCODEPAGE_UNICODEBIGENDIAN, MF_CHECKED);
		strcat(szCheeseBurger, "Unicode (Big Endian)");
	}
	else CheckMenuItem(HexecuteMenu, ID_OPTIONS_TEXTCODEPAGE_UNICODEBIGENDIAN, MF_UNCHECKED);
	if(CHECKED == ID_OPTIONS_TEXTCODEPAGE_UNICODE)
	{
		CheckMenuItem(HexecuteMenu, ID_OPTIONS_TEXTCODEPAGE_UNICODE, MF_CHECKED);
		strcat(szCheeseBurger, "Unicode");
	}
	else CheckMenuItem(HexecuteMenu, ID_OPTIONS_TEXTCODEPAGE_UNICODE, MF_UNCHECKED);
	if(CHECKED == ID_OPTIONS_TEXTCODEPAGE_DEFAULT)
	{
		CheckMenuItem(HexecuteMenu, ID_OPTIONS_TEXTCODEPAGE_DEFAULT, MF_CHECKED);
		strcat(szCheeseBurger, "ASCII");
	}
	else CheckMenuItem(HexecuteMenu, ID_OPTIONS_TEXTCODEPAGE_DEFAULT, MF_UNCHECKED);
	if(CHECKED == IDM_CODEPAGE0)
	{
		CheckMenuItem(HexecuteMenu, IDM_CODEPAGE0, MF_CHECKED);
		strcat(szCheeseBurger, CPages[0].name);
	}
	else CheckMenuItem(HexecuteMenu, IDM_CODEPAGE0, MF_UNCHECKED);
	if(CHECKED == IDM_CODEPAGE1)
	{
		CheckMenuItem(HexecuteMenu, IDM_CODEPAGE1, MF_CHECKED);
		strcat(szCheeseBurger, CPages[1].name);
	}
	else CheckMenuItem(HexecuteMenu, IDM_CODEPAGE1, MF_UNCHECKED);
	if(CHECKED == IDM_CODEPAGE2)
	{
		CheckMenuItem(HexecuteMenu, IDM_CODEPAGE2, MF_CHECKED);
		strcat(szCheeseBurger, CPages[2].name);
	}
	else CheckMenuItem(HexecuteMenu, IDM_CODEPAGE2, MF_UNCHECKED);
	if(CHECKED == IDM_CODEPAGE3)
	{
		CheckMenuItem(HexecuteMenu, IDM_CODEPAGE3, MF_CHECKED);
		strcat(szCheeseBurger, CPages[3].name);
	}
	else CheckMenuItem(HexecuteMenu, IDM_CODEPAGE3, MF_UNCHECKED);
	if(CHECKED == IDM_CODEPAGE4)
	{
		CheckMenuItem(HexecuteMenu, IDM_CODEPAGE4, MF_CHECKED);
		strcat(szCheeseBurger, CPages[4].name);
	}
	else CheckMenuItem(HexecuteMenu, IDM_CODEPAGE4, MF_UNCHECKED);
	if(CHECKED == IDM_CODEPAGE5)
	{
		CheckMenuItem(HexecuteMenu, IDM_CODEPAGE5, MF_CHECKED);
		strcat(szCheeseBurger, CPages[5].name);
	}
	else CheckMenuItem(HexecuteMenu, IDM_CODEPAGE5, MF_UNCHECKED);

	//
	iTitleLength = GetWindowTextLength(hWnd);
	szHamburger = new char[iTitleLength + 100];
	if(FileOpen)
	{
			//here we set the window title to what it should be 
		GetWindowText(hWnd, szHamburger, iTitleLength);
		for ( int Backwards = iTitleLength - 1; Backwards >= 0; Backwards-- )
		{
			if(szHamburger[Backwards] != '-')
				szHamburger[Backwards] = 0x00;
			else break;
		}
		strcat(szHamburger, szCheeseBurger);
	}
	else
	{
			wsprintf(szHamburger, "%s %d.%d -%s", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, szCheeseBurger);
	}
	SetWindowText(hWnd, szHamburger);
	delete[] szHamburger;
}