/*
 * Hexecute 3.0
 * Output.cpp
 * copyright 2000 Mike Walston
 *
 * These are the functions that draw the hex data onto the screen
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void SetColors(HDC hDC, int HighlightColor, int HexBGColor, int color, int HighlightTextColor, int AxtempCalc, int qw)
{
	if(HighlightOn) {
		if( endHighlight > startHighlight) {
			if( ( AxtempCalc + qw >= startHighlight ) &&
				( AxtempCalc + qw < endHighlight ) )
			{
				SetTextColor(hDC, HighlightTextColor);
				SetBkColor(hDC, HighlightColor);
				ImageList_SetBkColor(hImageList, HighlightColor);
			}
			else
			{
				SetTextColor(hDC, color);
				SetBkColor(hDC, HexBGColor);
				ImageList_SetBkColor(hImageList, HexBGColor);
			}
		} else {
			if( ( AxtempCalc + qw < startHighlight ) &&
				( AxtempCalc + qw >= endHighlight ) )
			{
				SetTextColor(hDC, HighlightTextColor);
				SetBkColor(hDC, HighlightColor);
				ImageList_SetBkColor(hImageList, HighlightColor);
			}
			else
			{
				SetTextColor(hDC, color);
				SetBkColor(hDC, HexBGColor);
				ImageList_SetBkColor(hImageList, HexBGColor);
			}
		}
	} else {
		SetTextColor(hDC, color);
		SetBkColor(hDC, HexBGColor);
		ImageList_SetBkColor(hImageList, HexBGColor);
	}
}

// this returns the total width of the output
int HexOutputWord(HDC hDC, int specialCalc, // width of row
				   int OddColumnColor, int EvenColumnColor,
				   int HighlightColor, int HexBGColor,
				   int AxtempCalc, int StartHighlight,
				   int EndHighlight, int cyChar, 
				   int cxChar, int CtimescyChar, 
				   int tempCalc, int c)
{
	bool lastodd = false;
	char temp[50];
	int color = OddColumnColor;
	long OutputWidth;
	SIZE Size;
	//HBRUSH Fixer;
//	RECT HoleFiller;
	
	wsprintf(temp, "%08X  ", AxtempCalc );
	GetTextExtentPoint32(hDC, temp, strlen(temp), &Size);
	Positions[c][0] = Size.cx;
	OutputWidth = Size.cx;
	for(int qw = 0; qw < specialCalc;qw++)
	{
		if(!(qw % 2)) // it's the first number in a 2 char set
		{
			wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
	
			// here we do our thing for the output of hex no matter what font	
			if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
			{
				Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
				OutputWidth += Size.cx;
			}
			else 
			{
				MessageBox(NULL, TEXT("BOOM - HexOutputWord() - Line 15"), PROGRAM_NAME, MB_OK);
			}
			SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
			TextOut(hDC, Positions[c][qw]  - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
			qw++;
		}
		if(qw < specialCalc)	// it's not and it's not the last
			{
			if (qw + 1 == specialCalc)
				wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
			else wsprintf(temp, "%02x ", GetFileByte(AxtempCalc + qw));

			// here we do our thing for the output of hex no matter what font	
			if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
			{
				Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
				OutputWidth += Size.cx;
			}
			else MessageBox(NULL, TEXT("BOOM - HexOutputWord() - Line 109"), PROGRAM_NAME, MB_OK);
			SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
			TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
			}
		if(color == OddColumnColor)
			color = EvenColumnColor;
		else color = OddColumnColor;
		SetBkColor(hDC, HexBGColor);
		ImageList_SetBkColor(hImageList, HexBGColor);
	}
	for(int wq = specialCalc; wq < tempCalc; wq++)
	{
		if(wq % 2)
		{
			wsprintf(temp, "00 ");
			if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
			{
				Positions[c][wq + 1] = Positions[c][wq] + Size.cx;
				OutputWidth += Size.cx;
			}
			wsprintf(temp, "         ");
			TextOut(hDC, OutputWidth  - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		}
		else
		{
			wsprintf(temp, "0000 ");
			if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
			{
				Positions[c][wq + 1] = Positions[c][wq] + Size.cx;
				Positions[c][wq + 2] = Positions[c][wq] + Size.cx;
				OutputWidth += Size.cx;
			}
			wsprintf(temp, "         ");
			TextOut(hDC, OutputWidth  - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
			wq++;
		}
	}
	TextOut(hDC, OutputWidth - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	return (int) OutputWidth;
}


int HexOutputByte(HDC hDC, int specialCalc, // width of row
				   int OddColumnColor, int EvenColumnColor,
				   int HighlightColor, int HexBGColor,
				   int AxtempCalc,
				   int StartHighlight, int EndHighlight,
				   int cyChar, int cxChar, int CtimescyChar, 
				   int tempCalc, int c)
{
	bool lastodd = false;
	char temp[50];
	int color = OddColumnColor;
	long OutputWidth;
	SIZE Size;

	wsprintf(temp, "%08X  ", c * tempCalc );
	GetTextExtentPoint32(hDC, temp, strlen(temp), &Size);
	Positions[c][0] = Size.cx;
	OutputWidth = Size.cx;

	for(int qw = 0; qw < specialCalc;qw++)
	{
		if(qw < specialCalc)	// it's not and it's not the last
			{
			if (qw + 1 == specialCalc)
				wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
			else wsprintf(temp, "%02x ", GetFileByte(AxtempCalc + qw));

			// here we do our thing for the output of hex no matter what font	
			if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
			{
				Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
				OutputWidth += Size.cx;
			}
			else MessageBox(NULL, TEXT("BOOM - HexOutputByte() - Line 297"), PROGRAM_NAME, MB_OK);
			SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
			TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		} else {
			wsprintf(temp, "   ");
			lastodd = true;
			SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
			TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		}
		if(color == OddColumnColor)
			color = EvenColumnColor;
		else color = OddColumnColor;
		SetBkColor(hDC, HexBGColor);
	}
	for(int wq = specialCalc; wq < tempCalc; wq++)
	{
		if(lastodd == true)
		{
			wq++;
			lastodd = false;
		}
		wsprintf(temp, "     ");
		TextOut(hDC, ( (wq * 3 ) + 10 ) * cxChar - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
	}
	return (int) OutputWidth;
	// eventually this will return the width of the output
}

int HexOutputInt(HDC hDC, int specialCalc, // width of row
				   int OddColumnColor, int EvenColumnColor,
				   int HighlightColor, int HexBGColor,
				   int AxtempCalc,
				   int StartHighlight, int EndHighlight,
				   int cyChar, int cxChar, int CtimescyChar, 
				   int tempCalc, int c)
{
	int tempqw;
	bool lastodd = false;
	char temp[50];
	int color = OddColumnColor;
	long OutputWidth = 0;
	SIZE Size;

	wsprintf(temp, "%08X  ", c * tempCalc );
	GetTextExtentPoint32(hDC, temp, strlen(temp), &Size);
	Positions[c][0] = Size.cx;
	OutputWidth = Size.cx;

	for(int qw = 0; qw < specialCalc;qw++)
	{
		//SetTextColor(hDC, color);
		tempqw = qw;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputInt() - Line 374"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
			
		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputInt() - Line 403"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
		
		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputInt() - Line 432"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		if(qw + 1 == specialCalc)
			wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
		else wsprintf(temp, "%02x ", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputInt() - Line 463"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		if(color == OddColumnColor)
			color = EvenColumnColor;
		else color = OddColumnColor;
		SetBkColor(hDC, HexBGColor);
	}
	for(int wq = specialCalc; wq < tempCalc; wq++)
	{
		if(lastodd == true)
		{
			wq++;
			lastodd = false;
		}
	wsprintf(temp, "     ");
	TextOut(hDC, ( ( tempqw * 9 ) + 10 ) * cxChar - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
	}
	return (int) OutputWidth;
	// eventually this will return the width of the output
}

int HexOutputQWord(HDC hDC, int specialCalc, // width of row
				   int OddColumnColor, int EvenColumnColor,
				   int HighlightColor, int HexBGColor,
				   int AxtempCalc,
				   int StartHighlight, int EndHighlight,
				   int cyChar, int cxChar, int CtimescyChar, 
				   int tempCalc, int c)
{
	int tempqw;
	bool lastodd = false;
	char temp[50];
	long OutputWidth = 0;
	int color = OddColumnColor;
	SIZE Size;

	wsprintf(temp, "%08X  ", c * tempCalc );
	GetTextExtentPoint32(hDC, temp, strlen(temp), &Size);
	Positions[c][0] = Size.cx;
	OutputWidth = Size.cx;

	for(int qw = 0; qw < specialCalc;qw++)
	{
		tempqw = qw;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 534"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 563"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 592"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 621"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 650"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);

		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 679"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));

		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 708"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		qw++;
		if(qw + 1 == specialCalc)
			wsprintf(temp, "%02x", GetFileByte(AxtempCalc + qw));
		else wsprintf(temp, "%02x ", GetFileByte(AxtempCalc + qw));
		
		// here we do our thing for the output of hex no matter what font	
		if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
		{
			Positions[c][qw + 1] = Positions[c][qw] + Size.cx;
			OutputWidth += Size.cx;
		}
		else MessageBox(NULL, TEXT("BOOM - HexOutputQWord - Line 739"), PROGRAM_NAME, MB_OK);
		SetColors(hDC, HighlightColor, HexBGColor, color, HighlightTextColor, AxtempCalc, qw);
		TextOut(hDC, Positions[c][qw] - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
		if(color == OddColumnColor)
			color = EvenColumnColor;
		else color = OddColumnColor;
		SetBkColor(hDC, HexBGColor);
	}
	for(int wq = specialCalc; wq < tempCalc; wq++)
	{
		if(lastodd == true)
		{
			wq++;
			lastodd = false;
		}
	wsprintf(temp, "     ");
	TextOut(hDC, ( ( tempqw * 9 ) + 10 ) * cxChar - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
	}
	return (int) OutputWidth;
	// eventually this will return the width of the output
}