/*
 * Hexecute 3.0
 * Paint.cpp
 * copyright 2000 Mike Walston
 * 
 * These are the two main parts of the WM_PAINT handler 
 * in DataWinProc
 */


#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include <tchar.h>
#include <wingdi.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void DrawImage(HIMAGELIST himl, HDC hDC, int index, int HighlightColor, int HexBGColor, int AxtempCalc, int qw, int f00b4r, int CtimescyChar)
{
	if(HighlightOn) {
		if( endHighlight > startHighlight) {
			if( ( AxtempCalc + qw >= startHighlight ) &&
				( AxtempCalc + qw < endHighlight ) )
			{
				ImageList_DrawEx(himl, index, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					16,16, CLR_DEFAULT , HighlightColor,ILD_BLEND );
			}
			else
			{
				ImageList_DrawEx(himl, index, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					16,16, CLR_DEFAULT , HexBGColor,ILD_NORMAL );
			}
		} else {
			if( ( AxtempCalc + qw < startHighlight ) &&
				( AxtempCalc + qw >= endHighlight ) )
			{
				ImageList_DrawEx(himl, index, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					16,16, CLR_DEFAULT , HighlightColor,ILD_BLEND );
			}
			else
			{
				ImageList_DrawEx(himl, index, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					16,16, CLR_DEFAULT , HexBGColor,ILD_NORMAL );
			}
		}
	} else {
		ImageList_DrawEx(himl, index, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
			16,16, CLR_DEFAULT , HexBGColor,ILD_NORMAL );
	}
}

void DrawLastLine(HWND hWnd, HDC hDC, int &AxtempCalc, unsigned long &NESPageSize, unsigned long &NESOffset,
				  int &CtimescyChar, int &HexWidth, int &specialCalc, int &tempCalc, 
				  int &OutputWidthTemp, int &hehe, int &CarryOver, int &c, SIZE &Size, int &AxtempCalcplusQ)
{
	wchar_t blankness[100] = { 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000 };
	int f00b4r;
	wchar_t	converted[100],
		temp_wide[50];
	TCHAR temp[500], temp2[500];
	static tableEntry emptyNode;
	emptyNode.string = new char[10];
	strcpy(emptyNode.string, ".");
	emptyNode.value = 0;
	tableEntry* tempNode;
	int GooglyMoogly /*,nihon, f00*/;
	SIZE AddressSize;
//	RECT HoleFiller;
//	HDC hdcMem;
//	BITMAP bm;
	SelectObject(hDC, hFontHex);
	//SetBkMode(hDC, TRANSPARENT);
	SetTextColor(hDC, AddressColor);
	SetBkColor(hDC, AddressBGColor);
    
	if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
	{
		if(ViewAsHiRom)
			wsprintf(temp, "%08X ", SMCToHiROM(AxtempCalc));
		else if( ViewAsLoRom) // if (ViewAsHiRom)
			wsprintf(temp, "%08X ", SMCToLoROM(AxtempCalc));
		else if ( ViewAsNES ) // else if (ViewAsLoRom)
		{
			if( (AxtempCalc / NESPageSize ) < 0xFFFF)
				wsprintf(temp, "%04X:", ( AxtempCalc ) / NESPageSize);
			else
				wsprintf(temp, "0000:");
			wsprintf(temp2, "%04X", NEStoOffset(AxtempCalc, NESPageSize, NESOffset));
			lstrcat(temp, temp2);
		}
	}
	else if(HexOrDec == HEX) // if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
		wsprintf(temp, "%08X ", AxtempCalc);
	else // if(HexOrDec == HEX)
		wsprintf(temp, "%08i ", AxtempCalc);
	TextOut(hDC, 0 - ( HorizontalOffset * cxChar) , CtimescyChar, temp, lstrlen(temp));
	//SetBkMode(hDC, OPAQUE);
	GetTextExtentPoint32(hDC, temp, strlen(temp), &AddressSize);
	SetBkColor(hDC, WHITE);
	TextOut(hDC, AddressSize.cx - ( HorizontalOffset * cxChar) , CtimescyChar, " ", lstrlen(" "));
	switch(GroupSize) {
		case 1:
			HexWidth = HexOutputByte(hDC, specialCalc, OddColumnColor, EvenColumnColor,
				HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
				endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 2:
			HexWidth = HexOutputWord(hDC, specialCalc, OddColumnColor, EvenColumnColor,
				HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
				endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 4:
			HexWidth = HexOutputInt(hDC, specialCalc, OddColumnColor, EvenColumnColor,
				HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
				endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 8:
			HexWidth = HexOutputQWord(hDC, specialCalc, OddColumnColor, EvenColumnColor,
				HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
				endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c );
			break;
	} // switch(GroupSize) 
	SetBkColor(hDC, WHITE);
	TextOut(hDC, HexWidth - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	GetTextExtentPoint32(hDC, TEXT(" "), strlen(TEXT(" ")), &Size);
	HexWidth += Size.cx;
	OutputWidthTemp = HexWidth;
	SelectObject(hDC, hFont);
	if(CurrentTable == -1)
	{
		HexWidth += Size.cx;
		if(CleanUp)
			SelectObject(hDC, hFont);
		else 
			SelectObject(hDC, CPages[CurrentCodePage].font);
		// print out the character data
		// working(?)
		GooglyMoogly = CPages[CurrentCodePage].CodePageNum;
		f00b4r = HexWidth;
		// TEST TEST TEST TEST TEST TEST TEST TEST TEST
		f00b4r -= cxChar;
		// END TEST END TEST END TEST END TEST END TEST
		Positions[c][16] = HexWidth - cxChar;
		SetBkColor(hDC, TextBGColor);
		SetTextColor(hDC, TextColor);
		temp[0] = 0;
		for(int q = 0; q < specialCalc; q++)
		{
			AxtempCalcplusQ = AxtempCalc + q;
			if(!CleanUp && IsDBCSLeadByteEx(GooglyMoogly, GetFileByte(AxtempCalcplusQ)))
			{
				wsprintf(temp, "%c%c", GetFileByte(AxtempCalcplusQ), GetFileByte(AxtempCalcplusQ + 1));
				MultiByteToWideChar(GooglyMoogly, MB_PRECOMPOSED, (const char*)temp, -1, converted, 50);	
				SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
				ExtTextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, ETO_OPAQUE, 
							NULL, converted, wcslen(converted),NULL);
				GetTextExtentPoint32W(hDC, converted, wcslen(converted), &Size);
				// we have a double byte size character here
				Positions[c][q + tempCalc + 1] = Positions[c][q + tempCalc];
				Positions[c][q + tempCalc + 2] = Positions[c][q + tempCalc] + Size.cx;
				q++;
				f00b4r += Size.cx;
			}
			else
			{
				// the new version
				if ( IsCharAlphaNumeric(GetFileByte(AxtempCalcplusQ)) || 
					 ( GetFileByte(AxtempCalcplusQ) == 0x20 ) || 
					 ispunct(GetFileByte(AxtempCalcplusQ)))
				{
					wsprintf(temp, "%c", GetFileByte(AxtempCalcplusQ));
					if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
					{
						Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
						OutputWidthTemp += Size.cx;
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLastLine() - Line 173"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
					f00b4r += Size.cx;
				} else {
					if(!CleanUp)
						wsprintf(temp, "%c", GetFileByte(AxtempCalcplusQ));
					else
						wsprintf(temp, ".");
					if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
					{
						Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
						OutputWidthTemp += Size.cx;
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLastLine() - Line 200"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					TextOut(hDC, f00b4r- ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
					f00b4r += Size.cx;
				}
			}
		}
		for( int y = specialCalc; y < tempCalc; y++)
			strcat(temp, " ");
		if(CleanUp)
		{
			SetBkColor(hDC, WHITE);
			wsprintf(temp, "                                                 ");
			// original code
			if(MaxAddress % tempCalc )
				TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), 
						CtimescyChar, temp, lstrlen(temp));	
			else 
				TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), 
						CtimescyChar, temp, lstrlen(temp));	
		}
		else
		{
		// hack for kamaitachi
			SelectObject(hDC, CPages[CurrentCodePage].font);
			// TEST TEST TEST TEST
			SetBkColor(hDC, 0x00FFFFFF);
			// END TEST END TEST
			ExtTextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, 
						ETO_OPAQUE, NULL, blankness, wcslen(blankness),NULL);
			SelectObject(hDC, hFont); 
			// end kamaitachi hack section
		}
		OutputWidthTemp = f00b4r;
	} else {	// if(CurrentTable == -1)
		SetTextColor(hDC, TextColor);
		SetBkColor(hDC, TextBGColor);
		SelectObject(hDC, tblFont[CurrentTable]);
		// are we using japanese?
		/*
		 * This is now going to be "Are we using a far eastern based table file"
		 * be it chinese, korean, japanese, or thai
		 *
		 */
		if(Table[CurrentTable]->getCodepage() != 1252)
		{			
			GooglyMoogly = Table[CurrentTable]->getCodepage();
			_tcscpy(temp, TEXT("                                                          "));
			TextOut(hDC, HexWidth - ( HorizontalOffset * cxChar), 
				CtimescyChar, temp, lstrlen(temp));	
			f00b4r = HexWidth;
			unsigned int checkValue = 0;
			converted[0] = 0x0000;
			for(int q = 0; q < specialCalc;q++)
			{
				AxtempCalcplusQ = AxtempCalc + q;
				Table[CurrentTable]->SetSubTable(Table[CurrentTable]->GetAddressSubTable(AxtempCalcplusQ));
				AxtempCalcplusQ = AxtempCalc + q;
				checkValue = 0;
				hehe = 0;
				switch( Table[CurrentTable]->getWidestValue() ) {
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(AxtempCalcplusQ) << 24);
						AxtempCalcplusQ++;
						hehe += 1;

					case 3:
						// check for 3 byte match
						checkValue += (GetFileByte(AxtempCalcplusQ) << 16 );
						AxtempCalcplusQ++;
						hehe += 1;

					case 2:
						// check for 2 byte match
						checkValue += (GetFileByte(AxtempCalcplusQ) << 8 );
						AxtempCalcplusQ++;
						hehe += 1;

					default:
						checkValue += GetFileByte(AxtempCalcplusQ);
						switch( Table[CurrentTable]->getWidestValue() ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
										break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						} // switch( Table[CurrentTable]->getWidestValue() ) [line 207]
						q += hehe;

				} // switch( Table[CurrentTable]->getWidestValue() ) { [line 186]
				if(tempNode->string == 0x00000000)
				{
					tempNode->string = new char[10];
					tempNode->string[0]='.';
					tempNode->string[1]=0;
				}				
				// my attempt at adding those l33t graphics that yousei had in hexroll
				if(!strcmp(tempNode->string, "HEXECUTE_NEWLINE"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);				
					DrawImage(hImageList, hDC, 0, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				else if (!strcmp(tempNode->string, "HEXECUTE_ENDSTRING"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);									
					DrawImage(hImageList, hDC, 1, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				
				// end of my leet attemp

				else
		
				{
					MultiByteToWideChar(GooglyMoogly, MB_PRECOMPOSED, 
						(const char*)tempNode->string,
						-1, temp_wide, 50);
					wcscat(converted, temp_wide);
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					if(GetTextExtentPoint32W(hDC, temp_wide, wcslen(temp_wide), &Size))
					{
						// if we have a one byte value, I think messing this up is what
						// was causing my messed up cursor positions
						if(tempNode->value < 0x100 )
						{
							Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
							OutputWidthTemp += Size.cx;
						}
						else if(tempNode->value >= 0x100 && tempNode->value < 0x10000 )
						{
							// q has already been incremented
							Positions[c][q + 16] = Positions[c][q + 15];
							Positions[c][q + 17] = Positions[c][q + 15] + Size.cx;
							OutputWidthTemp += Size.cx;
						}
						
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLastLine() - Line 398"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					ExtTextOutW(hDC,  f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, 
								ETO_OPAQUE, NULL, temp_wide,  wcslen(temp_wide), NULL);
					f00b4r += Size.cx;
				}
			}
		}
		// or are we using english?
		else if (Table[CurrentTable]->getCodepage() == 1252)
		{
			SelectObject(hDC, hFont);
			SetBkColor(hDC, TextBGColor);
			SetTextColor(hDC, TextColor);
			f00b4r = HexWidth;
			SelectObject(hDC, tblFont[CurrentTable]);
			for(int q = 0; q < specialCalc;q++)
			{
				AxtempCalcplusQ = AxtempCalc + q;
				Table[CurrentTable]->SetSubTable(Table[CurrentTable]->GetAddressSubTable(AxtempCalcplusQ));
				unsigned int checkValue = 0;
				hehe = 0;
				AxtempCalcplusQ = AxtempCalc + q;
				switch( Table[CurrentTable]->getWidestValue() ) {
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(AxtempCalcplusQ) << 24);
						AxtempCalcplusQ++;
						hehe += 1;

					case 3:
						// check for 3 byte match
						checkValue += ( GetFileByte(AxtempCalcplusQ)<< 16 );
						AxtempCalcplusQ++;
						hehe += 1;

					case 2:
						// check for 2 byte match
						checkValue += ( GetFileByte(AxtempCalcplusQ) << 8 );
						AxtempCalcplusQ++;
						hehe += 1;

					default:
						checkValue += GetFileByte(AxtempCalcplusQ);
						switch( Table[CurrentTable]->getWidestValue() ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						}
						q += hehe;

				}

				// my attempt at adding those l33t graphics that yousei had in hexroll
				if(tempNode->string == 0x00000000)
				{
					tempNode->string = new char[10];
					tempNode->string[0]='.';
					tempNode->string[1]=0;
				}
				if(!strcmp(tempNode->string, "HEXECUTE_NEWLINE"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);					
					DrawImage(hImageList, hDC, 0, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
//					ImageList_DrawEx(hImageList, 0, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
//						16,16, CLR_DEFAULT , NULL,ILD_NORMAL );

					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				else if (!strcmp(tempNode->string, "HEXECUTE_ENDSTRING"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);					
					DrawImage(hImageList, hDC, 1, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					//ImageList_DrawEx(hImageList, 1, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					//	16,16, CLR_DEFAULT , NULL,ILD_NORMAL );
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				
				// end of my leet attemp
				else

				{
					wsprintf(temp, (const char*)tempNode->string);
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					if(GetTextExtentPoint32(hDC, tempNode->string, strlen(tempNode->string), &Size))
					{
						Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
						OutputWidthTemp += Size.cx;
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLastLine() - Line 550"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, tempNode->string, lstrlen(tempNode->string));
					f00b4r += Size.cx;
				}
			}
		}
	}
	return;
}

void DrawLine(HWND hWnd, HDC hDC, int &AxtempCalc, unsigned long &NESPageSize, unsigned long &NESOffset,
				  int &CtimescyChar, int &HexWidth, int &specialCalc, int &tempCalc, 
				  int &OutputWidthTemp, int &hehe, int &CarryOver, int &c, SIZE &Size, int &AxtempCalcplusQ)
{
	bool WideChar = false;
	int f00b4r, floopy;
	wchar_t	converted[100],
		temp_wide[50];
	TCHAR temp[500], temp2[500];
	SIZE AddressSize;
//	RECT HoleFiller;
	static tableEntry emptyNode;
	emptyNode.string = new char[10];
	strcpy(emptyNode.string, ".");
	emptyNode.value = 0;
	int GooglyMoogly;
//	HDC hdcMem;
//	BITMAP bm;
	tableEntry* tempNode;
	wchar_t blankness[100] = { 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000 };
//	CPINFO CodePageInfo;
	SelectObject(hDC, hFontHex);
	//SetBkMode(hDC, TRANSPARENT);
	SetTextColor(hDC, AddressColor);
	SetBkColor(hDC, AddressBGColor);
	if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
	{
		if(ViewAsHiRom)
			wsprintf(temp, "%08X ", SMCToHiROM(AxtempCalc));
		else if( ViewAsLoRom)
			wsprintf(temp, "%08X ", SMCToLoROM(AxtempCalc));
		else if ( ViewAsNES )
		{
			if( (AxtempCalc / NESPageSize ) < 0xFFFF)
				wsprintf(temp, "%04X:", ( AxtempCalc ) / NESPageSize);
			else
				wsprintf(temp, "0000:");
			wsprintf(temp2, "%04X ", NEStoOffset(AxtempCalc, NESPageSize, NESOffset));
			lstrcat(temp, temp2);
		}
	}
	else if(HexOrDec == HEX)
		wsprintf(temp, "%08X ", AxtempCalc);
	else 
		wsprintf(temp, "%08i ", AxtempCalc);
	TextOut(hDC, 0 - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
	GetTextExtentPoint32(hDC, temp, strlen(temp), &AddressSize);
	/*
	if(AddressSize.cy < cyChar)
	{
		HoleFiller.left = 0 - (HorizontalOffset * cxChar );
		HoleFiller.right = AddressSize.cx - (HorizontalOffset * cxChar );
		HoleFiller.top = CtimescyChar + AddressSize.cy;
		HoleFiller.bottom = CtimescyChar + cyChar;
		FillRect(hDC, &HoleFiller, CreateSolidBrush(AddressBGColor));
	}
	*/
	//SetBkMode(hDC, OPAQUE);
	SetBkColor(hDC, WHITE);
	TextOut(hDC, AddressSize.cx - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	switch(GroupSize) {
		case 1:
			HexWidth = HexOutputByte(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 2:
			HexWidth = HexOutputWord(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 4:
			HexWidth = HexOutputInt(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc,c);
			break;
		case 8:
			HexWidth = HexOutputQWord(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc,c);
			break;
	}			
	SetBkColor(hDC, WHITE);
	TextOut(hDC, HexWidth - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	GetTextExtentPoint32(hDC, TEXT(" "), strlen(TEXT(" ")), &Size);
	HexWidth += Size.cx;
	OutputWidthTemp = HexWidth;
	SetTextColor(hDC, TextColor);
	temp[0] = 0;

	// if we are just outputting the ascii
	if(CurrentTable == -1)
	{
		if(CleanUp)
			SelectObject(hDC, hFont);
		else 
			SelectObject(hDC, CPages[CurrentCodePage].font);
		f00b4r = HexWidth;
		GooglyMoogly = CPages[CurrentCodePage].CodePageNum;
		Positions[c][16] = HexWidth;
		// text output
		for(int q = 0; q < tempCalc;q++)
		{
			WideChar = false;
			AxtempCalcplusQ = AxtempCalc + q;	
			// new version
			if(!CleanUp && IsDBCSLeadByteEx(GooglyMoogly, GetFileByte(AxtempCalcplusQ)))
			{
				wsprintf(temp, "%c%c", GetFileByte(AxtempCalcplusQ), GetFileByte(AxtempCalcplusQ + 1));
				MultiByteToWideChar(GooglyMoogly, MB_PRECOMPOSED, (const char*)temp, -1, converted, 50);	
				SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
				ExtTextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, ETO_OPAQUE, 
							NULL, converted, wcslen(converted),NULL);
				GetTextExtentPoint32W(hDC, converted, wcslen(converted), &Size);
				// we have a double byte size character here
				Positions[c][q + tempCalc + 1] = Positions[c][q + tempCalc];
				Positions[c][q + tempCalc + 2] = Positions[c][q + tempCalc] + Size.cx;
				OutputWidthTemp += Size.cx;
				q++;
				f00b4r += Size.cx;
				//MessageBoxW(NULL, converted, LPROGRAM_NAME, MB_OK);
			}
			else 
			{
				if( IsCharAlphaNumeric(GetFileByte(AxtempCalcplusQ)) || 
					( GetFileByte(AxtempCalcplusQ) == 0x20 ) || 
					 ispunct(GetFileByte(AxtempCalcplusQ)))
				{
					SetBkColor(hDC, TextBGColor);
					wsprintf(temp, "%c", GetFileByte(AxtempCalcplusQ));	
					if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
					{
						Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
						OutputWidthTemp += Size.cx;
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLine() - Line 742"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
					f00b4r += Size.cx;
				}
				else
				{			
					SetBkColor(hDC, TextBGColor);
					wsprintf(temp, ".");
					if(GetTextExtentPoint32(hDC, temp, strlen(temp), &Size))
					{
						Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
						OutputWidthTemp += Size.cx;
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLine() - Line 769"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
					f00b4r += Size.cx;
				}
			}
		}				
		if(CleanUp)
		{
			SetBkColor(hDC, WHITE);
			wsprintf(temp, "                                                 ");
			// original code
			TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), 
			CtimescyChar, temp, lstrlen(temp));	
		}
		else
		{					
			SetBkColor(hDC, WHITE);				
			ExtTextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, ETO_OPAQUE, 
						NULL, blankness, wcslen(blankness),NULL);
			SelectObject(hDC, hFont); 
		}
	}
	// if we have a table file in use
	else
	{
		floopy = Table[CurrentTable]->getWidestValue();
		SelectObject(hDC, tblFont[CurrentTable]);
		// are we using japanese?
		if(Table[CurrentTable]->getCodepage() != 1252)
		{	
			GooglyMoogly = Table[CurrentTable]->getCodepage();
			SelectObject(hDC, tblFont[CurrentTable]);
			SetBkColor(hDC, TextBGColor);
			SetTextColor(hDC, TextColor);
			f00b4r = HexWidth;
			Positions[c][16] = HexWidth;
			unsigned int checkValue = 0;
			converted[0] = 0x0000;
			for(int q = 0 + CarryOver; q < tempCalc; q++)
			{
				AxtempCalcplusQ = AxtempCalc + q;
				hehe = 0;
				checkValue = 0;
				Table[CurrentTable]->SetSubTable(Table[CurrentTable]->GetAddressSubTable(AxtempCalcplusQ));
				AxtempCalcplusQ = AxtempCalc + q;
				switch( floopy ) 
				{
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(AxtempCalcplusQ) << 24);
						AxtempCalcplusQ++;
						hehe += 1;

					case 3:
						// check for 3 byte match
						checkValue += ( GetFileByte(AxtempCalcplusQ) << 16 );
						AxtempCalcplusQ++;
						hehe += 1;

					case 2:
						// check for 2 byte match
						checkValue += ( GetFileByte(AxtempCalcplusQ) << 8 );
						AxtempCalcplusQ++;
						hehe += 1;

					default:
						checkValue += GetFileByte(AxtempCalcplusQ);
						switch( floopy ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;		
						}
						q += hehe;
				} // end of the switch

				// my attempt at adding those l33t graphics that yousei had in hexroll

				// this will be reenabled as soon as I can get bitblt to work consistently				
				if(tempNode->string == 0x00000000)
				{
					tempNode->string = new char[10];
					tempNode->string[0]='.';
					tempNode->string[1]=0;
				}
				if(!strcmp(tempNode->string, "HEXECUTE_NEWLINE"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					DrawImage(hImageList, hDC, 0, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					//ImageList_DrawEx(hImageList, 0, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					//	16,16, CLR_DEFAULT , NULL,ILD_NORMAL );
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				else if (!strcmp(tempNode->string, "HEXECUTE_ENDSTRING"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					DrawImage(hImageList, hDC, 1, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					//ImageList_DrawEx(hImageList, 1, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					//	16,16, CLR_DEFAULT , NULL,ILD_NORMAL );
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				
				// end of my leet attempt
				else
		
				{
					MultiByteToWideChar(GooglyMoogly, MB_PRECOMPOSED, (const char*)tempNode->string,
										-1, temp_wide, 50);
					wcscat(converted, temp_wide);
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					if(GetTextExtentPoint32W(hDC, temp_wide, wcslen(temp_wide), &Size))
					{
						// if we have a one byte value, I think messing this up is what
						// was causing my messed up cursor positions
						if(tempNode->value < 0x100 )
						{
							Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
							OutputWidthTemp += Size.cx;
						}
						else if(tempNode->value >= 0x100 && tempNode->value < 0x10000 )
						{
							// q has already been incremented
							Positions[c][q + 16] = Positions[c][q + 15];
							Positions[c][q + 17] = Positions[c][q + 15] + Size.cx;
							OutputWidthTemp += Size.cx;
						}
						
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLine() - Line 960"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					ExtTextOutW(hDC, f00b4r- ( HorizontalOffset * cxChar),CtimescyChar, ETO_OPAQUE,
								NULL,temp_wide, wcslen(temp_wide),NULL);
					f00b4r += Size.cx;
				}
			}
			//swprintf(temp_wide, blankness);
			SetBkColor(hDC, 0x00FFFFFF);
			ExtTextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, 
						ETO_OPAQUE, NULL,blankness, wcslen(blankness), NULL);
			if(q >= tempCalc)
				CarryOver = q - tempCalc;

		}
		// or are we using english?
		else if (Table[CurrentTable]->getCodepage() == 1252)
		{
			SelectObject(hDC, hFont);
			SetBkColor(hDC, TextBGColor);
			SetTextColor(hDC, TextColor);
			f00b4r = HexWidth;
			SelectObject(hDC, tblFont[CurrentTable]);
			for(int q = 0 + CarryOver; q < tempCalc;q++)
			{
				AxtempCalcplusQ = AxtempCalc + q;
				Table[CurrentTable]->SetSubTable(Table[CurrentTable]->GetAddressSubTable(AxtempCalcplusQ));
				hehe = 0;
				unsigned int checkValue = 0;
				AxtempCalcplusQ = AxtempCalc + q;
				switch( floopy ) {
					case 4:
						// check for 4 byte value
						checkValue += (GetFileByte(AxtempCalcplusQ) << 24);
						AxtempCalcplusQ++;
						hehe += 1;

					case 3:
						// check for 3 byte match
						checkValue += ( GetFileByte(AxtempCalcplusQ) << 16 );
						AxtempCalcplusQ++;
						hehe += 1;

					case 2:
						// check for 2 byte match
						checkValue += ( GetFileByte(AxtempCalcplusQ) << 8 );
						AxtempCalcplusQ++;
						hehe += 1;

						// again fall through
					default:
						checkValue += GetFileByte(AxtempCalcplusQ);
						switch( floopy ) {
							case 4:
								tempNode = Table[CurrentTable]->getNode32(checkValue);
								if(tempNode != NULL)
									break;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
								hehe--;
							case 3:
								tempNode = Table[CurrentTable]->getNode24(checkValue);													
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							case 2:
								tempNode = Table[CurrentTable]->getNode16(checkValue);
								if(tempNode != NULL)
									break;
								hehe--;
								checkValue &= 0xFFFFFF00;
								checkValue >>= 8;
							default:
								tempNode = Table[CurrentTable]->getNode8(checkValue);
								if(tempNode != NULL)
									break;
								tempNode = &emptyNode;
						}
						q += hehe;
				}
				// my attempt at adding those l33t graphics that yousei had in hexroll
				if(tempNode->string == 0x00000000)
				{
					tempNode->string = new char[10];
					tempNode->string[0]='.';
					tempNode->string[1]=0;
				}
				if(!strcmp(tempNode->string, "HEXECUTE_NEWLINE"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					DrawImage(hImageList, hDC, 0, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					//ImageList_DrawEx(hImageList, 0, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					//	16,16, CLR_DEFAULT , NULL,ILD_NORMAL );
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				else if (!strcmp(tempNode->string, "HEXECUTE_ENDSTRING"))
				{
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					DrawImage(hImageList, hDC, 1, HighlightColor, HexBGColor, AxtempCalc, q, f00b4r,CtimescyChar);
					//ImageList_DrawEx(hImageList, 1, hDC, f00b4r - (HorizontalOffset * cxChar), CtimescyChar, 
					//	16,16, CLR_DEFAULT , NULL,ILD_NORMAL );
					Positions[c][q + 16 + 1] = Positions[c][q + 16] + 16; // width of the bitmap
					OutputWidthTemp += 16;
					f00b4r += 16;
				}
				
				// end of my leet attempt
				else

				{
					_tcscpy(temp, (const TCHAR*)tempNode->string);
					if( q ==  ( 0 + CarryOver ) )  // that makes this the first character on the line
						Positions[c][q + 16] = HexWidth;
					if(GetTextExtentPoint32(hDC, tempNode->string, strlen(tempNode->string), &Size))
					{
						Positions[c][q + 16 + 1] = Positions[c][q + 16] + Size.cx;
						OutputWidthTemp += Size.cx;
					}
					else MessageBox(hWnd, TEXT("BOOM - DrawLine() - Line 1119"), PROGRAM_NAME, MB_OK);
					SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q);
					TextOut(hDC, f00b4r- ( HorizontalOffset * cxChar), CtimescyChar, tempNode->string, lstrlen(tempNode->string));
					f00b4r += Size.cx;
				}
			}
			SetBkColor(hDC, WHITE);
			//SetBkColor(hDC,TextBGColor);
			wsprintf(temp, "                                                 ");
			TextOut(hDC, f00b4r - ( HorizontalOffset * cxChar), 
			CtimescyChar, temp, lstrlen(temp));	
			if(q >= tempCalc)
				CarryOver = q - tempCalc;
		}
	}
//#ifdef _DEBUG
//	MessageBox(hWnd, TEXT("Exiting DrawLine()"), PROGRAM_NAME, MB_OK);
//#endif
	return ;
}

void DrawLineUnicode(HWND hWnd, HDC hDC, int &AxtempCalc, unsigned long &NESPageSize, unsigned long &NESOffset,
				  int &CtimescyChar, int &HexWidth, int &specialCalc, int &tempCalc, 
				  int &OutputWidthTemp, int &hehe, int &CarryOver, int &c, SIZE &Size, int &AxtempCalcplusQ)
{
	bool WideChar = false;
	int f00b4r/*, floopy*/;
	wchar_t	/*converted[100],*/ hoser,
		temp_wide[50];
	TCHAR temp[500], temp2[500];
	SIZE AddressSize;
//	RECT HoleFiller;
	int /*GooglyMoogly,*/ KoreWaHonDesu = AxtempCalc / 2, gaijin = tempCalc / 2, boohoo;
//	HDC hdcMem;
//	BITMAP bm;
	static tableEntry emptyNode;
	emptyNode.string = new char[10];
	strcpy(emptyNode.string, ".");
	emptyNode.value = 0;
//	tableEntry* tempNode;
	wchar_t blankness[100] = { 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000 };
//	CPINFO CodePageInfo;
	SelectObject(hDC, hFontHex);
	//SetBkMode(hDC, TRANSPARENT);
	SetTextColor(hDC, AddressColor);
	SetBkColor(hDC, AddressBGColor);
	if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
	{
		if(ViewAsHiRom)
			wsprintf(temp, "%08X ", SMCToHiROM(AxtempCalc));
		else if( ViewAsLoRom)
			wsprintf(temp, "%08X ", SMCToLoROM(AxtempCalc));
		else if ( ViewAsNES )
		{
			if( (AxtempCalc / NESPageSize ) < 0xFFFF)
				wsprintf(temp, "%04X:", ( AxtempCalc ) / NESPageSize);
			else
				wsprintf(temp, "0000:");
			wsprintf(temp2, "%04X ", NEStoOffset(AxtempCalc, NESPageSize, NESOffset));
			lstrcat(temp, temp2);
		}
	}
	else if(HexOrDec == HEX)
		wsprintf(temp, "%08X ", AxtempCalc);
	else 
		wsprintf(temp, "%08i ", AxtempCalc);
	TextOut(hDC, 0 - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
	GetTextExtentPoint32(hDC, temp, strlen(temp), &AddressSize);
	SetBkColor(hDC, WHITE);
	TextOut(hDC, AddressSize.cx - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	switch(GroupSize) {
		case 1:
			HexWidth = HexOutputByte(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 2:
			HexWidth = HexOutputWord(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 4:
			HexWidth = HexOutputInt(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc,c);
			break;
		case 8:
			HexWidth = HexOutputQWord(hDC, tempCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc,c);
			break;
	}			
	SetBkColor(hDC, WHITE);
	TextOut(hDC, HexWidth - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	GetTextExtentPoint32(hDC, TEXT(" "), strlen(TEXT(" ")), &Size);
	HexWidth += Size.cx;
	OutputWidthTemp = HexWidth;
	SetTextColor(hDC, TextColor);
	temp[0] = 0;

	SelectObject(hDC, hFontUnicode);
	f00b4r = HexWidth;
	Positions[c][16] = HexWidth;
	// text output
	boohoo = 0;
	for(int q = 0; q < gaijin ;q++)
	{

		WideChar = false;
		AxtempCalcplusQ = KoreWaHonDesu + q;	
		// new version
		if(!BigEndian)
		{
			hoser = GetUnicodeFileByte(AxtempCalcplusQ);
//			if( IsCharAlphaNumericW(hoser) || 
//				( hoser == 0x0020 ) || 
//				 iswpunct(hoser))
			{
				SetBkColor(hDC, TextBGColor);
				swprintf(temp_wide, L"%c", hoser);	
				if(GetTextExtentPoint32W(hDC, temp_wide, wcslen(temp_wide), &Size))
				{
					Positions[c][boohoo + tempCalc + 1] = Positions[c][boohoo + tempCalc];
					Positions[c][boohoo + tempCalc + 2] = Positions[c][boohoo + tempCalc] + Size.cx;
					OutputWidthTemp += Size.cx;
				}
				else MessageBox(hWnd, TEXT("BOOM - DrawLineUnicode() - Line 1264"), PROGRAM_NAME, MB_OK);
				// TEST ON q*2
				SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q*2);
				TextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp_wide, lstrlenW(temp_wide));
				f00b4r += Size.cx;
			}
		}
		else
		{
			hoser = MakeUnicodeBigEndian(GetUnicodeFileByte(AxtempCalcplusQ));
//			if( IsCharAlphaNumericW(hoser) || 
//				( hoser == 0x0020 ) || 
//				 iswpunct(hoser))
			{
				SetBkColor(hDC, TextBGColor);
				swprintf(temp_wide, L"%c", hoser);	
				if(GetTextExtentPoint32W(hDC, temp_wide, wcslen(temp_wide), &Size))
				{
					Positions[c][boohoo + tempCalc + 1] = Positions[c][boohoo + tempCalc];
					Positions[c][boohoo + tempCalc + 2] = Positions[c][boohoo + tempCalc] + Size.cx;
					OutputWidthTemp += Size.cx;
				}
				else MessageBox(hWnd, TEXT("BOOM- DrawLineUnicode() - Line 1328"), PROGRAM_NAME, MB_OK);
				SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q*2);
				TextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp_wide, lstrlenW(temp_wide));
				f00b4r += Size.cx;
			}
		}
		boohoo += 2;
	}		
	SetBkColor(hDC, WHITE);
	swprintf(temp_wide, L"                                                 ");
	// original code
	TextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), 
	CtimescyChar, temp_wide, lstrlenW(temp_wide));	
	return;
}

void DrawLastLineUnicode(HWND hWnd, HDC hDC, int &AxtempCalc, unsigned long &NESPageSize, unsigned long &NESOffset,
				  int &CtimescyChar, int &HexWidth, int &specialCalc, int &tempCalc, 
				  int &OutputWidthTemp, int &hehe, int &CarryOver, int &c, SIZE &Size, int &AxtempCalcplusQ)
{
	bool WideChar = false;
	int f00b4r/*, floopy*/;
	wchar_t	/*converted[100],*/ hoser,
		temp_wide[50];
	TCHAR temp[500], temp2[500];
	SIZE AddressSize;
//	RECT HoleFiller;
	int /*GooglyMoogly,*/ KoreWaHonDesu = AxtempCalc / 2, gaijin = specialCalc / 2, boohoo;
//	HDC hdcMem;
//	BITMAP bm;
	static tableEntry emptyNode;
	emptyNode.string = new char[10];
	strcpy(emptyNode.string, ".");
	emptyNode.value = 0;
//	tableEntry* tempNode;
	wchar_t blankness[100] = { 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 
							  0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000 };
//	CPINFO CodePageInfo;
	SelectObject(hDC, hFontHex);
	//SetBkMode(hDC, TRANSPARENT);
	SetTextColor(hDC, AddressColor);
	SetBkColor(hDC, AddressBGColor);
	if(ViewAsHiRom || ViewAsLoRom || ViewAsNES)
	{
		if(ViewAsHiRom)
			wsprintf(temp, "%08X ", SMCToHiROM(AxtempCalc));
		else if( ViewAsLoRom)
			wsprintf(temp, "%08X ", SMCToLoROM(AxtempCalc));
		else if ( ViewAsNES )
		{
			if( (AxtempCalc / NESPageSize ) < 0xFFFF)
				wsprintf(temp, "%04X:", ( AxtempCalc ) / NESPageSize);
			else
				wsprintf(temp, "0000:");
			wsprintf(temp2, "%04X ", NEStoOffset(AxtempCalc, NESPageSize, NESOffset));
			lstrcat(temp, temp2);
		}
	}
	else if(HexOrDec == HEX)
		wsprintf(temp, "%08X ", AxtempCalc);
	else 
		wsprintf(temp, "%08i ", AxtempCalc);
	TextOut(hDC, 0 - ( HorizontalOffset * cxChar), CtimescyChar, temp, lstrlen(temp));
	GetTextExtentPoint32(hDC, temp, strlen(temp), &AddressSize);
	SetBkColor(hDC, WHITE);
	TextOut(hDC, AddressSize.cx - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	switch(GroupSize) {
		case 1:
			HexWidth = HexOutputByte(hDC, specialCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 2:
			HexWidth = HexOutputWord(hDC, specialCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc, c);
			break;
		case 4:
			HexWidth = HexOutputInt(hDC, specialCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc,c);
			break;
		case 8:
			HexWidth = HexOutputQWord(hDC, specialCalc, OddColumnColor, EvenColumnColor,
						HighlightColor, HexBGColor, AxtempCalc, startHighlight, 
						endHighlight, cyChar, cxChar, CtimescyChar, tempCalc,c);
			break;
	}			
	SetBkColor(hDC, WHITE);
	TextOut(hDC, HexWidth - ( HorizontalOffset * cxChar), CtimescyChar, " ", lstrlen(" "));
	GetTextExtentPoint32(hDC, TEXT(" "), strlen(TEXT(" ")), &Size);
	HexWidth += Size.cx;
	OutputWidthTemp = HexWidth;
	SetTextColor(hDC, TextColor);
	temp[0] = 0;

	SelectObject(hDC, hFontUnicode);
	f00b4r = HexWidth;
	Positions[c][16] = HexWidth;
	// text output
	boohoo = 0;
	for(int q = 0; q < gaijin ;q++)
	{
		WideChar = false;
		AxtempCalcplusQ = KoreWaHonDesu + q;	
		// new version
		if(!BigEndian)
		{
			hoser = GetUnicodeFileByte(AxtempCalcplusQ);
//			if( IsCharAlphaNumericW(hoser) || 
//				( hoser == 0x0020 ) || 
//				 iswpunct(hoser))
			{
				SetBkColor(hDC, TextBGColor);
				swprintf(temp_wide, L"%c", hoser);	
				if(GetTextExtentPoint32W(hDC, temp_wide, wcslen(temp_wide), &Size))
				{
					Positions[c][boohoo + tempCalc + 1] = Positions[c][boohoo + tempCalc];
					Positions[c][boohoo + tempCalc + 2] = Positions[c][boohoo + tempCalc] + Size.cx;
					OutputWidthTemp += Size.cx;
				}
				else MessageBox(hWnd, TEXT("BOOM - DrawLastLineUnicode() - Line 1496"), PROGRAM_NAME, MB_OK);
				SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q*2);
				TextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp_wide, lstrlenW(temp_wide));
				f00b4r += Size.cx;
			}
		}
		else
		{
			hoser = MakeUnicodeBigEndian(GetUnicodeFileByte(AxtempCalcplusQ));
//			if( IsCharAlphaNumericW(hoser) || 
//				( hoser == 0x0020 ) || 
//				 iswpunct(hoser))
			{
				SetBkColor(hDC, TextBGColor);
				swprintf(temp_wide, L"%c", hoser);	
				if(GetTextExtentPoint32W(hDC, temp_wide, wcslen(temp_wide), &Size))
				{
					Positions[c][boohoo + tempCalc + 1] = Positions[c][boohoo + tempCalc];
					Positions[c][boohoo + tempCalc + 2] = Positions[c][boohoo + tempCalc] + Size.cx;
					OutputWidthTemp += Size.cx;
				}
				else MessageBox(hWnd, TEXT("BOOM- DrawLastLineUnicode() - Line 1558"), PROGRAM_NAME, MB_OK);
				SetColors(hDC, HighlightColor, TextBGColor, TextColor, HighlightTextColor, AxtempCalc, q*2);
				TextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), CtimescyChar, temp_wide, lstrlenW(temp_wide));
				f00b4r += Size.cx;
			}
		}
		boohoo += 2;
	}		
	SetBkColor(hDC, WHITE);
	swprintf(temp_wide, L"                                                 ");
	// original code
	TextOutW(hDC, f00b4r - ( HorizontalOffset * cxChar), 
	CtimescyChar, temp_wide, lstrlenW(temp_wide));	
	return;
}