/*
 * Hexecute 3.0
 * Registry.cpp
 * copyright 2000 Mike Walston
 * 
 * the registry stuff
 */


#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

int InitializeFromRegistry()
{
	MENUITEMINFO mii;
	mii.cbSize = sizeof(MENUITEMINFO);
	mii.fType = MFT_STRING;          
	mii.fState = MFS_ENABLED;          
	mii.fMask = MIIM_TYPE | MIIM_ID | MIIM_STATE;

	static bool FirstTime = true;
	// registry stuff
	DWORD Status;
	DWORD Type;
	DWORD Size;
	DWORD localData;
	char localString[MAX_PATH], localString2[_MAX_PATH];
	HKEY hKeyNames, hKeyCodePageNames;
	HMENU MenuTemp;
	MenuTemp = GetSubMenu(HexecuteMenu, 0);

	// get the registry keys
	Status = RegOpenKeyEx(HKEY_CURRENT_USER, HexecuteAppKey, 0l, KEY_READ, &hKeyNames);
	if (Status == ERROR_SUCCESS)
	{
		Size = sizeof(GroupSize);
		Status = RegQueryValueEx(hKeyNames, SizeKey, NULL, &Type, (LPBYTE)&localData, &Size);
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			GroupSize = localData;

		Size = sizeof(AddressColor);
		Status = RegQueryValueEx(hKeyNames, AddressColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			AddressColor = localData;

		Status = RegQueryValueEx(hKeyNames, AddressBGColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			AddressBGColor = localData;

		Status = RegQueryValueEx(hKeyNames, OddColumnColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			OddColumnColor = localData;

		Status = RegQueryValueEx(hKeyNames, EvenColumnColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			EvenColumnColor = localData;

		Status = RegQueryValueEx(hKeyNames, HexBGColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			HexBGColor = localData;

		Status = RegQueryValueEx(hKeyNames, HighlightColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			HighlightColor = localData;

		Status = RegQueryValueEx(hKeyNames, TextColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			TextColor = localData;

		Status = RegQueryValueEx(hKeyNames, TextBGColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
		{
			TextBGColor = localData;
			ImageList_SetBkColor(hImageList, TextBGColor);
		}

		/*
		Status = RegQueryValueEx(hKeyNames, NumRecentFilesKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			NumRecentFiles = localData;
		*/
		Status = RegQueryValueEx(hKeyNames, HighlightTextColorKey, NULL, &Type, (LPBYTE)&localData, &Size );
		if(Status == ERROR_SUCCESS && Type == REG_DWORD)
			HighlightTextColor = localData;
		/*
		if(NumRecentFiles > 0)
		{
			// the first recent file
			Size = MAX_PATH;
			Status = RegQueryValueEx(hKeyNames, RecentFile0Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFile0 = new TCHAR[MAX_PATH];
				_tcscpy(RecentFile0, localString);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFileTitle0", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFile0 = new TCHAR[1];
				RecentFile0[0] = 0x00;
			}

			Status = RegQueryValueEx(hKeyNames, RecentFileTitle0Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFileTitle0 = new TCHAR[MAX_PATH];
				_tcscpy(RecentFileTitle0, localString);
				mii.wID = IDM_RECENT_FILE0;
				mii.dwTypeData = RecentFileTitle0;
				InsertMenuItem(MenuTemp, (UINT)-1, TRUE, &mii);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFileTitle0", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFileTitle0 = new TCHAR[1];
				RecentFileTitle0[0] = 0x00;
			}
		}

		// the second recent file
		if(NumRecentFiles > 1)
		{
			Size = MAX_PATH;
			Status = RegQueryValueEx(hKeyNames, RecentFile1Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFile1 = new TCHAR[strlen(localString) + 1];
				_tcscpy(RecentFile1, localString);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFile1", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFile1 = new TCHAR[1];
				RecentFile1[0] = 0x00;
			}
			Status = RegQueryValueEx(hKeyNames, RecentFileTitle1Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFileTitle1 = new char[strlen(localString) + 1];
				_tcscpy(RecentFileTitle1, localString);
				mii.wID = IDM_RECENT_FILE1;
				mii.dwTypeData = RecentFileTitle1;
				InsertMenuItem(MenuTemp, (UINT)-1, TRUE, &mii);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFileTitle1", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFileTitle1 = new char[1];
				RecentFileTitle1[0] = 0x00;
			}			
		}

		// the third recent file
		if(NumRecentFiles > 2)
		{
			Size = MAX_PATH;
			Status = RegQueryValueEx(hKeyNames, RecentFile2Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFile2 = new char[strlen(localString) + 1];
				_tcscpy(RecentFile2, localString);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFile2", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFile2 = new char[1];
				RecentFile2[0] = 0x00;
			}


			Status = RegQueryValueEx(hKeyNames, RecentFileTitle2Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFileTitle2 = new char[strlen(localString) + 1];
				_tcscpy(RecentFileTitle2, localString);
				mii.wID = IDM_RECENT_FILE2;
				mii.dwTypeData = RecentFileTitle2;
				InsertMenuItem(MenuTemp, (UINT)-1, TRUE, &mii);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFileTitle2", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFileTitle2 = new char[1];
				RecentFileTitle2[0] = 0x00;
			}
		}

		// the fourth recent file
		if(NumRecentFiles > 3)
		{
			Size = MAX_PATH;
			Status = RegQueryValueEx(hKeyNames, RecentFile3Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFile3 = new char[strlen(localString) + 1];
				_tcscpy(RecentFile3, localString);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFile2", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFile3 = new char[1];
				RecentFile3[0] = 0x00;
			}

			Status = RegQueryValueEx(hKeyNames, RecentFileTitle3Key, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				RecentFileTitle3 = new char[strlen(localString) + 1];
				_tcscpy(RecentFileTitle3, localString);
				mii.wID = IDM_RECENT_FILE3;
				mii.dwTypeData = RecentFileTitle3;
				InsertMenuItem(MenuTemp, (UINT)-1, TRUE, &mii);
			}
			else 
			{
				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, Status, NULL, localString, MAX_PATH, NULL);
				wsprintf(localString2, "%s - RecentFileTitle3", PROGRAM_NAME);
				MessageBox(hWndData, localString, localString2, MB_OK);
				RecentFileTitle3 = new char[1];
				RecentFileTitle3[0] = 0x00;
			}
		}
		*/
	}

	// get the registry keys
	Status = RegOpenKeyEx(HKEY_CURRENT_USER, CodePagesKey, 0l, KEY_READ, &hKeyCodePageNames);
	{
			Status = RegQueryValueEx(hKeyCodePageNames, AllowPagingKey, NULL, &Type, (unsigned char*)localString, &Size);
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				sscanf(localString, "%d", &AllowPaging);
			}

			Status = RegQueryValueEx(hKeyCodePageNames, ShowSplashKey, NULL, &Type, (unsigned char*)localString, &Size);
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				sscanf(localString, "%d", &ShowSplash);
			}
			
			Status = RegQueryValueEx(hKeyCodePageNames, CurrentCodePageKey, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
			{
				sscanf(localString, "%d", &CurrentCodePage);
				if(CurrentCodePage == -1)
				{
					CurrentCodePage = 0;
					CleanUp = 1;
				}
				else
					CleanUp = 0;
			}			


			Size = 50;
			Status = RegQueryValueEx(hKeyCodePageNames, HexFontKey, NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
				_tcscpy(HexFontName, localString);

			Size = MAX_PATH;;
			Type = REG_SZ;
			
			Status = RegQueryValueEx(hKeyCodePageNames, "FontSize", NULL, &Type, (unsigned char*)localString, &Size );
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
				sscanf(localString, "%d", &FontHeight);		
			
			Size = MAX_PATH;
			Type = REG_SZ;
			for( int p = 0; p < InstalledPage; p++)
			{
				wsprintf(localString, "%d", CPages[p].CodePageNum);
				Status = RegQueryValueEx(hKeyCodePageNames, localString, NULL, &Type, (unsigned char*)localString2, &Size );
				if(Status == ERROR_SUCCESS && Type == REG_SZ)
					_tcscpy(	CPages[p].FontName, localString2);
			}
			Status =  RegQueryValueEx(hKeyCodePageNames, "1252", 0, &Type, (LPBYTE)localString,  &Size);
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
				_tcscpy(FontName, localString);			
			Size = MAX_PATH;
			Type = REG_SZ;
			Status =  RegQueryValueEx(hKeyCodePageNames, UnicodeFontKey, 0, &Type, (LPBYTE)localString,  &Size);
			if(Status == ERROR_SUCCESS && Type == REG_SZ)
				_tcscpy(UnicodeFontName, localString);	
	}
	if(FirstTime)
	{
		EnumSystemCodePages(CodePagesProc, CP_INSTALLED);
		FirstTime = false;
	}
	return 0;
}

int SaveSettingsToRegistry()
{
	// registry stuff
	DWORD Status;
	DWORD Type;
	DWORD dwDisposition; 
	char localString[MAX_PATH], localString2[_MAX_PATH];
	HKEY hKeyNames, hKeyCodePageNames;

	Status = RegCreateKeyEx(HKEY_CURRENT_USER, HexecuteAppKey, 0L,
		NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS | KEY_WRITE,
		NULL, &hKeyNames, &dwDisposition) ;
	// if it has been created before, then open it    
	if (dwDisposition == REG_OPENED_EXISTING_KEY)       
	{       
		Status = RegOpenKeyEx(HKEY_CURRENT_USER, HexecuteAppKey, 0L,          
			KEY_WRITE, &hKeyNames) ;       
	}
	if(Status == ERROR_SUCCESS) {
		Status = RegSetValueEx(hKeyNames, SizeKey, 0,
			REG_DWORD, (LPBYTE)&GroupSize, sizeof(GroupSize));
		Status = RegSetValueEx(hKeyNames, AddressColorKey, 0,
			REG_DWORD, (LPBYTE)&AddressColor, sizeof(AddressColor));
		Status = RegSetValueEx(hKeyNames, AddressBGColorKey, 0,
			REG_DWORD, (LPBYTE)&AddressBGColor, sizeof(AddressBGColor));
		Status = RegSetValueEx(hKeyNames, OddColumnColorKey, 0,
			REG_DWORD, (LPBYTE)&OddColumnColor, sizeof(OddColumnColor));
		Status = RegSetValueEx(hKeyNames, EvenColumnColorKey, 0,
			REG_DWORD, (LPBYTE)&EvenColumnColor, sizeof(EvenColumnColor));
		Status = RegSetValueEx(hKeyNames, HexBGColorKey, 0,
			REG_DWORD, (LPBYTE)&HexBGColor, sizeof(HexBGColor));
		Status = RegSetValueEx(hKeyNames, HighlightColorKey, 0,
			REG_DWORD, (LPBYTE)&HighlightColor, sizeof(HighlightColor));
		Status = RegSetValueEx(hKeyNames, TextColorKey, 0,
			REG_DWORD, (LPBYTE)&TextColor, sizeof(TextColor));
		Status = RegSetValueEx(hKeyNames, TextBGColorKey, 0,
			REG_DWORD, (LPBYTE)&TextBGColor, sizeof(TextBGColor));
			/*
		Status = RegSetValueEx(hKeyNames, NumRecentFilesKey, 0,
			REG_DWORD, (LPBYTE)&NumRecentFiles, sizeof(NumRecentFiles));
			*/
		Status = RegSetValueEx(hKeyNames, HighlightTextColorKey, 0,
			REG_DWORD, (LPBYTE)&HighlightTextColor, sizeof(HighlightTextColor));

		Type = REG_SZ;
		/*
		if(NumRecentFiles > 0)
		{
			if ( RegSetValueEx(hKeyNames, RecentFile0Key, 0, Type, (LPBYTE)RecentFile0, (lstrlen(RecentFile0) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFile0Key was not able to be written"), PROGRAM_NAME, MB_OK);
			if ( RegSetValueEx(hKeyNames, RecentFileTitle0Key, 0, Type, (LPBYTE)RecentFileTitle0, ( lstrlen(RecentFileTitle0) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFileTitle0Key was not able to be written"), PROGRAM_NAME, MB_OK);
		}
		if(NumRecentFiles > 1)
		{
			if ( RegSetValueEx(hKeyNames, RecentFile1Key, 0, Type, (LPBYTE)RecentFile1, (lstrlen(RecentFile1) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFile1Key was not able to be written"), PROGRAM_NAME, MB_OK);
			if ( RegSetValueEx(hKeyNames, RecentFileTitle1Key, 0, Type, (LPBYTE)RecentFileTitle1, ( lstrlen(RecentFileTitle1) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFileTitle1Key was not able to be written"), PROGRAM_NAME, MB_OK);
		}
		if(NumRecentFiles > 2)
		{
			if( RegSetValueEx(hKeyNames, RecentFile2Key, 0, Type, (LPBYTE)RecentFile2, (lstrlen(RecentFile2) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFile2Key was not able to be written"), PROGRAM_NAME, MB_OK);
			if( RegSetValueEx(hKeyNames, RecentFileTitle2Key, 0, Type, (LPBYTE)RecentFileTitle2,(lstrlen(RecentFileTitle2) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFileTitle2Key was not able to be written"), PROGRAM_NAME, MB_OK);
		}
		if(NumRecentFiles > 3)
		{
			if( RegSetValueEx(hKeyNames, RecentFile3Key, 0, Type, (LPBYTE)RecentFile3, (lstrlen(RecentFile3) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS )
				MessageBox(hWndData, TEXT("RecentFile3Key was not able to be written"), PROGRAM_NAME, MB_OK);
			if ( RegSetValueEx(hKeyNames, RecentFileTitle3Key, 0, Type, (LPBYTE)RecentFileTitle3,(lstrlen(RecentFileTitle3) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("RecentFileTitle3Key was not able to be written"), PROGRAM_NAME, MB_OK);
		}
		*/
	}
	RegCloseKey(hKeyNames);

	// these are the keys related to fonts and code pages
	/*
	 * what I'm going to do to hold fonts
	 * for the various code pages is that
	 * the code page itself will be used as
	 * the Registry key name and the font will
	 * be a REG_SZ value in the format of %s %d
	 * for sscanf
	 */

	Status = RegCreateKeyEx(HKEY_CURRENT_USER, CodePagesKey, 0L,
		NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS | KEY_WRITE,
		NULL, &hKeyCodePageNames, &dwDisposition) ;
  
	if (dwDisposition == REG_OPENED_EXISTING_KEY)       
	{       
		Status = RegOpenKeyEx(HKEY_CURRENT_USER, CodePagesKey, 0L,          
			KEY_WRITE, &hKeyCodePageNames) ;       
	}
	if(Status == ERROR_SUCCESS) 
	{
			Type = REG_SZ;

			if(CleanUp)
			{	
				CurrentCodePage = -1;
			}

			wsprintf(localString, "%d", AllowPaging);
			if( RegSetValueEx(hKeyCodePageNames, AllowPagingKey, 0, Type, (LPBYTE)localString, ( lstrlen(localString) + 1)) != ERROR_SUCCESS )
				MessageBox(hWndData, TEXT("AllowPaging was not able to be written"), PROGRAM_NAME, MB_OK);

			wsprintf(localString, "%d", ShowSplash);
			if( RegSetValueEx(hKeyCodePageNames, ShowSplashKey, 0, Type, (LPBYTE)localString,( lstrlen(localString) + 1 )) != ERROR_SUCCESS )
				MessageBox(hWndData, TEXT("ShowSplash was not able to be written"), PROGRAM_NAME, MB_OK);

			wsprintf(localString, "%d", CurrentCodePage);
			if( RegSetValueEx(hKeyCodePageNames, CurrentCodePageKey, 0, Type, (LPBYTE)localString,( lstrlen(localString) + 1 )) != ERROR_SUCCESS )
				MessageBox(hWndData, TEXT("CurrentCodePageKey was not able to be written"), PROGRAM_NAME, MB_OK);

			wsprintf(localString, "%s", HexFontName);
			if( RegSetValueEx(hKeyCodePageNames, HexFontKey, 0, Type, (LPBYTE)localString, (lstrlen(localString) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS )
				MessageBox(hWndData, TEXT("HexFontKey was not able to be written"), PROGRAM_NAME, MB_OK);
			wsprintf(localString, FontName);
			if( RegSetValueEx(hKeyCodePageNames, "1252", 0, Type, (LPBYTE)localString, (lstrlen(localString) + 1 ) * sizeof(TCHAR)) != ERROR_SUCCESS )
				MessageBox(hWndData, TEXT("1252 was not able to be written"), PROGRAM_NAME, MB_OK);			
			
			Type = REG_SZ;
			wsprintf(localString, "%d", FontHeight);
			if( RegSetValueEx(hKeyCodePageNames, "FontSize", 0, Type, (LPBYTE)localString, ( lstrlen(localString) + 1 ) ) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("FontSize was not able to be written"), PROGRAM_NAME, MB_OK);			

			if( RegSetValueEx(hKeyCodePageNames, UnicodeFontKey, 0, Type, (LPBYTE)&UnicodeFontName, ( lstrlen(UnicodeFontName) + 1 ) ) != ERROR_SUCCESS)
				MessageBox(hWndData, TEXT("UnicodeFontKey was not able to be written"), PROGRAM_NAME, MB_OK);			
			

			Type = REG_SZ;
			for( int p = 0; p < InstalledPage; p++)
			{
				wsprintf(localString, "%d", CPages[p].CodePageNum);
				if( RegSetValueEx(hKeyCodePageNames, 
									   localString, 
									   NULL, 
									   Type, 
									   (unsigned char*)CPages[p].FontName, 
									   lstrlen(CPages[p].FontName) ) != ERROR_SUCCESS )
				{
					wsprintf(localString2, TEXT("Could not write %s to key %s"), CPages[p].FontName, localString);
					MessageBox(hWndData, localString2, PROGRAM_NAME, MB_OK);
				}
			}	
	}
	return 0;
}