/*
 * Hexecute 3.0
 * ResizeWindows.cpp
 * copyright 2000 Mike Walston
 *
 * This is the code that resizes all the windows in the main window
 */
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

bool OverWrite = true;

void ResizeWindows(HWND hWnd, HWND hWndData, HWND StatusBar, HWND hWndToolBar, int StatusBarShow, int ToolBarShow) {
	int DataWindowTop, 	StatusBarParts[7];
	//miscellaneous
	RECT rect, sbRect;
	HDC hdcStatus;
	TEXTMETRIC tm;

	fmemzero(rect, SIZE rect);
	fmemzero(sbRect, SIZE sbRect);
	GetClientRect(hWnd, &rect);
	GetClientRect(StatusBar, &sbRect);

	if (ToolBarShow)
	{
		DataWindowTop = 28;
		ShowWindow(hWndToolBar, SW_SHOW);
		MoveWindow(hWndToolBar, 0,0, rect.right, 0, TRUE);
	}
	else 
	{
		ShowWindow(hWndToolBar, SW_HIDE);
		DataWindowTop = 0;
	}

	if (StatusBarShow) {
		hdcStatus = GetDC(StatusBar);
		GetTextMetrics(hdcStatus, &tm);
		ReleaseDC(StatusBar, hdcStatus);
		StatusBarParts[0] = tm.tmAveCharWidth * 11;
		StatusBarParts[1] = rect.right - ( tm.tmAveCharWidth * 48 );
		StatusBarParts[2] = rect.right - ( tm.tmAveCharWidth * 31 );
		StatusBarParts[3] = rect.right - ( tm.tmAveCharWidth * 14 );
		StatusBarParts[4] = rect.right - ( tm.tmAveCharWidth * 10 );
		StatusBarParts[5] = rect.right - ( tm.tmAveCharWidth * 6 );
		StatusBarParts[6] = -1;		
		SendMessage(StatusBar, SB_SETPARTS, 7, (LPARAM)StatusBarParts);
		if (IsPagingOn)
			OverWrite = true;
		if (OverWrite)
			SendMessage(StatusBar, SB_SETTEXT, 4, (LPARAM)"OVR");
		else
			SendMessage(StatusBar, SB_SETTEXT, 4, (LPARAM)"INS");
		// resize the status bar
		ShowWindow(StatusBar, SW_SHOW);
		MoveWindow(StatusBar, 0, rect.bottom - sbRect.bottom, rect.right, 20, TRUE);
		//resize the MDI Frame
		MoveWindow(hWndData, 0, DataWindowTop, rect.right, rect.bottom - DataWindowTop - sbRect.bottom, TRUE);
	} else { // remove the status bar
		ShowWindow(StatusBar, SW_HIDE);
		//MoveWindow (StatusBar, 0, rect.bottom, 0,0, TRUE);
		//resize the MDI Frame to take up the whole window
		MoveWindow(hWndData, 0, DataWindowTop, rect.right, rect.bottom - DataWindowTop, TRUE);
	}
	// send the WM_SIZE message to the mdi frame
	SendMessage(hWndData, WM_SIZE, 0, 0);
}