/*
 * Hexecute 3.0
 * SaveWork.cpp
 * copyright 2000 Mike Walston
 *
 * This code is what is called when New File and Open File
 * are used while a file is already opened
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

int SaveWork(HWND hWnd)
{
	std::fstream floop;
	FILE* kanji;
	TCHAR temp[MAX_PATH];
	TCHAR* Caption;
	OPENFILENAME ofn;
	LPTSTR path = (LPTSTR)malloc(_MAX_PATH * sizeof(TCHAR)); 
	_tcscpy((TCHAR*)path, TEXT(""));
	int Result = MessageBox(hWnd, "Would you like to save your current work?\nPress cancel to return to current file.",
               					    PROGRAM_NAME, MB_YESNOCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON1	);;
	Caption = new TCHAR[MAX_PATH];
	int a = 0;

	// let's do what we need based on the return value of MessageBox
	switch(Result) {
		// we'll save the file then move on to opening a new one
		case IDYES:
			ZeroMemory(&ofn, sizeof(OPENFILENAME));
			ZeroMemory(path, _MAX_PATH);
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = (LPSTR)Filters;
			ofn.nMaxFile = MAX_PATH;
			ofn.nMaxFileTitle = MAX_PATH;
			ofn.lpstrFile = path;
			ofn.lpstrFileTitle = TitleName;
			ofn.lpstrTitle = "Save as...";
			ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
	
			// if we get a file name
			if(GetSaveFileName(&ofn))
			{								
				if(IsPagingOn)
				{

							wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
							floop.open(temp, std::ios::out | std::ios::binary);
							floop.write((LPCSTR)File, 0x800000);
							floop.close();
							for(a = 0; a < NumPages; a++)
							{
								if(PagesAltered[a])
								{
									wsprintf(temp, "hxct%04x.tmp", a);
									floop.open(temp, std::ios::in | std::ios::binary);
									floop.read((LPSTR)File, 0x800000);
									floop.close();
									remove(temp);
									kanji = fopen(Filename, "r+b");
									fseek(kanji, a * 0x800000, SEEK_SET);
#ifdef _DEBUG
									wsprintf(temp, "%08X", ftell(kanji));
									MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
#endif
									if(a + 1 == NumPages)
										fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
									else
										fwrite(File, sizeof(unsigned char), 0x800000, kanji);
									fclose(kanji);
									FileStream.close();
									FileStream.open(Filename, std::ios::in | std::ios::binary);
								}
								PagesAltered[a] = 0;
							}
				}
				else
				{
					FileStream.open((LPCSTR)ofn.lpstrFile, std::ios::out | std::ios::binary);
					FileStream.write((LPCSTR)File, MaxAddress);			
				}
			}
			FileStream.close();
			GlobalFree(File);
			FileOpen = 0;

			// return the caption to normal
			wsprintf(Caption, "%s %d.%d", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR);
			SetWindowText(hWnd, Caption);
			for(a = 0; a < TotalTables; a++)
				delete Table[a];
			TotalTables = 0;
			CurrentTable = 0;
			if(IsPagingOn)
			{

							wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
							floop.open(temp, std::ios::out | std::ios::binary);
							floop.write((LPCSTR)File, 0x800000);
							floop.close();
							for(a = 0; a < NumPages; a++)
							{
								if(PagesAltered[a])
								{
									wsprintf(temp, "hxct%04x.tmp", a);
									floop.open(temp, std::ios::in | std::ios::binary);
									floop.read((LPSTR)File, 0x800000);
									floop.close();
									remove(temp);
									kanji = fopen(Filename, "r+b");
									fseek(kanji, a * 0x800000, SEEK_SET);
#ifdef _DEBUG
									wsprintf(temp, "%08X", ftell(kanji));
									MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
#endif
									if(a + 1 == NumPages)
										fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
									else
										fwrite(File, sizeof(unsigned char), 0x800000, kanji);
									fclose(kanji);
									FileStream.close();

									//FileStream.open(Filename, std::ios::out | std::ios::binary | std::ios::nocreate);
									//FileStream.seekp(a * 0x800000);

									FileStream.open(Filename, std::ios::in | std::ios::binary);
								}
								PagesAltered[a] = 0;
							}
			}
		//don't want to save, just move on
		case IDNO:
			GlobalFree(File);
			FileOpen = 0;
			
			//return to the regular caption
			wsprintf(Caption, "%s %d.%d", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR);
			SetWindowText(hWnd, Caption);
//			for(a = 0; a < TotalTables; a++)
//				delete Table[a];
			TotalTables = 0;
			CurrentTable = 0;
			if(IsPagingOn)
			{

							wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
							floop.open(temp, std::ios::out | std::ios::binary);
							floop.write((LPCSTR)File, 0x800000);
							floop.close();
							for(a = 0; a < NumPages; a++)
							{
								if(PagesAltered[a])
								{
									wsprintf(temp, "hxct%04x.tmp", a);
									floop.open(temp, std::ios::in | std::ios::binary);
									floop.read((LPSTR)File, 0x800000);
									floop.close();
									remove(temp);
									kanji = fopen(Filename, "r+b");
									fseek(kanji, a * 0x800000, SEEK_SET);
#ifdef _DEBUG
									wsprintf(temp, "%08X", ftell(kanji));
									MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
#endif
									if(a + 1 == NumPages)
										fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
									else
										fwrite(File, sizeof(unsigned char), 0x800000, kanji);
									fclose(kanji);
									FileStream.close();
									FileStream.open(Filename, std::ios::in | std::ios::binary);
								}
								PagesAltered[a] = 0;
							}
			}
			FileStream.close();
			free(path);
			delete[] Caption;
			return 1;
		//cancel and go back
		case IDCANCEL:
			free(path);
			return 0;
	}					
	return 0;
}

int UnsavedTitle(HWND hWnd)
{
	char* szOldCaption;
//	char* szNewCaption;
	int iOldCaption/*, iNewCaption*/;

	iOldCaption = GetWindowTextLength(hWnd);
	szOldCaption = new char[iOldCaption + 3];
	GetWindowText(hWnd, szOldCaption, iOldCaption + 1);
	for( int backCounter = iOldCaption; backCounter >= 0; backCounter --)
	{
		if(szOldCaption[backCounter] == ']')
		{
			szOldCaption[backCounter] = 0x00;
			break;
		}
	}
	strcat(szOldCaption, " *] - ");
	if(CurrentTable == -1)
	{
		if(CleanUp)
			strcat(szOldCaption, "ASCII");
		else
			strcat(szOldCaption, CPages[CurrentCodePage].name);
	}
	else
		strcat(szOldCaption, Table[CurrentTable]->getName());
	SetWindowText(hWnd, szOldCaption);
	delete[] szOldCaption;
	return 0;

}

int SavedTitle(HWND hWnd)
{
	char* szOldCaption;
//	char* szNewCaption;
	int iOldCaption, /*iNewCaption, */backCounter;

	iOldCaption = GetWindowTextLength(hWnd);
	szOldCaption = new char[iOldCaption + 3];
	GetWindowText(hWnd, szOldCaption, iOldCaption + 1);
	for(backCounter = iOldCaption; backCounter >= 0; backCounter --)
	{
		if(szOldCaption[backCounter] == '*')
		{
			szOldCaption[backCounter] = 0x00;
			break;
		}
	}
	if(backCounter != -1)
		strcat(szOldCaption, "] - ");
	wsprintf(szOldCaption, "%s %d.%d.%d - [ %s ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD, TitleName);
	if( CurrentTable == -1 )
	{
		if(UnicodeOutput)
			strcat(szOldCaption, "Unicode");
		else if(CleanUp)
			strcat(szOldCaption, "ASCII");
		else
			strcat(szOldCaption, CPages[CurrentCodePage].name);
	}
	else
		strcat(szOldCaption, Table[CurrentTable]->getName());
	SetWindowText(hWnd, szOldCaption);
	delete szOldCaption;
	return 0;
}