/*
 * Hexecute 3.0
 * Table.cpp
 * copyright 2000 Mike Walston
 *
 * This holds the entire table file routine and the table class.
 */

/*
 *	Today I need to modify the table format slightly, instead of using * and /, i'm going
 *  to have to use END_STRING and NEW_LINE, because if someone needs to print out a *, they
 *  usually do something to the effect of FF=*, but if someone needs an endstring, they will
 *  usually do *FF, and I need to differentiate between the two, it won't take much work, just
 *  changing the checking of / and * in the dumping and to END_STRING and NEW_LINE
 *
 *
 */

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include <process.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

HWND hWndSubStringDisplay;
bool first_time = true;
int start_address = 0;
int bb_length = 0;

int CheckValueAgainstTable(char value, int address)
{
	static char* original;
	static char** backbuffer;
	static char* queue;
	char temp[3];

	// if this is a new queue, then we allocate a new backbuffer and a new
	// queue for the text
	if(first_time)
	{
		queue = new char[Table[CurrentTable]->getLongestEntry()];
		ZeroMemory(queue, sizeof(char) * Table[CurrentTable]->getLongestEntry());
		backbuffer = new char*[Table[CurrentTable]->getLongestEntry()];
		for(int a = 0; a < Table[CurrentTable]->getLongestEntry(); a++)
		{
			backbuffer[a] = new char[Table[CurrentTable]->getLongestEntry()];
			ZeroMemory(backbuffer[a], sizeof(char) * Table[CurrentTable]->getLongestEntry());
		}
		start_address = address;
	}
	wsprintf(temp, "%c", value);
	strcat(queue, temp);
	wsprintf(temp, "%c", GetFileByte(address));
	strcat(original, temp);
	// here we do our checking
	return 0;
}

int ParseTable(std::fstream& poopypants, table* Table, char* strTitle)
{
	HMENU hMenuTemp;

	int nameAlreadySet = 0;
	int newValue = 0;
	int NumSubTables = 0, CurrentSubTable = 0, MaxTable = 0;
//	LOGFONT Font;
	char temp[500];
	int* Entries, *SubTableKey;
	char szHamburger[100],  szDrive[MAX_PATH], szDir[MAX_PATH], szName[MAX_PATH], szExt[MAX_PATH];

	while(!poopypants.eof())
	{
		char szLine[256];
		poopypants.getline(szLine, 255, '\n');

		if(szLine[0] == '\x00')
		{
			continue;
		}
		else if(szLine[0] == 's' && szLine[8] != 'e' && szLine[1] != 't')
			NumSubTables++;
	}
	poopypants.close();

	Entries = new int[NumSubTables + 1];
	for(int a = 0; a <= NumSubTables; a++)
		Entries[a] = 0;
	SubTableKey = new int[NumSubTables + 1];
	for(int e = 0; e <= NumSubTables; e++)
		SubTableKey[e] = 0;

	poopypants.open(strTitle, std::ios::in);

	while(!poopypants.eof())
	{
		char szLine[256];
		poopypants.getline(szLine, 255, '\n');

		if(szLine[0] == '\x00')
		{
			continue;
		}
		else if(szLine[0] == '/')
			Entries[CurrentSubTable]++;
		else if(szLine[0] == '*')
			Entries[CurrentSubTable]++;
		else if(szLine[0] == '^')
			Entries[CurrentSubTable]++;
		else if(szLine[0] == '\\')
			Entries[CurrentSubTable]++;
		else if(szLine[0] == 's')
		{
			// here we encounter the end of the subtable
			// and we go back to normal values
			if(szLine[8] == 'e' && szLine[1] != 't')
				CurrentSubTable = 0;
			// here is a the beginning of a subtable
			// we want to assign it to one more than
			// the number of tables we've encountered
			// so far, in case the program has more
			// than one subtable
			else if(szLine[5] != '=')
			{
				CurrentSubTable = MaxTable +1;
				MaxTable++;
			}
		}
		else if(szLine[0] == '.'){}
		else if(szLine[0] == '$'){}
		else if(szLine[0] == '('){}
		else if(szLine[0] == '['){}
		else if(szLine[0] == ';'){}
		else if(szLine[0] == '#'){}
		else if(szLine[0] == '>'){}
		else if(szLine[0] == '<'){}
		else if(isxdigit(szLine[0]))
		{
			if(( szLine[0] == 'e' && szLine[1] == 'n' ))
				;
			else if(szLine[1] != '=' && szLine[2] != '=' &&szLine[3] != '=' && szLine[4] != '=' )
				;
			else Entries[CurrentSubTable]++;
		}
		else
			;
	}
	poopypants.close();

	Table->Allocate(Entries, NumSubTables);
	_splitpath(strTitle, szDrive, szDir, szName, szExt);
	strcat(szName, szExt);
	Table->setName(szName);
	NumSubTables = 0, CurrentSubTable = 0, MaxTable = 0;

	poopypants.open(strTitle, std::ios::in);
	while(!poopypants.eof())
	{
		char szExt[256];
		char szValue[256];
		char szLine[256];

		poopypants.getline(szLine, 255, '\n');
		if(szLine[0] == 0 || szLine[0] == '\n')
		{
			continue;
		}
		else if(szLine[0] == '/')
		{
			if(szLine[1] == '=')
			{
				sscanf(szLine, "/=%[0-9a-zA-Z]", szValue);
				newValue = strtoul(szValue, NULL, 16);
				Table->newNode(newValue, "HEXECUTE_ENDSTRING");
			}
			else
			{
				sscanf(szLine, "/%[0-9a-zA-Z]", szValue);
				newValue = strtoul(szValue, NULL, 16);
				Table->newNode(newValue, "HEXECUTE_ENDSTRING");
			}
		}
		else if(szLine[0] == '*')
		{
			if(szLine[1] == '=')
			{
				sscanf(szLine, "*=%[0-9a-zA-Z]", szValue);
				newValue = strtoul(szValue, NULL, 16);
				Table->newNode(newValue, "HEXECUTE_NEWLINE");
			}
			else
			{
				sscanf(szLine, "*%[0-9a-zA-Z]", szValue);
				newValue = strtoul(szValue, NULL, 16);
				Table->newNode(newValue, "HEXECUTE_NEWLINE");
			}
		}
		else if(szLine[0] == '^')
		{
			//sscanf(szLine, "^%[0-9a-zA-Z]", szValue);
			//newValue = strtoul(szValue, NULL, 16);
			//Table->newNode(newValue, "HEXECUTE_Choice");
		}
		else if(szLine[0] == '\\')
		{
			//sscanf(szLine, "\\%[0-9a-zA-Z]", szValue);
			//newValue = strtoul(szValue, NULL, 16);
			//Table->newNode(newValue, "\\");
		}
		else if(szLine[0] == '.')
		{
			char* pDelim = strchr(szLine, '=');
			_tcscpy(szExt, szLine + 1);  szExt[pDelim - szLine - 1] = 0;
			_tcscpy(szValue, pDelim + 1);

			if(stricmp(szExt, "codepage") == 0)
			{
				Table->setCodepage(strtoul(szValue, NULL, 10));			
				if(nameAlreadySet)
				{
					wsprintf(temp, "%s ", Table->getName());
					for(int b = strlen(temp) - 1 ; b >= 0 ; b--)
						if(temp[b] == '(')
						{
							temp[b] = 0x00;
							break;
						}
					wsprintf(szHamburger, "(%d)", Table->getCodepage());
					strcat(temp, szHamburger);
					Table->setName(temp);
				}
			}
			else if(stricmp(szExt, "title") == 0)
			{
				wsprintf(temp, " (%d)", Table->getCodepage());
				strcat(szValue, temp);
				Table->setName(szValue);
				nameAlreadySet = 1;
			}
		}
		else if(szLine[0] == 's')
		{
			if(szLine[1] == 't')
			{
				char szAssoc[128];
				sscanf(szLine, "%[0-9a-zA-Z]=", szValue);
				char* pDelim = strchr(szLine, '=');
				_tcscpy(szAssoc, pDelim + 1);
				newValue = strtoul(szAssoc, NULL, 16);
				Table->SetSubTableStartAddress(newValue);
			}
			// here we encounter the end of the subtable
			// and we go back to normal values
 			else if(szLine[8] == 'e')
			{
				if(szLine[11] == '=')
				{
					char szAssoc[128];
					sscanf(szLine, "%[0-9a-zA-Z]=", szValue);
					char* pDelim = strchr(szLine, '=');
					_tcscpy(szAssoc, pDelim + 1);
					newValue = strtoul(szAssoc, NULL, 16);
					Table->SetSubTableEndKey(CurrentSubTable,newValue);
				}
				else Table->SetSubTableEndKey(CurrentSubTable, 0);
				CurrentSubTable = 0;
				Table->SetSubTable(CurrentSubTable);
			}
			// here is a the beginning of a subtable
			// we want to assign it to one more than
			// the number of tables we've encountered
			// so far, in case the program has more
			// than one subtable
			else
			{
				char szAssoc[128];
				sscanf(szLine, "%[0-9a-zA-Z]=", szValue);
				char* pDelim = strchr(szLine, '=');
				_tcscpy(szAssoc, pDelim + 1);
				newValue = strtoul(szAssoc, NULL, 16);
				CurrentSubTable = MaxTable + 1 ;
				Table->SetSubTable(CurrentSubTable);
				Table->SetSubTableKey(CurrentSubTable, newValue);
				MaxTable++;
			}
		}
		else if(szLine[0] == '$')
		{
		}
		else if(szLine[0] == '(')
		{
			// these are bookmarks that should be able to be jumped directly
			// to from a menu.  The bookmarks menu item and the bookmarks themselves
			// will be added to hexecutemenu at runtime, because I don't want to have
			// a submenu with no items in it, that just looks bad
			char szOffset[200], szTitle[200];
			hMenuTemp = GetSubMenu(HexecuteMenu,1);

			sscanf(szLine, "(%[0-9a-zA-Z])%[0-9a-zA-Z ])", szOffset, szTitle);
			if(szOffset[strlen(szOffset) - 1] == 'h')
				szOffset[strlen(szOffset) - 1] = 0;
			MENUITEMINFO mii;

			mii.cbSize = sizeof(MENUITEMINFO);
			mii.fType = MFT_STRING;          
			mii.fState = MFS_ENABLED;          
			mii.fMask = MIIM_TYPE | MIIM_ID | MIIM_STATE;

			long foo[8] = { IDM_BOOKMARK0, IDM_BOOKMARK1, IDM_BOOKMARK2, IDM_BOOKMARK3, 
				IDM_BOOKMARK4, IDM_BOOKMARK5, IDM_BOOKMARK6, IDM_BOOKMARK7 }; 
			mii.wID = foo[BookmarkCounter];
			mii.dwTypeData = szTitle;
			strcpy(BookmarkStrings[BookmarkCounter], szTitle);
			BookMarks[BookmarkCounter] = strtoul(szOffset, NULL, 16);
			if(!InsertMenuItem(hMenuTemp, (UINT)-1, TRUE, &mii))
				MessageBox(NULL, "Unable to add bookmark", PROGRAM_NAME, MB_OK);
			BookmarkCounter++;
		}
		else if(szLine[0] == '[')
		{
			// these are predefined ranges for script dumping. The ranges menu item and 
			// the ranges themselves will be added to hexecutemenu at runtime, because 
			// I don't want to have a submenu with no items in it, that just looks bad
		}
		else if(szLine[0] == ';') // comments
		{
		}
		else if(isxdigit(szLine[0])) // add just a little more robustness
			// as it now can't be screwed up by adding weird values
		{
			if(szLine[0] == 'e' && szLine[1] == 'n')
			{
				char szAssoc[128];
				sscanf(szLine, "%[0-9a-zA-Z]=", szValue);
				char* pDelim = strchr(szLine, '=');
				_tcscpy(szAssoc, pDelim + 1);
				newValue = strtoul(szAssoc, NULL, 16);
				Table->SetSubTableEndAddress(newValue);
			}
			else
			{
				if(szLine[1] != '=' && szLine[2] != '=' &&szLine[3] != '=' && szLine[4] != '=' )
					continue;
				char szAssoc[128];
				sscanf(szLine, "%[0-9a-zA-Z]=", szValue);
				char* pDelim = strchr(szLine, '=');
				_tcscpy(szAssoc, pDelim + 1);
				newValue = strtoul(szValue, NULL, 16);
				Table->newNode(newValue, szAssoc);
			}
		}
	}
	poopypants.close();

	if(Table->getCodepage() != 1252)
		tblFont[TotalTables] = CreateFontIndirect(&CPages[GetCPIndex(Table->getCodepage())].logFont);	// create the logical font
	else 
		tblFont[TotalTables] = hFont;

	TotalTables++;
//	char f00bar[400];
//	DWORD start, end;
//	start = GetTickCount();

	Table->sort();
	Table->sortForInsertion();

//	end = GetTickCount();
//	wsprintf(f00bar, "sort() and sortForInsertion()\ntook %d ms.", end - start);
//	MessageBox(NULL, f00bar, PROGRAM_NAME, MB_OK);

//	EnableMenuItem(HexecuteMenu, ID_SPECIAL_EDITTABLE, MF_ENABLED);	
	delete[] Entries;
	delete[] SubTableKey;
	return true;
}

// this is the actual table, this is what the program interfaces with
// yep, the definition of the table class
// ph33r
table::table() {
	codepage = 1252;
	isFirstAllocated = false;
	name[0] = 0x00;
	widestValue = 0;
	dwFlags = 0;
	tableData = NULL;
	InsertionTableData = NULL;
	changed = false;
	SubTables = 0;
	longest_entry = 0;
	Filename[0] = 0x00;
	CurrentSubTable = 0;
	for( int a = 0; a < 10; a++)
	{
		SubTableStart[a] = 0;
		SubTableEnd[a] = 0;
		SubTableKeys[a] = 0;
		Entries[a] = 0;
		Entries32[a] = 0;
		Entries24[a] = 0;
		Entries16[a] = 0;
		Entries8[a] = 0; 
		currentEntries[a] = 0;
	}
}

table::~table() {
	for(int b = 0; b <= SubTables; b++)
	{
		DeleteObject(tblFont[b]);
		for(int a =0; a < Entries[b]; a++)
		{
			delete[] tableData[b][a].string;
			delete[] InsertionTableData[b][a].string;
		}
		delete[] tableData[b];
		delete[] InsertionTableData[b];
	}
}

// binary search through the sorted array
tableEntry* table::getNode(int getValue) const {
	int middle, low = 0, high = currentEntries[CurrentSubTable], f00;
	while(low <= high) {
		middle = ( low + high ) / 2;
		f00 = tableData[CurrentSubTable][middle].value;
		if(getValue == f00)
			return &tableData[CurrentSubTable][middle];
		else if ( getValue > f00 )
			high = middle - 1;
		else
			low = middle + 1;
	}
	return NULL;
}

tableEntry* table::getNode32(int getValue) const {
	int middle, high = currentEntries[CurrentSubTable] - 
					   Entries8[CurrentSubTable] - 
					   Entries16[CurrentSubTable] - 
					   Entries24[CurrentSubTable], 
					   low = high - Entries32[CurrentSubTable],
					   f00;
	while(low <= high) {
		middle = ( low + high ) / 2;
		f00 = tableData[CurrentSubTable][middle].value;
		if(getValue == f00)
			return &tableData[CurrentSubTable][middle];
		else if ( getValue > f00 )
			high = middle - 1;
		else
			low = middle + 1;
	}
	return NULL;
}

tableEntry* table::getNode24(int getValue) const {
	int middle, high = currentEntries[CurrentSubTable]
					   - Entries8[CurrentSubTable]
					   - Entries16[CurrentSubTable], 
					   low = high - Entries24[CurrentSubTable],
					   f00;
	while(low <= high) {
		middle = ( low + high ) / 2;
		f00 = tableData[CurrentSubTable][middle].value;
		if(getValue == f00)
			return &tableData[CurrentSubTable][middle];
		else if ( getValue > f00)
			high = middle - 1;
		else
			low = middle + 1;
	}
	return NULL;
}

tableEntry* table::getNode16(int getValue) const{
	int middle, high = currentEntries[CurrentSubTable] - Entries8[CurrentSubTable], 
				low = high - Entries16[CurrentSubTable], f00;
	while(low <= high) {
		middle = ( low + high ) / 2;
		f00 = tableData[CurrentSubTable][middle].value;
		if(getValue == f00)
			return &tableData[CurrentSubTable][middle];
		else if ( getValue > f00 )
			high = middle - 1;
		else
			low = middle + 1;
	}
	return NULL;
}

tableEntry* table::getNode8(int getValue) const {
	int middle, high = currentEntries[CurrentSubTable], low = high - Entries8[CurrentSubTable], f00;
	while(low <= high) {
		middle = ( low + high ) / 2;
		f00 = tableData[CurrentSubTable][middle].value;
		if(getValue == f00)
			return &tableData[CurrentSubTable][middle];
		else if ( getValue > f00 )
			high = middle - 1;
		else
			low = middle + 1;
	}
	return NULL;
}

bool table::newNode(int newValue, char* newString) {
	
	int tempWide = 0, f00 = currentEntries[CurrentSubTable];

	if(newValue != ( newValue & 0xFFFFFF ) ) { // a mask of 24 bits changed it's value, it's above 24
		tempWide = 4;
		Entries32[CurrentSubTable]++;
	}
	else if(newValue != ( newValue & 0xFFFF ) ) {
		tempWide = 3;
		Entries24[CurrentSubTable]++;
	}
	else if(newValue != ( newValue & 0xFF ) ) {
		tempWide = 2;
		Entries16[CurrentSubTable]++;
	}
	else {
		tempWide = 1;
		Entries8[CurrentSubTable]++;
	}

	if(tempWide > widestValue)
		widestValue = tempWide;

	if(strlen(newString) > longest_entry)
		longest_entry = strlen(newString);
	tableData[CurrentSubTable][f00].string = new char[256];
//	memset(tableData[CurrentSubTable][f00].string, 0, 256);
	InsertionTableData[CurrentSubTable][f00].string = new char[256];
//	memset(InsertionTableData[CurrentSubTable][f00].string, 0, 256);
	if(strlen(newString) == 0)
	{
		strncpy(tableData[CurrentSubTable][f00].string, ".", strlen(".") + 1);
		strncpy(InsertionTableData[CurrentSubTable][f00].string, ".", strlen(".") + 1);
	}
	else
	{
		strcpy(tableData[CurrentSubTable][f00].string, newString);
		strcpy(InsertionTableData[CurrentSubTable][f00].string, newString);
	}
	tableData[CurrentSubTable][f00].value = newValue;
	InsertionTableData[CurrentSubTable][f00].value = newValue;
	currentEntries[CurrentSubTable]++;
	return true;
}

bool table::setCodepage(int newCodepage) {
	codepage = newCodepage;
	return true;
}

bool table::setName(char* newName) {
	strncpy(name, newName, 49);
	return true;
}

char* table::getName() {
	return name;
}

int table::getWidestValue() {
	return widestValue;
}

int table::getCodepage() {
	return codepage;
}

int table::getLongestEntry() {
	return longest_entry;
}

void table::sort() {
	for(int c = 0; c <= SubTables; c++)
	{
		if(Entries[c] > 4)
		//	ValueInsertionSort(c);
			ValueHeapSort(c);
		else
			ValueBubbleSort(c);
	}
}

void table::sortForInsertion() {
	for(int c = 0; c <= SubTables; c++)
	{
		if(Entries[c] > 4)
		//	StringInsertionSort(c);
			StringHeapSort(c);
		else
			StringBubbleSort(c);
	}
}

void table::ValueInsertionSort(int subtable)
{
	for (int i = 0; i < Entries[subtable]; i++) {
	    int j = i;
		tableEntry B;
		B.string = tableData[subtable][i].string;
		B.value = tableData[subtable][i].value;
	    while ((j > 0) && (tableData[subtable][j-1].value < B.value)) {
	        swap(tableData[subtable],j,j-1);
	        j--;
	    }
	    tableData[subtable][j].string = B.string;
		tableData[subtable][j].value = B.value;
        }
}

void table::StringInsertionSort(int subtable)
{
	for (int i = 0; i < Entries[subtable]; i++) {
	    int j = i;
		tableEntry B;
		B.string = InsertionTableData[subtable][i].string;
		B.value = InsertionTableData[subtable][i].value;
	    while ((j > 0) && (strlen(InsertionTableData[subtable][j-1].string) < strlen(B.string))) {
	        swap(InsertionTableData[subtable],j,j-1);
	        j--;
	    }
	    InsertionTableData[subtable][j].string = B.string;
		InsertionTableData[subtable][j].value = B.value;
        }
}

void table::ValueHeapSort(int subtable)
{
	int N = Entries[subtable];
	for (int k = N/2; k > 0; k--) {
	    Valuedownheap(tableData[subtable], k, N);
        }
	do {
		tableEntry T;
		T.value = tableData[subtable][0].value;
		T.string = tableData[subtable][0].string;
		tableData[subtable][0].value = tableData[subtable][N - 1].value;
		tableData[subtable][0].string = tableData[subtable][N - 1].string;
		tableData[subtable][N - 1].value = T.value;
		tableData[subtable][N - 1].string = T.string;
		N = N - 1;
		Valuedownheap(tableData[subtable], 1, N);
	} while (N > 1);
}

void table::StringHeapSort(int subtable)
{
	int N = Entries[subtable];
	for (int k = N/2; k > 0; k--) {
	    Stringdownheap(InsertionTableData[subtable], k, N);
        }
	do {
            tableEntry T;
			T.value = InsertionTableData[subtable][0].value;
			T.string = InsertionTableData[subtable][0].string;
            InsertionTableData[subtable][0].value = InsertionTableData[subtable][N - 1].value;
			InsertionTableData[subtable][0].string = InsertionTableData[subtable][N - 1].string;
            InsertionTableData[subtable][N - 1].value = T.value;
			InsertionTableData[subtable][N - 1].string = T.string;
			N = N - 1;
            Stringdownheap(InsertionTableData[subtable], 1, N);
	} while (N > 1);
}

void table::Valuedownheap(tableEntry* blah, int k, int N)
{
	tableEntry T;
	T.string = blah[k - 1].string;
	T.value = blah[k - 1].value;
	while (k <= N/2) {
            int j = k + k;
            if ((j < N) && (blah[j - 1].value > blah[j].value)) {
	        j++;
	    }
	    if (T.value < blah[j - 1].value) {
		break;
	    } else {
                blah[k - 1].value = blah[j - 1].value;
				blah[k - 1].string = blah[j - 1].string;
                k = j;
            }
	}
    blah[k - 1].value = T.value;
	blah[k - 1].string = T.string;
}

void table::Stringdownheap(tableEntry* blah, int k, int N)
{
	tableEntry T;
	T.string = blah[k - 1].string;
	T.value = blah[k - 1].value;
	while (k <= N/2) {
            int j = k + k;
            if ((j < N) && (strlen(blah[j - 1].string) < strlen(blah[j].string))) {
	        j++;
	    }
	    if (strlen(T.string) >= strlen(blah[j - 1].string)) {
		break;
	    } else {
                blah[k - 1].value = blah[j - 1].value;
				blah[k - 1].string = blah[j - 1].string;
                k = j;
            }
	}
    blah[k - 1].value = T.value;
	blah[k - 1].string = T.string;
}
/*
    void sort(int a[]) throws Exception {
	int N = a.length;
	for (int k = N/2; k > 0; k--) {
	    downheap(a, k, N);
	    pause();
        }
	do {
            int T = a[0];
            a[0] = a[N - 1];
            a[N - 1] = T;
	    N = N - 1;
	    pause(N);
            downheap(a, 1, N);
	} while (N > 1);
    }

    void downheap(int a[], int k, int N) throws Exception {
	int T = a[k - 1];
	while (k <= N/2) {
            int j = k + k;
            if ((j < N) && (a[j - 1] < a[j])) {
	        j++;
	    }
	    if (T >= a[j - 1]) {
		break;
	    } else {
                a[k - 1] = a[j - 1];
                k = j;
		pause();
            }
	}
        a[k - 1] = T;
	pause();
    }

  */

inline void table::swap(tableEntry* blah, int l, int r)
{
	int tempValue;
	char* tempString;
	tempValue = blah[l].value;
	blah[l].value = blah[r].value;
	blah[r].value = tempValue;
	tempString = blah[l].string;
	blah[l].string = blah[r].string;
	blah[r].string = tempString;
}


void table::ValueBubbleSort(int subtable) {
	for( int a = 0;  a < Entries[subtable] - 1; a++ ) {
		for( int b = 0 ; b < ( Entries[subtable] - 1 - a) ; b++ ) {
			if( tableData[subtable][b].value < tableData[subtable][b + 1].value ) {
				swap(tableData[subtable], b, b+1);
			}
		}
	}	
}


// this function sorts by string length instead of
// by value and that is the way that it needs to 
// be for the insertion of the text you entered
// this seems to be working perfectly
void table::StringBubbleSort(int subtable) {
	for( int a = 0;  a < Entries[subtable] - 1; a++ ) {
		for( int b = 0 ; b < ( Entries[subtable] - 1 - a) ; b++ ) {
			if( strlen(InsertionTableData[subtable][b].string) < strlen(InsertionTableData[subtable][b + 1].string) ) {
				swap(InsertionTableData[subtable], b, b+1);
			}
			longest_entry = strlen(InsertionTableData[subtable][0].string);
		}
	}
}

tableEntry* table::getMatchingNode(char* temp) const{
	for(int b = 0; b < Entries[CurrentSubTable]; b++)
	{
		if(!strcmp(temp, InsertionTableData[CurrentSubTable][b].string))
			return &InsertionTableData[CurrentSubTable][b];
	}
	return NULL;
}

void table::dumpNodes(char* Filename) {
	std::ofstream dumpFile(Filename);
	int blah = 0;
	for(int a = 0; a <= SubTables; a++) {
		dumpFile << "This is subtable " << a << " (remember, subtable 0 is the main table)" << std::endl;
		while( blah < Entries[a])
		{
			dumpFile << tableData[a][blah].value << "=" << tableData[a][blah].string << std::endl;
			blah++;
		}
		blah = 0;
	}
}

bool table::Allocate(int* numNodes, int NumSubTables) {
	SubTables = NumSubTables;
	if(tableData == NULL) {
		tableData = new tableEntry*[NumSubTables + 1];
		InsertionTableData = new tableEntry*[NumSubTables + 1];
		ZeroMemory(tableData, sizeof(tableEntry*) * (NumSubTables + 1 ));
		for(int b = 0; b <= SubTables; b++)
		{
			Entries[b] = numNodes[b];
			tableData[b] = new tableEntry[numNodes[b]+3];
			InsertionTableData[b] = new tableEntry[numNodes[b]+3];
			ZeroMemory(tableData[b], sizeof(tableEntry) * ( numNodes[b] + 3 ));
			ZeroMemory(InsertionTableData[b], sizeof(tableEntry) * (numNodes[b] + 3));
		}
	}
	else {
		// cheap hack 
		for(int b = 0; b <= SubTables; b++)
		{
			for(int a = 0; a < Entries[b]; a++) {
				delete[] tableData[b][a].string;
				delete[] InsertionTableData[b][a].string;
			}
			delete[] tableData;
			delete[] InsertionTableData;
			tableData = new tableEntry*[NumSubTables + 1];
			InsertionTableData = new tableEntry*[NumSubTables + 1];
			Entries[b] = numNodes[b];
			tableData[b] = new tableEntry[numNodes[b]];
			InsertionTableData[b] = new tableEntry[numNodes[b]];
			ZeroMemory(tableData[b], sizeof(tableEntry) * numNodes[b]);		
			ZeroMemory(InsertionTableData[b], sizeof(tableEntry) * numNodes[b]);
		}
	}
	return true;
}

int table::IsSubTableKey(int check, int address)
{
	for( int a = 0; a <= SubTables; a++)
	{
		if(address >= SubTableStart[a] && address < SubTableEnd[a] )
		{
			if( SubTableKeys[a] == check)
				return a;
		}
		if(!SubTableStart[a] || !SubTableEnd[a] && a != 0)
		{
			if( SubTableKeys[a] == check)
				return a;
		}
	}
	return 0;
}

int table::IsSubTableEndValue(char check)
{
	int f003y = check & 0x000000ff;
	if( SubTableEndKeys[CurrentSubTable] == f003y)
		return 1;
	return 0;
}

int table::SetSubTable(int check)
{
	CurrentSubTable = check;
	return 1;
}

int table::SetSubTableKey(int subtable, int value)
{
	SubTableKeys[subtable] = value;
	return 1;
}

int table::SetSubTableEndKey(int subtable, int value)
{
	SubTableEndKeys[subtable] = value;
	return 1;
}

int table::SetSubTableEndAddress(int address)
{
	SubTableEnd[CurrentSubTable] = address;
	return 1;
}

int table::SetSubTableStartAddress(int address)
{
	SubTableStart[CurrentSubTable] = address;
	return 1;
}

int table::getSubTable()
{
	return CurrentSubTable;
}

int table::getSubTableKey()
{
	return SubTableKeys[CurrentSubTable];
}

int table::GetAddressSubTable(int address)
{
	for(int a = 1; a <= SubTables; a++)
	{
		for(int b = 0; b < RangeCount[a]; b++)
		{
			if( ( address >= Ranges[a][b].start ) && ( address <= Ranges[a][b].end ) )
				return a;
		}
	}
	return 0;
}

bool table::IsInSubTableRange(int address)
{
	return ( ( address >= SubTableStart[CurrentSubTable] ) && ( address < SubTableEnd[CurrentSubTable] ) );;
}

/*
void __cdecl FindSubStringsThread(void*)
{
	Table[CurrentTable]->FindSubStrings();
}
*/
// this is an interesting function that I get to code
// although it seems like it might be somewhat difficult
int table::FindSubStrings()
{
	// this is the function that we will call if we have a table
	// file that has substrings in it, this way we can take the
	// whole file at once and not base it on WM_PAINT
	bool InsideSubstring = false;
	int Index = 0, current = 1, FileIndex = 0;
	int *NumRanges = new int[SubTables + 1], *f00 = new int[SubTables + 1];
	Ranges = new RANGE*[SubTables + 1];

	if ( SubTables == 0 )
		return 0;

	for( int e = 1 ; e <= SubTables ; e++ )
	{
		f00[e] = 0;
		NumRanges[e] = 0;
		f00[e] = 0;
	}

	for (FileIndex = 0; FileIndex < MaxAddress; FileIndex++)
	{
		// if we're inside a string, then we need to check for
		// the end of a substring (the substring terminator)
		// however if it doesn't have a terminator, we'll check
		// for the subtable key value for the other subtables
		if(InsideSubstring)
		{
			// we have a termination value
			if(SubTableEndKeys[current])
			{
				if(GetFileByte(FileIndex) == SubTableEndKeys[current] ||
					FileIndex > SubTableEnd[current])
				{
					//wsprintf(temp, "End of a subtable found at %08x", FileIndex);
					//MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
					InsideSubstring = false;
				}
			}
			else if (FileIndex > SubTableEnd[current])
			{
				InsideSubstring = false;
			}
			// we don't have a termination value so we search for the other
			// table initialization values
			else
			{
				for(int a = 1; a <= SubTables; a++)
				{
					if(GetFileByte(FileIndex) == SubTableKeys[a] &&
						FileIndex >= SubTableStart[a] &&
						(SubTableEnd[a] ? ( FileIndex <= SubTableEnd[a] ): 1 ) )
					{
						current = a;
						NumRanges[a]++;
						InsideSubstring = false;
					}
				}
			}
		}
		else 
		{
			for(int b = 1; b <= SubTables; b++)
			{
				if(GetFileByte(FileIndex) == SubTableKeys[b] && 
					FileIndex >= SubTableStart[b] &&
					( SubTableEnd[b] ? ( FileIndex <= SubTableEnd[b] ): 1 ) )
				{
					//wsprintf(temp, "Subtable found at %08x", FileIndex);
					//MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
					current = b;
					NumRanges[b]++;
					InsideSubstring = true;
				}
			}
		}
	}

	for(int a = 1; a <= SubTables; a++)
	{
		RangeCount[a] = NumRanges[a];
		Ranges[a] = new RANGE[NumRanges[a]];
	}

	current = 1;
	for (FileIndex = 0; FileIndex < MaxAddress; FileIndex++)
	{
		// if we're inside a string, then we need to check for
		// the end of a substring (the substring terminator)
		// however if it doesn't have a terminator, we'll check
		// for the subtable key value for the other subtables
		if(InsideSubstring)
		{
			// we have a termination value
			if(SubTableEndKeys[current])
			{
				if(GetFileByte(FileIndex) == SubTableEndKeys[current] ||
					FileIndex > SubTableEnd[current])
				{
					//wsprintf(temp, "End of a subtable found at %08x", FileIndex);
					//MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
					Ranges[current][f00[current]].end = FileIndex - 1;
					InsideSubstring = false;
					f00[current]++;
				}
			}
			else if (FileIndex > SubTableEnd[current])
			{
				Ranges[current][f00[current]].end = FileIndex - 1;
				InsideSubstring = false;
				f00[current]++;
			}
			// we don't have a termination value so we search for the other
			// table initialization values
			else
			{
				for(int a = 1; a <= SubTables; a++)
				{
					if(GetFileByte(FileIndex) == SubTableKeys[a] &&
						FileIndex >= SubTableStart[a] &&
						(SubTableEnd[a] ? ( FileIndex <= SubTableEnd[a] ): 1 ) )
					{
						// we found the start of a new substring and the current
						// substring doesn't have a termination value
						Ranges[current][f00[current]].end = FileIndex - 1;
						current = a;
						// now that we've set the new subtable, we assign
						// the start of that range there
						Ranges[current][f00[current]].start = FileIndex;
						InsideSubstring = true;
					}
				}
			}
		}
		else 
		{
			for(int b = 1; b <= SubTables; b++)
			{
				if(GetFileByte(FileIndex) == SubTableKeys[b] && 
					FileIndex >= SubTableStart[b] &&
					( SubTableEnd[b] ? ( FileIndex <= SubTableEnd[b] ): 1 ) )
				{
					current = b;
					Ranges[current][f00[current]].start = FileIndex;
					InsideSubstring = true;
				}
			}
		}
	}
	return 0;
}

int table::SetFlags(int flags)
{
	dwFlags |= flags;
	return 1;
}

int table::ClearFlags(int flags)
{
	dwFlags ^= flags;
	return 1;
}

int table::GenerateTable(char* flark)
{
	std::fstream newTable;
	char temp[100];
	newTable.open(flark, std::ios::out);
	newTable << ".codepage=" << codepage << std::endl;
	for( int p = strlen(name) - 1; p >= 0; p--)
	{
		if(name[p] == '(')
			name[p - 1] = 0x00;
	}
	newTable << ".title=" << name << std::endl;
	for( int c = 0; c <= SubTables ; c++)
	{
		if( c != 0 )
		{
			newTable.setf(std::ios::hex);
			newTable << "subtable=" << SubTableKeys[c] << std::endl;
			for(int a = 0; a < RangeCount[c]; a++)
			{
				newTable << "start=" << Ranges[c][a].start << std::endl;
				newTable << "end=" << Ranges[c][a].end << std::endl;
			}
		}
		for(int d = 0; d < Entries[c]; d++)
		{
			newTable.setf(std::ios::hex);
			if(!strcmp(tableData[c][d].string, "HEXECUTE_NEWLINE"))
			{
				newTable << "*";
				if (tableData[c][d].value <= 0xFF)
					wsprintf(temp, "%02X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFF)
					wsprintf(temp, "%04X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFFFF)
					wsprintf(temp, "%06X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFFFFFF)
					wsprintf(temp, "%08X", tableData[c][d].value);
				newTable << temp << std::endl;
			}
			else if (!strcmp(tableData[c][d].string, "HEXECUTE_ENDSTRING"))
			{
				newTable << "/";
				if (tableData[c][d].value <= 0xFF)
					wsprintf(temp, "%02X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFF)
					wsprintf(temp, "%04X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFFFF)
					wsprintf(temp, "%06X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFFFFFF)
					wsprintf(temp, "%08X", tableData[c][d].value);			
				newTable << temp << std::endl;
			}
			else
			{
				if (tableData[c][d].value <= 0xFF)
					wsprintf(temp, "%02X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFF)
					wsprintf(temp, "%04X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFFFF)
					wsprintf(temp, "%06X", tableData[c][d].value);
				else if (tableData[c][d].value <= 0xFFFFFFFF)
					wsprintf(temp, "%08X", tableData[c][d].value);
				newTable << temp << "=" << tableData[c][d].string << std::endl;
			}
		}
		if(c != 0)
		{
			newTable.setf(std::ios::hex);
			newTable << "subtableend=" << SubTableEndKeys[c] << std::endl;
		}
	}
	for(int a = 0; a < BookmarkCounter; a++)
	{
		wsprintf(temp, "(%08X)%s", BookMarks[a], BookmarkStrings[a]);
		newTable << temp << std::endl;
	}
	newTable.close();
	return 1;
}

int table::setFilename(char* crap)
{
	_tcscpy(Filename, crap);
	return 1;
}

bool table::HasBeenChanged()
{
	return changed;
}


int table::Append(int newValue, char* newString, int sub_table)
{
	tableEntry* tempTable = new tableEntry[Entries[sub_table] + 1];
	for(int a = 0; a < Entries[sub_table]; a++)
	{
		tempTable[a].string = new char[strlen(tableData[sub_table][a].string)];
		_tcscpy(tempTable[a].string, tableData[sub_table][a].string);
		tempTable[a].value = tableData[sub_table][a].value;
	}
	tempTable[Entries[sub_table]].value = newValue;
	tempTable[Entries[sub_table]].string = new char[strlen(newString)];
	_tcscpy(tempTable[Entries[sub_table]].string, newString);

	/*
	for( int b = 0; b < Entries[sub_table]; a++)
	{
		delete tableData[sub_table][a].string;
		delete tableData[sub_table];
	}
	delete tableData[sub_table];
	*/

	Entries[sub_table]++;
	tableData[sub_table] = new tableEntry[Entries[sub_table]];
	ZeroMemory(tableData[sub_table], sizeof(tableEntry) * Entries[sub_table]);

	for( int c = 0; c < Entries[sub_table]; c++)
	{
		tableData[sub_table][c].string = new char[strlen(tempTable[c].string)];
		_tcscpy(tableData[sub_table][c].string, tempTable[c].string);
		tableData[sub_table][c].value = tempTable[c].value;
		InsertionTableData[sub_table][c].value = tempTable[c].value;
		InsertionTableData[sub_table][c].string = new char[strlen(tempTable[c].string)];
		_tcscpy(InsertionTableData[sub_table][c].string, tempTable[c].string);
	}
	delete[] tempTable;
	return 1;
}

int table::AddRange(int START, int END, int sub_table)
{
	RANGE* tempRange = new RANGE[RangeCount[sub_table] + 1];
	for(int a = 0; a < RangeCount[sub_table]; a++)
	{
		tempRange[a].start = Ranges[sub_table][a].start;
		tempRange[a].end = Ranges[sub_table][a].end;
	}
	tempRange[RangeCount[sub_table]].start = START;
	tempRange[RangeCount[sub_table]].end = END;

	RangeCount[sub_table]++;
	Ranges[sub_table] = new RANGE[RangeCount[sub_table]];
	ZeroMemory(Ranges[sub_table], sizeof(RANGE) * RangeCount[sub_table]);
	for(int c = 0; c < RangeCount[sub_table]; c++)
	{
		Ranges[sub_table][c].start = tempRange[c].start;
		Ranges[sub_table][c].end = tempRange[c].end;
	}	
	return 1;
}

int table::AddSubTable(int key, int endkey)
{
	// all right, this will take some work
	if(key)
		SubTables++;

	SubTableKeys[SubTables] = key;
	SubTableEndKeys[SubTables] = endkey;
	tableEntry** holder = new tableEntry*[SubTables + 1];
	tableEntry** holder2 = new tableEntry*[SubTables + 1];
	for( int a = 0; a < SubTables; a++)
	{
		holder[a] = tableData[a];
		holder2[a] = InsertionTableData[a];
	}

	RangeCount[SubTables] = 0;
	Entries[SubTables] = 0;
	tableData = holder;
	tableData[SubTables] = NULL;
	InsertionTableData = holder2;
	InsertionTableData[SubTables] = NULL;
	return 1;
}

bool table::IsStartFlag(int address)
{
	for( int a = 1;  a<= SubTables; a++)
	{
		for( int b = 0; b < RangeCount[a]; b++)
		{
			if(address == Ranges[a][b].start)
				return true;
		}
	}
	return 0;
}

bool table::IsEndFlag(int address)
{
	for( int a = 1;  a<= this->SubTables; a++)
	{
		for( int b = 0; b < this->RangeCount[0]; b++)
		{
			if(address == this->Ranges[0][b].end )
				return true;
		}
	}
	return 0;
}
