/*
 * Hexecute 3.0
 * WinProc.h
 * copyright 2000 Mike Walston
 *
 * This is the file that holds WinProc for the flat base window
 * which contains the status bar and the MDI frame
 */
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include <imm.h>
#include <fstream>
#include <iostream>
#include <htmlhelp.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

#pragma warning( disable : 4700 )

LRESULT CALLBACK WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	OPENFILENAME ofn;
	// the common control data structure
	INITCOMMONCONTROLSEX CommonControls;
	// handle to a device context
	HDC hdc;
	HIMC hIMC;
	//integers for storing stuff
	static int StatusBarShow = 1, ToolBarShow = 1, DataWindowTop, CopyLength, CutLength, DataBarShow = 1;
	int DataWindowHeight, DataWindowWidth, a ,l,b,q,c,r, nihon ,Result, cyTemp1, cyTemp2, matsu;
	long TempWindowLong = 0;
	int MASK[4] = { 0xFF, 0xFF00, 0xFF0000, 0xFF000000 } , result, romh;
	HGLOBAL	ClipBoardData;
	POINT pointImeLocation;
	PTSTR pClipBoardData;
	static LPSTR lpstr;
	static wchar_t minnasan[200];
	static int wasabi;
	int o, i;
	char temp2[500];
	RECT rect;
	COMPOSITIONFORM cf;
	HMENU hMenuTemp;
	// menu handles
	//static LOGFONT tempLogFont;
	HexecuteMenu = GetMenu(hWnd);
	tableEntry* yeehaw;
	//tooltiptext pointer
	LPTOOLTIPTEXT ToolTipText = new TOOLTIPTEXT;
	std::fstream floop;
	FILE* kanji;

	// long pointers to strings
	LPTSTR path;
	char temp[500];

	// here begins the journey
	switch(message) {

		case WM_CREATE:
			path = (LPTSTR)malloc(_MAX_PATH * sizeof(TCHAR)); 
			_tcscpy((TCHAR*)path, TEXT(""));
		    // Register the hexecute data type for the clipboard
			CF_HEXECUTE = RegisterClipboardFormat(TEXT("CF_HEXECUTE"));
			OpenClipboard(hWnd);
			EmptyClipboard();
			CloseClipboard();

			DataBarShow = true;
			StatusBarShow = true;
			ToolBarShow = true;

			// initialize common controls
		    CommonControls.dwSize = sizeof(CommonControls);
			CommonControls.dwICC = ICC_WIN95_CLASSES;
			InitCommonControlsEx(&CommonControls);

			// default menu setup
			DefaultMenu();

			hMenuTemp = GetSubMenu(HexecuteMenu, 3);
			// we should now have a menu handle to the code
			// page selection menu
			hMenuTemp = GetSubMenu(hMenuTemp, 4);
			AddCodePagesToMenu(hMenuTemp);
			SetTimer(hWnd, TIMER_1_SEC, 1000, NULL);
			
			hIMC = ImmGetContext(hWnd);
			ImmSetCompositionFont(hIMC, &(CPages[GetCPIndex(932)].logFont));
			ImmReleaseContext(hWnd, hIMC);
			if(_tcslen(CommandLine))
			{
					OpenFile(hWnd, CommandLine, CommandLineTitle);
					SendMessage(hWndData, HX_OPENFILE, WPARAM(NULL), LPARAM(NULL));
					InvalidateRect(hWndData, NULL, FALSE);
					SendMessage(hWndData, WM_SIZE, (WPARAM)NULL, LPARAM(NULL));
			}
			if(!CleanUp) {
				switch(CurrentCodePage) {
					case 0:
						CodePageMenu(hWnd, IDM_CODEPAGE0);
						SendMessage(hWndData, WM_SIZE, 0,0);
						InvalidateRect(hWndData, NULL, FALSE);
						return 0;
					case 1 :
						CodePageMenu(hWnd, IDM_CODEPAGE1);
						SendMessage(hWndData, WM_SIZE, 0,0);
						InvalidateRect(hWndData, NULL, FALSE);
						break;
					case 2 :
						CodePageMenu(hWnd, IDM_CODEPAGE2);
						SendMessage(hWndData, WM_SIZE, 0,0);
						InvalidateRect(hWndData, NULL, FALSE);
						return 0;
					case 3 :
						CodePageMenu(hWnd, IDM_CODEPAGE3);
						SendMessage(hWndData, WM_SIZE, 0,0);
						InvalidateRect(hWndData, NULL, FALSE);
						return 0;
					case 4 :
						CodePageMenu(hWnd, IDM_CODEPAGE4);
						SendMessage(hWndData, WM_SIZE, 0,0);
						InvalidateRect(hWndData, NULL, FALSE);
						return 0;
					case 5 :
						CodePageMenu(hWnd, IDM_CODEPAGE5);
						SendMessage(hWndData, WM_SIZE, 0,0);
						InvalidateRect(hWndData, NULL, FALSE);
						return 0;
				}
			}
		case WM_DISPLAYCHANGE:
			// get the device context of hWnd
			hdc = GetDC(hWnd);
			if(ToolBarShow)
			{
				hWndToolBar = CreateToolbarEx(hWnd, WS_CHILD | WS_BORDER | WS_VISIBLE | TBSTYLE_TOOLTIPS,
											  TOOLBAR, 
											  11, //number of bitmapss
											  hInst, 
											  IDB_BITMAP1, // bitmap containing icons
											  (LPCTBBUTTON)&tbButtons, 
											  13, // number of buttons
											  16, 16, 16, 16, sizeof (TBBUTTON)); 
				if (hWndToolBar == NULL)
				{
					DataWindowTop = 0;
					MessageBox (hWnd, "Toolbar not created!", NULL, MB_OK);
				}
				else DataWindowTop = 20;
			}

			if(StatusBarShow)
			{
				// let's create the status bar now
				StatusBar = CreateWindowEx (0L, // extended style
										STATUSCLASSNAME, // create status bar
										"", // window title
										WS_CHILD | WS_BORDER | 
										WS_VISIBLE | SBS_SIZEGRIP, // window styles
										0, 0, 0, 0, // x, y, width, height
										hWnd, // parent window
										(HMENU)STATUS_BAR, // ID
										hInst, // instance	
										NULL); // window data

				if (StatusBar == NULL)
					MessageBox(hWnd, TEXT("Status Bar not-initialized."), AppName, MB_ICONERROR);
			}
			
			if(DataBarShow)
			{
				;
			}

			// set the height and width for the data window
			DataWindowWidth = LOWORD(lParam);
			if( ( StatusBar == NULL ) || !StatusBarShow )
				DataWindowHeight = HIWORD(lParam);
			else DataWindowHeight = HIWORD(lParam) - 24;

			//done with the status bar, now we do the data frame
			hWndData = CreateWindowEx(WS_EX_CLIENTEDGE ,DataClass, NULL,
									   WS_CHILD | WS_VSCROLL | WS_HSCROLL | WS_VISIBLE,
									   0, DataWindowTop,
								       DataWindowWidth, DataWindowHeight,
									   hWnd, NULL, hInst, NULL);

			ReleaseDC(hWnd, hdc); // release the device context

			// fall through to WM_SIZE

		// when we resize our window, let's make sure the coords are set correctly
		case WM_SIZE:
			ResizeWindows(hWnd, hWndData, StatusBar, hWndToolBar, StatusBarShow, ToolBarShow);
			return 0;

		// menu commands
		case WM_COMMAND:

			// (LOWORD)(wParam) contains the menu option selected
			switch(LOWORD(wParam)) {
				
				case ID_OPTIONS_TEXTCODEPAGE_UNICODEBIGENDIAN:
					CleanUp = true;
					UnicodeOutput = true;
					BigEndian = true;
					CodePageMenu(hWnd, ID_OPTIONS_TEXTCODEPAGE_UNICODEBIGENDIAN);
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_OPTIONS_TEXTCODEPAGE_UNICODE:
					CleanUp = true;
					UnicodeOutput = true;
					BigEndian = false;
					CodePageMenu(hWnd, ID_OPTIONS_TEXTCODEPAGE_UNICODE);
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_OPTIONS_TEXTCODEPAGE_DEFAULT:
					CleanUp = true;
					UnicodeOutput = false;
					CodePageMenu(hWnd, ID_OPTIONS_TEXTCODEPAGE_DEFAULT);
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;
				case IDM_CODEPAGE0:
					CleanUp = false;
					UnicodeOutput = false;
					CodePageMenu(hWnd, IDM_CODEPAGE0);
					CurrentCodePage = 0;
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;
				case IDM_CODEPAGE1 :
					CleanUp = false;
					UnicodeOutput = false;
					CodePageMenu(hWnd, IDM_CODEPAGE1);
					CurrentCodePage = 1;
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					break;
				case IDM_CODEPAGE2 :
					CleanUp = false;
					UnicodeOutput = false;
					CodePageMenu(hWnd, IDM_CODEPAGE2);
					CurrentCodePage = 2;
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;
				case IDM_CODEPAGE3 :
					CleanUp = false;
					UnicodeOutput = false;
					CodePageMenu(hWnd, IDM_CODEPAGE3);
					CurrentCodePage = 3;
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;
				case IDM_CODEPAGE4 :
					CleanUp = false;
					UnicodeOutput = false;
					CodePageMenu(hWnd, IDM_CODEPAGE4);
					CurrentCodePage = 4;
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;
				case IDM_CODEPAGE5 :
					CleanUp = false;
					UnicodeOutput = false;
					CodePageMenu(hWnd, IDM_CODEPAGE5);
					CurrentCodePage = 5;
					SendMessage(hWndData, WM_SIZE, 0,0);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case IDM_RECENT_FILE0:
					OpenFile(hWnd, RecentFile0, RecentFileTitle0);
					SendMessage(hWndData, WM_SIZE, NULL, NULL);
					SendMessage(hWnd, WM_SETFOCUS, wParam, lParam);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case IDM_RECENT_FILE1:
					OpenFile(hWnd, RecentFile1, RecentFileTitle1);
					SendMessage(hWndData, WM_SIZE, NULL, NULL);
					SendMessage(hWnd, WM_SETFOCUS, wParam, lParam);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case IDM_RECENT_FILE2:
					OpenFile(hWnd, RecentFile2, RecentFileTitle2);
					SendMessage(hWndData, WM_SIZE, NULL, NULL);
					SendMessage(hWnd, WM_SETFOCUS, wParam, lParam);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case IDM_RECENT_FILE3:
					OpenFile(hWnd, RecentFile3, RecentFileTitle3);
					SendMessage(hWndData, WM_SIZE, NULL, NULL);
					SendMessage(hWnd, WM_SETFOCUS, wParam, lParam);
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_FILE_NEW:
					if(FileOpen) 
					{
						if(!Saved)
						{
							result = MessageBox(hWnd, "Would you like to save your current work?\nPress cancel to return to current file.",
               					    PROGRAM_NAME, MB_YESNOCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON1	);
							if(result == IDCANCEL)
								return 0;
							else if(result == IDYES)
							{
								if(IsPagingOn)
								{
									wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
									floop.open(temp, std::ios::out | std::ios::binary);
									floop.write((LPCSTR)File, 0x800000);
									floop.close();
									for(a = 0; a < NumPages; a++)
									{
										if(PagesAltered[a])
										{
											wsprintf(temp, "hxct%04x.tmp", a);
											floop.open(temp, std::ios::in | std::ios::binary);
											floop.read((LPSTR)File, 0x800000);
											floop.close();
											remove(temp);
											kanji = fopen(Filename, "r+b");
											fseek(kanji, a * 0x800000, SEEK_SET);
		#ifdef _DEBUG
											wsprintf(temp, "%08X", ftell(kanji));
											MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
		#endif
											if(a + 1 == NumPages)
												fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
											else
												fwrite(File, sizeof(unsigned char), 0x800000, kanji);
											fclose(kanji);
											FileStream.close();
											FileStream.open(Filename, std::ios::in | std::ios::binary);
										}
										PagesAltered[a] = 0;
									}
		//****************************************************************************************
								}
								else
								{
									FileStream.open(Filename, std::ios::out | std::ios::binary);
									FileStream.write((LPCSTR)File, MaxAddress);
									FileStream.close();
								}	
								Saved = true;
							}
							GlobalFree(File);
						}
						if(!NewFile)
							SavedTitle(hWnd);
						else
						{
							wsprintf(temp, "%s %d.%d.%d - [ %s ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD, TitleName);
							if(UnicodeOutput)
								strcat(temp, "Unicode");
							else if (CleanUp)
								strcat(temp, "Unicode");
							else 
							{
								strcat(temp, CPages[CurrentCodePage].name);
							}
							SetWindowText(hWnd, temp);
							NewFile = NO;
						}
//***************************************************************************************
					}
					// new file
					MaxAddress = 2048;
					wsprintf(temp, "Size: %08X", MaxAddress);
					SendMessage (StatusBar, SB_SETTEXT, 2, (LPARAM)temp);
					TotalTables = 0;
					CurrentTable = -1;
					File = (unsigned char*)GlobalAlloc(GMEM_FIXED , MaxAddress);
					UnicodeFile = (wchar_t*)File;
					memset(File, 0x00, 2048);
					FileOpen = 1;
					SendMessage(hWndData, WM_SIZE, NULL, NULL);
					SendMessage(hWnd, WM_SETFOCUS, wParam, lParam);
					InvalidateRect(hWndData, NULL, FALSE);
					FileOpenedMenu();
					NewFile = YES;
					wsprintf(temp, "%s %d.%d.%d - [ (Unnamed) ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD);
					if(UnicodeOutput)
						strcat(temp, "Unicode");
					else if (CleanUp)
						strcat(temp, "ASCII");
					else 
						strcat(temp, CPages[CurrentCodePage].name);
					SetWindowText(hWnd, temp);
					return 0;

				case ID_FILE_OPEN:
					// open file
					if(FileOpen) 
					{
						if(!Saved)
						{
							result = MessageBox(hWnd, "Would you like to save your current work?\nPress cancel to return to current file.",
               					    PROGRAM_NAME, MB_YESNOCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON1	);
							if(result == IDCANCEL)
								return 0;
							else if(result == IDYES)
							{
								if(IsPagingOn)
								{

		//****************************************************************************************

									wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
									floop.open(temp, std::ios::out | std::ios::binary);
									floop.write((LPCSTR)File, 0x800000);
									floop.close();
									for(a = 0; a < NumPages; a++)
									{
										if(PagesAltered[a])
										{
											wsprintf(temp, "hxct%04x.tmp", a);
											floop.open(temp, std::ios::in | std::ios::binary);
											floop.read((LPSTR)File, 0x800000);
											floop.close();
											remove(temp);
											kanji = fopen(Filename, "r+b");
											fseek(kanji, a * 0x800000, SEEK_SET);
		#ifdef _DEBUG
											wsprintf(temp, "%08X", ftell(kanji));
											MessageBox(NULL, temp, PROGRAM_NAME, MB_OK);
		#endif
											if(a + 1 == NumPages)
												fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
											else
												fwrite(File, sizeof(unsigned char), 0x800000, kanji);
											fclose(kanji);
											FileStream.close();
											FileStream.open(Filename, std::ios::in | std::ios::binary);
										}
										PagesAltered[a] = 0;
									}
		//****************************************************************************************
								}
								else
								{
									FileStream.open(Filename, std::ios::out | std::ios::binary);
									FileStream.write((LPCSTR)File, MaxAddress);
									FileStream.close();
								}	
								Saved = true;
							}
							GlobalFree(File);
						}
						if(!NewFile)
							SavedTitle(hWnd);
						else
						{
							wsprintf(temp, "%s %d.%d.%d - [ %s ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD, TitleName);
							if(UnicodeOutput)
								strcat(temp, "Unicode");
							else if (CleanUp)
								strcat(temp, "Unicode");
							else 
							{
								strcat(temp, CPages[CurrentCodePage].name);
							}
							SetWindowText(hWnd, temp);
							NewFile = NO;
						}
					}

					switch(OpenFile(hWnd)) {
						case MEM_ERROR:
							wsprintf(temp, "Unable to allocate %d bytes RAM for %s", MaxAddress, TitleName);
							MessageBox(hWnd, temp, PROGRAM_NAME, MB_OK);
							break;

						case FILE_NOT_FOUND:
							MessageBox(hWnd, TEXT("File not found"),PROGRAM_NAME, MB_OK); // debugging
							break;

						case FILE_OPENED:
							SendMessage(hWndData, HX_OPENFILE, WPARAM(NULL), LPARAM(NULL));
							break;

						case FILE_CANCELLED:
							break;
					}
					// force data area redraw
					HighlightOn = false;
					InvalidateRect(hWndData, NULL, FALSE);
					SendMessage(hWnd, WM_SETFOCUS, NULL, NULL);
					return 0;

				case ID_FILE_CLOSE:
					if(!Saved)
						if(!SaveWork(hWnd))
							return 0;
					CloseFiles(hWnd);
					// force data area redraw
					InvalidateRect(hWndData, NULL, FALSE);
					EnableMenuItem(HexecuteMenu, ID_SPECIAL_EDITTABLE, MF_GRAYED);
					return 0;

				case ID_FILE_SAVE:
					if(!FileOpen) return 0;
					//save file
					if(NewFile)
					{
						ZeroMemory(&ofn, sizeof(OPENFILENAME));
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hWnd;
						ofn.lpstrFilter = (LPSTR)Filters;
						ofn.nMaxFile = MAX_PATH;
						ofn.nMaxFileTitle = MAX_PATH;
						ofn.lpstrFile = Filename;
						ofn.lpstrFileTitle = TitleName;
						ofn.lpstrTitle = "Save as...";
						ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
	
						// if we get a file name
						if(!GetSaveFileName(&ofn))
						{								
							return 0;
						}
					}
					if(!Saved)
					{
						if(IsPagingOn)
						{

//****************************************************************************************

							wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
							floop.open(temp, std::ios::out | std::ios::binary);
							floop.write((LPCSTR)File, 0x800000);
							floop.close();
							for(a = 0; a < NumPages; a++)
							{
								if(PagesAltered[a])
								{
									wsprintf(temp, "hxct%04x.tmp", a);
									floop.open(temp, std::ios::in | std::ios::binary);
									floop.read((LPSTR)File, 0x800000);
									floop.close();
									remove(temp);
									kanji = fopen(Filename, "r+b");
									fseek(kanji, a * 0x800000, SEEK_SET);
									if(a + 1 == NumPages)
										fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
									else
										fwrite(File, sizeof(unsigned char), 0x800000, kanji);
									fclose(kanji);
									FileStream.close();
									FileStream.open(Filename, std::ios::in | std::ios::binary);
								}
								PagesAltered[a] = 0;
							}
//****************************************************************************************
						}
						else
						{
							FileStream.open(Filename, std::ios::out | std::ios::binary);
							FileStream.write((LPCSTR)File, MaxAddress);
							FileStream.close();
						}	
						Saved = true;
					}
					if(!NewFile)
						SavedTitle(hWnd);
					else
					{
						wsprintf(temp, "%s %d.%d.%d - [ %s ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD, TitleName);
						if(UnicodeOutput)
							strcat(temp, "Unicode");
						else if (CleanUp)
							strcat(temp, "Unicode");
						else 
						{
							strcat(temp, CPages[CurrentCodePage].name);
						}
						SetWindowText(hWnd, temp);
						NewFile = NO;
					}
					return 0;

				case ID_FILE_SAVEAS:
					if(!FileOpen) return 0;

						ZeroMemory(&ofn, sizeof(OPENFILENAME));
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hWnd;
						ofn.lpstrFilter = (LPSTR)Filters;
						ofn.nMaxFile = MAX_PATH;
						ofn.nMaxFileTitle = MAX_PATH;
						ofn.lpstrFile = Filename;
						ofn.lpstrFileTitle = TitleName;
						ofn.lpstrTitle = "Save as...";
						ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
	
						// if we get a file name
						if(!GetSaveFileName(&ofn))
						{								
							return 0;
						}
						if(IsPagingOn)
						{

//****************************************************************************************

							wsprintf(temp, "hxct%04x.tmp", CurrentPage.offset / 0x800000);
							floop.open(temp, std::ios::out | std::ios::binary);
							floop.write((LPCSTR)File, 0x800000);
							floop.close();
							for(a = 0; a < NumPages; a++)
							{
								if(PagesAltered[a])
								{
									wsprintf(temp, "hxct%04x.tmp", a);
									floop.open(temp, std::ios::in | std::ios::binary);
									floop.read((LPSTR)File, 0x800000);
									floop.close();
									remove(temp);
									kanji = fopen(Filename, "r+b");
									fseek(kanji, a * 0x800000, SEEK_SET);
									if(a + 1 == NumPages)
										fwrite(File, sizeof(unsigned char), MaxAddress % 0x800000, kanji);
									else
										fwrite(File, sizeof(unsigned char), 0x800000, kanji);
									fclose(kanji);
									FileStream.close();
									FileStream.open(Filename, std::ios::in | std::ios::binary);
								}
								PagesAltered[a] = 0;
							}
//****************************************************************************************
						}
						else
						{
							FileStream.open(Filename, std::ios::out | std::ios::binary);
							FileStream.write((LPCSTR)File, MaxAddress);
							FileStream.close();
						}	
						Saved = true;

					if(!NewFile)
						SavedTitle(hWnd);
					else
					{
						wsprintf(temp, "%s %d.%d.%d - [ %s ] - ", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD, TitleName);
						if(UnicodeOutput)
							strcat(temp, "Unicode");
						else if (CleanUp)
							strcat(temp, "Unicode");
						else 
						{
							strcat(temp, CPages[CurrentCodePage].name);
						}
						SetWindowText(hWnd, temp);
						NewFile = NO;
					}
						
						//save with a different file name
					return 0;

				case ID_FILE_EXIT:
					if(!Saved) 
					{
						if(NewFile)
						{
							if(!SaveWork(hWnd)) // if the user hits cancel, else we move on
								return 0;
						}
						else 
						{
							Result = MessageBox(hWnd, "Would you like to save your current work?\nPress cancel to return to current file.",
               				    PROGRAM_NAME, MB_YESNOCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON1	);;
							switch(Result) {
								case IDYES:
									if(IsPagingOn)
									{
										;
									}
									else
									{
										FileStream.open(Filename, std::ios::out | std::ios::binary);
										FileStream.write((LPCSTR)File, MaxAddress);
									}
									FileStream.close();
									GlobalFree(File);
									break;
								case IDNO:
									GlobalFree(File);
									break;
								case IDCANCEL:
									return 0;
							}
						}
					}
					for(matsu = 0; matsu < TotalTables; matsu++)
					{
						if(Table[matsu]->HasBeenChanged())
						{
							wsprintf(temp, "Table %s has been changed.\r\n\r\nWould you like to save?", Table[matsu]->getName());
							if(MessageBox(hWnd, temp, PROGRAM_NAME, MB_YESNO) == IDYES)
								Table[CurrentTable]->GenerateTable(Tablefilename[matsu]);
						}
					}
					SaveSettingsToRegistry();
					FreeConsole();

					UnregisterClass(PROGRAM_NAME, hInst);
					PostQuitMessage(0); // we'll end the program here
					return 0;
				
				case ID_EDIT_CUT:
					if(FileOpen && HighlightOn && (!IsPagingOn)) {
						if(endHighlight > startHighlight) {
							// this part is all the same as copy
							CutLength = endHighlight - startHighlight;
							ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, CutLength);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							for( a = 0; a < CutLength; a++)
							{
								pClipBoardData[a] = GetFileByte(startHighlight + a);
							}
							// now we need to get rid of what we just cut
							memmove(File + startHighlight, File + endHighlight, MaxAddress - endHighlight);
							MaxAddress -= CutLength;
						} else {
							// this part is all the same as copy
							CutLength = startHighlight - endHighlight;
							ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, CutLength);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							for( a = 0; a < CutLength; a++)
							{
								pClipBoardData[a] = GetFileByte(endHighlight + a);
							}
							// now we need to get rid of what we just cut
							memmove(File + endHighlight, File + startHighlight, MaxAddress - startHighlight);
							MaxAddress -= CutLength;
						}
						GlobalUnlock(ClipBoardData);
						OpenClipboard(hWnd);
						EmptyClipboard();
						SetClipboardData(CF_HEXECUTE, ClipBoardData);
						CloseClipboard();
						EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
						wsprintf(temp, "Size: %08X", MaxAddress);
						SendMessage (StatusBar, SB_SETTEXT, 2, (LPARAM)temp);
						if(Saved)
						{
							UnsavedTitle(hWnd);
							Saved = false;
						}
						HighlightOn = false;
						InvalidateRect(hWnd, NULL, TRUE);
					}
					return 0;

				case ID_EDIT_COPY:
					if(FileOpen && HighlightOn) {
						if(endHighlight > startHighlight) {
							CopyLength = endHighlight - startHighlight;
							ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, CopyLength);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							for( a = 0; a < CopyLength; a++)
							{
								pClipBoardData[a] = GetFileByte(startHighlight + a);
							}
						} else {
							CopyLength = startHighlight - endHighlight;
							ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, CopyLength);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							for( a = 0; a < CopyLength; a++)
							{
								pClipBoardData[a] = GetFileByte(endHighlight + a);
							}
						}
						GlobalUnlock(ClipBoardData);
						OpenClipboard(hWnd);
						EmptyClipboard();
						SetClipboardData(CF_HEXECUTE, ClipBoardData);
						CloseClipboard();
						EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
					}
					return 0;

				case ID_COPY_SELECTED:
					if(endHighlight > startHighlight) {
						Dumpy.length = endHighlight - startHighlight;
						Dumpy.offset = startHighlight;
					} else {
						Dumpy.length = startHighlight - endHighlight;
						Dumpy.offset = endHighlight;
					}
					DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_SCRIPTDUMP), hWnd, DumpProc, 1);
					return 0;

				case ID_EDIT_COPYSTRING:
					if(FileOpen && HighlightOn) {
						if(endHighlight > startHighlight) {
							CopyLength = endHighlight - startHighlight;
							ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, 65355);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							CopyString(pClipBoardData, startHighlight, CopyLength);
						} else {
							CopyLength = startHighlight - endHighlight;
							ClipBoardData = GlobalAlloc(GHND | GMEM_SHARE | GMEM_ZEROINIT, 65355);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							CopyString(pClipBoardData, endHighlight, CopyLength);
						}
						pClipBoardData[strlen(pClipBoardData)] = 0x00; // terminate the string
						GlobalUnlock(ClipBoardData);
						OpenClipboard(hWnd);
						EmptyClipboard();
						SetClipboardData(CF_TEXT, ClipBoardData);
						CloseClipboard();
						EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
					}					
					return 0;

				case ID_EDIT_COPYAS_TEXT:
					pClipBoardData = NULL;
					CopyAsText(hWnd, ClipBoardData, pClipBoardData);
					return 0;

				case ID_EDIT_COPYAS_CHARARRAY:
					pClipBoardData = NULL;
					CopyAsCharArray(hWnd, ClipBoardData, pClipBoardData);
					return 0;

				case ID_EDIT_COPYAS_SHORTARRAY:
					pClipBoardData = NULL;
					CopyAsShortArray(hWnd, ClipBoardData, pClipBoardData);
					return 0;

				case ID_EDIT_COPYAS_LONGARRAY:
					pClipBoardData = NULL;
					CopyAsIntArray(hWnd, ClipBoardData, pClipBoardData);
					return 0;

				case ID_EDIT_COPYAS_BIGENDIAN:
					if(!BigEndian)
					{
						CheckMenuItem(HexecuteMenu, ID_EDIT_COPYAS_BIGENDIAN, MF_BYCOMMAND | MF_CHECKED);
						BigEndian = YES;
					}
					else 
					{
						CheckMenuItem(HexecuteMenu, ID_EDIT_COPYAS_BIGENDIAN, MF_BYCOMMAND | MF_UNCHECKED);
						BigEndian = NO;
					}
					return 0;

				case ID_EDIT_PASTE:
					if(FileOpen) {
						// the first thing we do is check for an
						// available hexecute format in the clipboard
						if(IsClipboardFormatAvailable(CF_HEXECUTE)) {
							OpenClipboard(hWnd);
							ClipBoardData = GetClipboardData(CF_HEXECUTE);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							if(HighlightOn)						
							{
								// this will simply overwrite the size of the clipboard data
								// regardless of what's highlighted if it's in overwrite mode
								if(OverWrite || IsPagingOn) { // we shouldn't EVER have these two be in disagreement, but just in case
									if(endHighlight > startHighlight) {
										SafeMemCopy(File, startHighlight, pClipBoardData, GlobalSize(ClipBoardData));
									} else {
										SafeMemCopy(File, endHighlight, pClipBoardData, GlobalSize(ClipBoardData));
									}
								}
								else {
									if(endHighlight > startHighlight) {
										nihon = MaxAddress - ( endHighlight - startHighlight ) + GlobalSize(ClipBoardData);
										unsigned char* tempFile = (unsigned char*)GlobalAlloc(GMEM_FIXED, nihon);
										ZeroMemory(tempFile, MaxAddress - ( endHighlight - startHighlight ) + GlobalSize(ClipBoardData) );
										memcpy(tempFile, File, startHighlight);
										memcpy(tempFile + startHighlight, pClipBoardData, GlobalSize(ClipBoardData));
										memcpy(tempFile + startHighlight + GlobalSize(ClipBoardData), File + endHighlight, MaxAddress - endHighlight);
										MaxAddress = nihon;
										GlobalFree(File);
										File = tempFile;
										wsprintf(temp, "Size: %08X", MaxAddress);
										SendMessage (StatusBar, SB_SETTEXT, 2, (LPARAM)temp);
									} else {
										nihon = MaxAddress - (  startHighlight - endHighlight) + GlobalSize(ClipBoardData);
										unsigned char* tempFile = (unsigned char*)GlobalAlloc(GMEM_FIXED, nihon);
										ZeroMemory(tempFile, MaxAddress - (  startHighlight - endHighlight ) + GlobalSize(ClipBoardData) );
										memcpy(tempFile, File, endHighlight);
										memcpy(tempFile + endHighlight, pClipBoardData, GlobalSize(ClipBoardData));
										memcpy(tempFile + endHighlight + GlobalSize(ClipBoardData), File + startHighlight, MaxAddress - startHighlight);
										MaxAddress = nihon;
										GlobalFree(File);
										File = tempFile;
										wsprintf(temp, "Size: %08X", MaxAddress);
										SendMessage (StatusBar, SB_SETTEXT, 2, (LPARAM)temp);
									}
								}
							}
							else
							{
								// this will simply overwrite the size of the clipboard data
								// regardless of what's highlighted if it's in overwrite mode
								if(OverWrite || IsPagingOn) { // we shouldn't EVER have these two be in disagreement, but just in case
									SafeMemCopy(File, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ), 
										pClipBoardData, GlobalSize(ClipBoardData));
								}
								else {
									nihon = CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 );
									unsigned char* tempFile = (unsigned char*)GlobalAlloc(GMEM_FIXED, MaxAddress + GlobalSize(ClipBoardData));
									ZeroMemory(tempFile, MaxAddress + GlobalSize(ClipBoardData) );
									memcpy(tempFile, File, nihon);
									memcpy(tempFile + nihon, pClipBoardData, GlobalSize(ClipBoardData));
									memcpy(tempFile + nihon + GlobalSize(ClipBoardData), File + nihon, MaxAddress - nihon);
									MaxAddress += GlobalSize(ClipBoardData);
									GlobalFree(File);
									File = tempFile;
									wsprintf(temp, "Size: %08X", MaxAddress);
									SendMessage (StatusBar, SB_SETTEXT, 2, (LPARAM)temp);
								}
							}
							GlobalUnlock(ClipBoardData);
							CloseClipboard();
							InvalidateRect(hWnd, NULL, FALSE);
						}	
						// we need to add some sort of timer message that checks for availability of cut and pasted data
						else if (IsClipboardFormatAvailable(CF_TEXT)) {
							OpenClipboard(hWnd);
							ClipBoardData = GetClipboardData(CF_TEXT);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
			
							if(CurrentTable == -1)
							{
								SafeMemCopy(File, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ), 
											pClipBoardData, GlobalSize(ClipBoardData));
							}
							else
							{
								romh = GlobalSize(ClipBoardData) - 1;
								for( l = 0; l < romh;) {
									for( b = Table[CurrentTable]->getLongestEntry() ; b > 0 ; b-- )
									{
										// we'll run through our options starting with the longest string
										// so as to get the maximum compressoin that we can get from a DTE
										// based table
										for(q = 0; q < b; q++) {
											temp2[q] = pClipBoardData[q + l];
										}
										temp2[q] = 0x00;
										if( Table[CurrentTable]->getMatchingNode(temp2) ) {
											yeehaw = Table[CurrentTable]->getMatchingNode(temp2);
											if ( yeehaw->value > 0xFFFFFF )
												c = 4;
											else if ( yeehaw->value > 0xFFFF )
												c = 3;
											else if ( yeehaw->value > 0xFF )
												c = 2;
											else c = 1;
											for(o = c, i = 0; o > 0; o--, i++)
											{
												SetFileByte(CurrentStartAddress + mmhmm + i + r,
													( yeehaw->value & MASK[ o - 1 ] ) >> ( 8 * ( o - 1 ) ));
												r += c;
											}
											break;
										}

									}
								if(!b)
									b++;
								l += b;								
								}
							}

							GlobalUnlock(ClipBoardData);
							CloseClipboard();
							InvalidateRect(hWnd, NULL, FALSE);
						}
						else if (IsClipboardFormatAvailable(CF_UNICODETEXT)) {
							OpenClipboard(hWnd);
							ClipBoardData = GetClipboardData(CF_UNICODETEXT);
							pClipBoardData = (PTSTR)GlobalLock(ClipBoardData);
							GlobalUnlock(ClipBoardData);
							CloseClipboard();
							InvalidateRect(hWnd, NULL, FALSE);
						}
						if(Saved)
						{
							UnsavedTitle(hWnd);
							Saved = false;
						}
					}
					return 0;

				case ID_EDIT_UNDO:
					SendMessage(hWndData, HX_CHAR, 0x1A, 0);
					if(Saved)
					{
						UnsavedTitle(hWnd);
						Saved = false;
					}
					return 0;

				case ID_EDIT_REDO:
					SendMessage(hWndData, HX_CHAR, 0x19, 0);
					if(Saved)
					{
						UnsavedTitle(hWnd);
						Saved = false;
					}
					return 0;

				case ID_EDIT_FIND:
					if(DialogBox(hInst, MAKEINTRESOURCE(IDD_FIND_DIALOG), hWnd, FindProc))
					{
						/* we found something *
						 * if we take this    *
						 * branch of code     */
						//si.cbSize = sizeof(SCROLLINFO);
						//si.fMask = SIF_ALL;
						//GetScrollInfo(hWndData, SB_VERT, &si);
						//si.nPos = ( wasabi & 0xFFFFFFF0 ) >> 4;
						//SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
						InvalidateRect(hWndData, NULL, FALSE);
					}
					else
					{
						/* we found nothing *
						 * if we go here    */
						;
					}
//					ShowWindow(SearchWindow, SW_SHOWNORMAL);
					return 0;
				
				case ID_EDIT_FINDNEXT:
					SendMessage(hWndData, HX_KEYDOWN, WPARAM(VK_F3), lParam);
					return 0;

				case ID_EDIT_SELECTLINE:
					ZeroMemory(&si, sizeof(SCROLLINFO));
					si.cbSize = sizeof(SCROLLINFO);
					si.fMask = SIF_ALL;
					GetScrollInfo(hWndData, SB_VERT, &si);
					startHighlight = ( si.nPos + yMouse ) * 16;
					endHighlight = ( si.nPos + yMouse + 1) * 16;
					CutAndCopyEnableMenu();
					HighlightOn = YES;
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_EDIT_SELECTALL:
					startHighlight = 0;
					endHighlight = MaxAddress;
					CutAndCopyEnableMenu();
					HighlightOn = YES;
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_EDIT_GOTO:
					if(DialogBox(hInst, MAKEINTRESOURCE(IDD_GOTO), hWnd, GoToProc))
					{
						si.cbSize = sizeof(SCROLLINFO);
						si.fMask = SIF_ALL;
						GetScrollInfo(hWndData, SB_VERT, &si);
						si.nPos = goToAddress / 16;
						SetScrollInfo(hWndData, SB_VERT, &si, TRUE);
						InvalidateRect(hWndData, NULL, FALSE);
						CurrentPosition = goToAddress % 16;
						RealPosition = CurrentPosition;
						yMouse = 0;
						SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);
						UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
					}
					return 0;

				case IDM_BOOKMARK0:
					goToAddress = BookMarks[0];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK1:
					goToAddress = BookMarks[1];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK2:
					goToAddress = BookMarks[2];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK3:
					goToAddress = BookMarks[3];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK4:
					goToAddress = BookMarks[4];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK5:
					goToAddress = BookMarks[5];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK6:
					goToAddress = BookMarks[6];
					GoToBookmark();
					return 0;

				case IDM_BOOKMARK7:
					goToAddress = BookMarks[7];
					GoToBookmark();
					return 0;

				case ID_OPTIONS_DATAVIEWER:
					DataBarShow ^= true;
					if(DataBarShow)
						CheckMenuItem(HexecuteMenu, ID_OPTIONS_DATAVIEWER, MF_CHECKED);
					else CheckMenuItem(HexecuteMenu, ID_OPTIONS_DATAVIEWER, MF_UNCHECKED);
					return 0;

				case ID_VIEW_STATUSBAR:
					// this will turn the statusbar on and off
					StatusBarShow ^= true;
					if(StatusBarShow)
						CheckMenuItem(HexecuteMenu, ID_VIEW_STATUSBAR ,MF_CHECKED);
					else CheckMenuItem(HexecuteMenu, ID_VIEW_STATUSBAR ,MF_UNCHECKED);
					ResizeWindows(hWnd, hWndData, StatusBar, hWndToolBar, StatusBarShow, ToolBarShow);
					return 0;

				case ID_VIEW_TOOLBARS:
					ToolBarShow ^= true;
					if(ToolBarShow)
					{
						CheckMenuItem(HexecuteMenu, ID_VIEW_TOOLBARS ,MF_CHECKED);
						TempWindowLong = GetWindowLong(hWndToolBar, GWL_STYLE);
						TempWindowLong ^= WS_VISIBLE;
						SetWindowLong(hWndToolBar, GWL_STYLE, TempWindowLong);
					}
					else 
					{
						CheckMenuItem(HexecuteMenu, ID_VIEW_TOOLBARS ,MF_UNCHECKED);
						TempWindowLong = GetWindowLong(hWndToolBar, GWL_STYLE);
						TempWindowLong ^= WS_VISIBLE;
						SetWindowLong(hWndToolBar, GWL_STYLE, TempWindowLong);
					}
					ResizeWindows(hWnd, hWndData, StatusBar, hWndToolBar, StatusBarShow, ToolBarShow);
					return 0;
				
				case ID_OPTIONS_PREFERENCES:
					// bring up the preferences dialog
					CreatePropertySheet(hWnd);
					GetClientRect(hWndData, &rect);
				// Nicolas - crashpoint
					Positions = new int*[( rect.bottom / cyChar ) + 1];
					for(wasabi = 0; wasabi < ( ( rect.bottom / cyChar ) + 1 ) ; wasabi++)
					{
						Positions[wasabi] = new int[32];

						// here we reinitialize the rows of positions that we need
						for(nihon = 0; nihon < 32; nihon++)
							Positions[wasabi][nihon] = PositionInit[GroupSize - 1][nihon];

					}
					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_TABLES_OPENTABLE:
					switch(OpenTableFile(hWnd)) {
						case MEM_ERROR:
							wsprintf(temp, "Unable to allocate %d bytes RAM for %s", MaxAddress, TitleName);
							MessageBox(hWnd, temp, PROGRAM_NAME, MB_OK);
							break;

						case FILE_NOT_FOUND:
							MessageBox(hWnd, TEXT("File not found"), PROGRAM_NAME, MB_OK); // debugging
							break;

						case FILE_OPENED:
							EnableMenuItem(HexecuteMenu, ID_SPECIAL_DUMPTEXT, MF_ENABLED);
							EnableMenuItem(HexecuteMenu, ID_SPECIAL_INSERTTEXT, MF_ENABLED);
//							EnableMenuItem(HexecuteMenu, ID_SPECIAL_EDITTABLE, MF_ENABLED);
							break;

						case FILE_CANCELLED:
							break;
					}

					InvalidateRect(hWndData, NULL, FALSE);
					return 0;

				case ID_SPECIAL_EDITTABLE:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_TABLE_FILE_EDITOR), hWnd, TableEditorProc);
					SendMessage(hWnd, WM_SIZE, NULL, NULL);
					return 0;

				// this is where we will be inserting text from a file
				// and it will be based on a table file
				case ID_SPECIAL_INSERTTEXT:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_SCRIPTINSERT), hWnd, ScriptInsertProc);
					InvalidateRect(hWnd, NULL, FALSE);
					if(Saved)
					{
						UnsavedTitle(hWnd);
						Saved = false;
					}
					return 0;

				// yaya, a script dumper, the reason people first started making
				// hex editors for romh4x0ring, can't forget this most useful of
				// features
				case ID_SPECIAL_DUMPTEXT:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_SCRIPTDUMP), hWnd, DumpProc);
					return 0;

				case ID_SPECIAL_SPLITFILE:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_SPLIT_BANKS), hWnd, BankSplitProc);
					return 0;
				
				case ID_SPECIAL_EXPANDFILE:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_EXPAND_FILE), hWnd, ExpandFileProc);
					if(Saved)
					{
						UnsavedTitle(hWnd);
						Saved = false;
					}
					return 0;

				case ID_HELP_CONTENTS:
					HtmlHelp(NULL, "hexecute.chm::/welcome.html", HH_DISPLAY_TOPIC, 0);
					return 0;

				case ID_HELP_ABOUTHEXECUTE:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT_BOX), hWnd, AboutProc);
					return 0;

				case ID_HELP_ABOUTTHEAUTHOR:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT_AUTHOR), hWnd, AboutProc);
					return 0;

			}
			return 0;

		case WM_NOTIFY:
			// when we get a tooltip message
			switch(((LPNMHDR)lParam)->code) {

				case TTN_NEEDTEXT: 
					// Display the ToolTip text.
					ToolTipText = (LPTOOLTIPTEXT)lParam;
					ToolTipText->hinst = hInst;
					switch(ToolTipText->hdr.idFrom) {
						case ID_FILE_NEW: ToolTipText->lpszText = ToolTips[0]; break;
						case ID_FILE_OPEN: ToolTipText->lpszText = ToolTips[1]; break;
						case ID_FILE_SAVE: ToolTipText->lpszText = ToolTips[2]; break;
						case ID_EDIT_CUT: ToolTipText->lpszText = ToolTips[3]; break;
						case ID_EDIT_COPY: ToolTipText->lpszText = ToolTips[4]; break;
						case ID_EDIT_PASTE: ToolTipText->lpszText = ToolTips[5]; break;
						case ID_HELP_ABOUTHEXECUTE: ToolTipText->lpszText = ToolTips[6]; break;
						case ID_EDIT_UNDO: ToolTipText->lpszText = ToolTips[7]; break;						
						case ID_EDIT_REDO: ToolTipText->lpszText = ToolTips[8]; break;
						case ID_EDIT_FIND: ToolTipText->lpszText = ToolTips[9]; break;
					}
			}
			return 0;

		case WM_SETFOCUS:		// this is called whenever the program gets the focus
			if(!FileOpen) return 0;

      		hdc = GetDC(hWndData); // gets the device context for hwnd so it can be used
			// here we get the character font so that we can compare the hex
			// and the character to get cyChar
			if(CurrentTable == -1)
			{
				if(CleanUp)
				{
					if(UnicodeOutput)
						SelectObject(hdc, hFontUnicode);
					else
						SelectObject(hdc, hFont);
				}
				else 
					SelectObject(hdc, CPages[CurrentCodePage].font);
			}		
			else 
				SelectObject(hdc, tblFont[CurrentTable]);
			GetTextMetrics(hdc, &tm);
			cyTemp1 = tm.tmHeight + tm.tmExternalLeading;

            SelectObject(hdc, hFontHex);
            GetTextMetrics(hdc, &tm);  // gets the data of the new font
            cxChar = tm.tmMaxCharWidth;  // cxChar is the width of the font letters
            cyTemp2 = tm.tmHeight + tm.tmExternalLeading; // this is the height of the font

			cyChar = ( cyTemp1 > cyTemp2 ? cyTemp1 : cyTemp2 );

            ReleaseDC(hWndData, hdc); // release the device context
            CreateCaret(hWndData, NULL, 1, cyChar);  // create the 'caret'
			// making sure we keep things where they should be
		// Nicholas - crashpoint
			if ( Positions )
				SetCaretPos(Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);  // sets the caret position to in front of the first character
			UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
            ShowCaret(hWndData);             // shows the caret
      		return 0;

		case WM_KILLFOCUS:	// this is called whenever the program loses focus

            HideCaret(hWndData); // hides the caret
            DestroyCaret();  // destroys the current caret
      		return 0;

		// this is how I need to do it, but now I need to pass information
		// to the data window about what keys where hit and whatnot, I'm
		// thinking about just passing the whole wParam and lParam and registering
		// my own message.
		case WM_CHAR:
			//MessageBox(hWnd, TEXT("WM_CHAR SENT"), PROGRAM_NAME, MB_OK);

			SendMessage(hWndData, HX_CHAR, wParam, lParam);
			return 0;

		case WM_KEYDOWN:
			//MessageBox(hWnd, TEXT("WM_KEYDOWN SENT"), PROGRAM_NAME, MB_OK);
			SendMessage(hWndData, HX_KEYDOWN, wParam, lParam);
			return 0;

		/*
		 * for the moment, this is disabled, as I can't seem to 
		 * get the IME to send me anything other than question marks
		 */

		case WM_IME_CHAR:
			return 0;

		case WM_IME_STARTCOMPOSITION:
			pointImeLocation.x = Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar);
			pointImeLocation.y = yMouse * cyChar;
			// convert where we want our ime to be on the data window to screen coordinates
			ClientToScreen(hWndData, &pointImeLocation);
			// convert them to a coordinate based on the main hexecute window, as that is the
			// one that the IME is technically connected to
			ScreenToClient(hWnd, &pointImeLocation);
			hIMC = ImmGetContext(hWnd);
			cf.dwStyle = CFS_FORCE_POSITION;
			cf.ptCurrentPos.x = pointImeLocation.x;
			cf.ptCurrentPos.y = pointImeLocation.y;
			ImmSetCompositionWindow(hIMC, &cf);
			ImmReleaseContext(hWnd, hIMC);
			break;

		case WM_IME_COMPOSITION:
			ZeroMemory(minnasan, sizeof(minnasan));
			hIMC = ImmGetContext(hWnd);
			wasabi = ImmGetCompositionString(hIMC, GCS_RESULTSTR, NULL, 0);
			ImmGetCompositionStringW(hIMC, GCS_RESULTSTR, minnasan, 200);
			ImmReleaseContext(hWnd, hIMC);
			break;

		case WM_IME_ENDCOMPOSITION:       
			if( CurrentTable == -1 )
			{
				if(!UnicodeOutput)
				{
					// we're getting the number of characters needed to hold the string
					wasabi = WideCharToMultiByte(932, NULL, minnasan, -1, NULL, NULL, NULL, NULL);
					if(!wasabi || wasabi == 1)
						return 0;
					lpstr = new char[wasabi + 2];
					wasabi = WideCharToMultiByte(932, NULL, minnasan, -1, lpstr, wasabi, NULL, NULL);
					SafeMemCopy(File, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ), lpstr, wasabi - 1);
				}
				else
				{
					if(!BigEndian)
					{
						SafeMemCopyW(File, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ),
							minnasan, wasabi);
					}
					else
					{
						for ( int a = 0; a < wasabi; a++)
							minnasan[a] = MakeUnicodeBigEndian(minnasan[a]);
						SafeMemCopyW(File, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ),
							minnasan, wasabi);
					}
				}
				CurrentPosition += wasabi - 1;
				if(CurrentPosition > 31)
				{
					CurrentPosition -= 16;
					yMouse++;
				}
				RealPosition = CurrentPosition;
				SetCaretPos( ( Positions[yMouse][CurrentPosition] )- ( HorizontalOffset * cxChar), yMouse * cyChar);
				UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));
				if(Saved)
				{
					UnsavedTitle(hWnd);
					Saved = false;
				}
				InvalidateRect(hWndData, NULL, FALSE);
			}
			else 
			{
				r = 0;
				wasabi = WideCharToMultiByte(932, NULL, minnasan, -1, NULL, NULL, NULL, NULL);
				if(!wasabi || wasabi == 1)
					return 0;
				lpstr = new char[wasabi + 2];
				wasabi = WideCharToMultiByte(932, NULL, minnasan, -1, lpstr, wasabi, NULL, NULL);
				// here we do the actual insert into the file
				DoInsertConversion(lpstr);
				for( l = 0; l < wasabi - 1;) {
					for( b = Table[CurrentTable]->getLongestEntry() ; b > 0 ; b-- )
					{
						// we'll run through our options starting with the longest string
						// so as to get the maximum compressoin that we can get from a DTE
						// based table
						for(q = 0; q < b; q++) {
							temp[q] = lpstr[q + l];
						}
						temp[q] = 0x00;
						nihon = 0;
						if( Table[CurrentTable]->getMatchingNode(temp) ) {
							yeehaw = Table[CurrentTable]->getMatchingNode(temp);
							if ( yeehaw->value > 0xFFFFFF )
								c = 4;
							else if ( yeehaw->value > 0xFFFF )
								c = 3;
							else if ( yeehaw->value > 0xFF )
								c = 2;
							else c = 1;
							switch(c) {
								case 1:
									SetFileByte(CurrentStartAddress + mmhmm + r + (yMouse * 16) + ( CurrentPosition % 16 ),
										yeehaw->value);
									r += c;
									break;
								case 2:
									SetFileByte(CurrentStartAddress + mmhmm + r + (yMouse * 16) + ( CurrentPosition % 16 ),
										( ( yeehaw->value & MASK[ 1 ] ) >> 8 ));
									SetFileByte(CurrentStartAddress + mmhmm + r + 1 + (yMouse * 16) + ( CurrentPosition % 16 ),
										( yeehaw->value & MASK[ 0 ] ));
									r += c;
									break;
								case 3:
									SetFileByte(CurrentStartAddress + mmhmm + r + (yMouse * 16) + ( CurrentPosition % 16 ),
										( ( yeehaw->value & MASK[ 2 ] ) >> 16 ));
									SetFileByte(CurrentStartAddress + mmhmm + r + 1 + (yMouse * 16) + ( CurrentPosition % 16 ),
										( ( yeehaw->value & MASK[ 1 ] ) >> 8 ));
									SetFileByte(CurrentStartAddress + mmhmm + r + 2 + (yMouse * 16) + ( CurrentPosition % 16 ),
										( yeehaw->value & MASK[ 0 ] ));
									r += c;
									break;
								case 4:
									SetFileByte(CurrentStartAddress + mmhmm + r + (yMouse * 16) + ( CurrentPosition % 16 ),
										( ( yeehaw->value & MASK[ 3 ] ) >> 24 ));
									SetFileByte(CurrentStartAddress + mmhmm + r + 1 + (yMouse * 16) + ( CurrentPosition % 16 ),
										( ( yeehaw->value & MASK[ 2 ] ) >> 16 ));
									SetFileByte(CurrentStartAddress + mmhmm + r + 2 + (yMouse * 16) + ( CurrentPosition % 16 ),
										( ( yeehaw->value & MASK[ 1 ] ) >> 8 ));
									SetFileByte(CurrentStartAddress + mmhmm + r + 3 + (yMouse * 16) + ( CurrentPosition % 16 ),
										( yeehaw->value & MASK[ 0 ] ));
									r += c;
									break;
							}
							break;
						}
					}
					if(!b)
						b++;
					l += b;
				}
				// end of the actual insertion in the file
//				Table[CurrentTable]->sort();
				InvalidateRect(hWndData, NULL, FALSE);
			}
			Saved = false;
			return 0;


		case WM_TIMER:
			switch(wParam) {
				case TIMER_1_SEC:
					if(FileOpen)
					{
						if(IsClipboardFormatAvailable(CF_HEXECUTE))
						{
							EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
							return 0;
						}
						else
							EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_GRAYED);
						if(IsClipboardFormatAvailable(CF_TEXT))
						{
							EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_ENABLED);
							return 0;
						}
						else
							EnableMenuItem(HexecuteMenu, ID_EDIT_PASTE, MF_GRAYED);
					}
			}
			return 0;


		// when someone hits the "x"
		case WM_CLOSE:
			SendMessage(hWnd, WM_COMMAND, LOWORD(ID_FILE_EXIT), NULL);
			return 0;

		case WM_ERASEBKGND:
			return 0;
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}
