/*
 * Hexecute 3.0
 * globals.cpp
 * copyright 2000 Mike Walston
 *
 * All global variables are defined here
 * This is platform dependant
 */

#include <windows.h>
#include <commctrl.h>
#include <fstream>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

historyStack History;

TCHAR	AppName[]	= PROGRAM_NAME,
		DataClass[]	= TEXT("DataWindow"),
		MainClass[]	= TEXT("MainFlatWindow"),
		Filename[MAX_PATH]	= TEXT(""),
		TitleName[MAX_PATH]	= TEXT(""),
		TableTitleName[MAX_PATH] = TEXT(""),
		Tablefilename[4][MAX_PATH]	= { 
											TEXT(""),
											TEXT(""),
											TEXT(""),
											TEXT("") }, 
		FontName[50] = { TEXT("Courier New") }, 
		HexFontName[50] = { TEXT("Courier New") }, 
		JapaneseFontName[50] = { TEXT("MS Mincho") },
		KoreanFontName[50] = { TEXT("@Batang") },
		SimplifiedChineseFontName[50] = { TEXT("PMingLiU") },
		TraditionalChineseFontName[50] = { TEXT("PMingLiU") },
		ThaiFontName[50] = { TEXT("Tahoma") },
		UnicodeFontName[50] = { TEXT("Lucida Sans Unicode") },
		Filters[] = TEXT("All Files (*.*)\0*.*\0Executable Files (*.exe)\0*.exe\0CD Images(*.bin,*.iso)\0*.bin;*.iso\0Wonderswan Color(*.wsc)\0*.wsc\0Super Nintendo(*.smc,*.fig,*.swc,*.sfc,*.usa)\0*.smc;*.fig;*.swc;*.sfc;*.usa\0Nintendo(*.fam,*.nes)\0*.nes;*.fam;\0Famicom Disk System(*.fds)\0*.fds\0Gameboy(*.gb,*.gbc,*.gba)\0*.gb;*.gbc;*.gba\0Nintendo 64(*.n64,*.v64)\0*.n64;*.v64\0Virtual Boy(*.vb)\0*.vb\0PC-Engine(*.pce)\0*.pce\0Sega Master System/Mega Drive(*.smd,*.bin)\0*.smd;*.bin\0Coleco Vision(*.rom)\0*.rom\0Apple ][(*.dsk)\0*.dsk\0SNES Save Ram(*.srm)\0*.srm\0"),
		TableFilter[] = TEXT("Table Files(*.tbl)\0*.tbl\0All Files (*.*)\0*.*\0");

TCHAR	HexecuteAppKey[] = "SOFTWARE\\Hexecute",
		AddressColorKey[] = "AddressColor",
		AddressBGColorKey[] = "AddressBGColor",
		OddColumnColorKey[] = "OddColumnColor",
		EvenColumnColorKey[] = "EvenColumnColor",
		HexBGColorKey[] = "HexBGColorKey",
		HighlightColorKey[] = "HighlightColor",
		TextColorKey[] = "TextColor",
		TextBGColorKey[] = "TextBGColor",
		HighlightTextColorKey[] = "HighlightTextColor",
		NumRecentFilesKey[] = "NumRecentFiles",
		RecentFile0Key[] = "RecentFile0",
		RecentFile1Key[] = "RecentFile1",
		RecentFile2Key[] = "RecentFile2",
		RecentFile3Key[] = "RecentFile3",
		RecentFileTitle0Key[] = "RecentFileTitle0",
		RecentFileTitle1Key[] = "RecentFileTitle1",
		RecentFileTitle2Key[] = "RecentFileTitle2",
		RecentFileTitle3Key[] = "RecentFileTitle3",
		CodePagesKey[] = "SOFTWARE\\Hexecute\\CodePages",
		CurrentCodePageKey[] = "CurrentCodePage",
		HexFontKey[] = "HexFont",
		NumPagesKey[] = "CodePageCount",
		SizeKey[] = "Size", 
		*RecentFile0,
		*RecentFile1,
		*RecentFile2,
		*RecentFile3,
		*RecentFileTitle0,
		*RecentFileTitle1,
		*RecentFileTitle2,
		*RecentFileTitle3,
		UnicodeFontKey[] = "Unicode",
		ShowSplashKey[] = "ShowSplash",
		AllowPagingKey[] = "AllowPaging",
		CommandLine[1000],
		CommandLineTitle[1000],
		BookmarkStrings[8][256];

DumpStruct Dumpy;

long	AddressColor = 0x00000000, 
		AddressBGColor = 0x00CCCCCC,
		OddColumnColor = 0x007F0000,
		EvenColumnColor = 0x00FF0000,
		HexBGColor = 0x00FFFFFF,
		HighlightColor = 0x00BBBBBB,
		TextColor = 0x00000000,
		TextBGColor = 0x00FFFFFF,
		HighlightTextColor = 0x00FFFFFF,
		FontHeight = -20,
		HexFontHeight, 
		JapaneseFontHeight, 
		SimplifiedChineseFontHeight, 
		TraditionalChineseFontHeight,
		KoreanFontHeight, 
		ThaiFontHeight,
		CurrentStartAddress = 0,
		MaxAddress = 0,
		CF_HEXECUTE;

int		FileOpen,
		MouseRow = 0,
		TotalTables = 0, 
		NewFile = NO,
		CurrentTable = -1,
		cyChar,
		cxChar, 
		LeftOverChars[100], 
		ViewAsHiRom = 0, 
		ViewAsLoRom = 0, 
		ViewAsNES = 0,
		width, 
		height, 
		HexOrDec = HEX, 
		mmhmm, 
		yMouse, 
		Value = 1, 
		Relative = 0,
		Warnings = OVERWRITING_START_FLAG + OVERWRITING_END_FLAG,
		Text = 1,
		startHighlight = 0, 
		endHighlight = 0, 
		GroupSize = 2, 
		CleanUp = 1,
		InstalledPage = 0, 
		CurrentCodePage = 0,
		NumPages = 1,
		NumRecentFiles = 0,
		ShowSplash = 1,
		AllowPaging = 0,
		IsPagingOn = 0,
		BookMarks[8] = { 0,0,0,0,0,0,0,0 },
		BookmarkCounter = 0;

int **Positions = (int**)NULL;

bool	Saved = true, 
		UnicodeOutput = false,
		BigEndian = false,
		InsideSubtable = false;

HFONT	tblFont[4], 
		hFont, 
		hFontHex, 
		hFontJapanese, 
		kamaitachiHFont,
		hFontUnicode;

HANDLE hConsole;
LRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DataWinProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK FrameWinProc(HWND, UINT, WPARAM, LPARAM);
BOOL	CALLBACK DisplayProc(HWND, UINT, WPARAM, LPARAM);
BOOL	CALLBACK FontProc(HWND, UINT, WPARAM, LPARAM);
BOOL	CALLBACK FindProc(HWND, UINT, WPARAM, LPARAM);
BOOL	CALLBACK InsertProc(HWND, UINT, WPARAM, LPARAM);
HIMAGELIST hImageList;

void	InitializeWndClassMain(WNDCLASS*, HINSTANCE);
void	InitializeWndClassData(WNDCLASS*, HINSTANCE);
void	ResizeWindows(HWND, HWND, HWND, HWND, int, int);
void	InitializeComboBoxArray(COMBOBOXTEXT[3]);
void	SetComboBoxText(HWND, COMBOBOXTEXT*);
void	SaveLastComboBoxText(HWND, char*, char*, char*, const int&, const int&, 
						  const int&, const int&, const int&);
int		SaveWork(HWND);
int		OpenFile(HWND);
int		OpenTableFile(HWND);
int		CalcPosition(int*, int);
int		ResetPosition(int*);
int		CreatePropertySheet(HWND);
int		ParseTable(std::fstream&, table&, char*);
DWORD	SMCToLoROM(DWORD dwSMC);
DWORD	LoROMToSMC(DWORD dwLoROM);
DWORD	SMCToHiROM(DWORD dwSMC);
DWORD	HiROMToSMC(DWORD dwHiROM);
WORD	NEStoOffset(DWORD dwNES, DWORD PageSize, DWORD StartingOffset);
DWORD NESOffset = 0x8000, NESPageSize = 0x8000;

HMENU	HexecuteMenu,
		ContextMenu;

HINSTANCE hInst;

HBITMAP EndLine, EndString, EndLineMask, EndStringMask;

std::fstream FileStream;

unsigned char *File;
wchar_t* UnicodeFile;
Page CurrentPage;
int* PagesAltered;

table* Table[4];

CHOOSEFONT cf;

LOGFONT Font, 
		kamaitachiLogFont;

LOGFONTW UnicodeFont;

TEXTMETRIC	tm, 
			tm2;

HWND	SearchWindow, 
		hWndData, 
		hWndFont;

tableEntry emptyNode;

POINT CursorPoint;

SCROLLINFO si;

CodePage CPages[20];

int NumChanges = 0;

LPCOMBOBOXTEXT	cbtTextRelative, 
				cbtTextValue, 
				cbtDecimal;

//TCHAR UnicodeFontName[50] = { TEXT("Arial Unicode MS") };

//toolbar buttson
TBBUTTON tbButtons [] = 
	{
		{0, ID_FILE_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{1, ID_FILE_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{2, ID_FILE_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
		{3, ID_EDIT_CUT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{4, ID_EDIT_COPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{5, ID_EDIT_PASTE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
		{9, ID_EDIT_UNDO, TBSTATE_INDETERMINATE, TBSTYLE_BUTTON, 0L, 0},
		{8, ID_EDIT_REDO, TBSTATE_INDETERMINATE, TBSTYLE_BUTTON, 0L, 0},
		{10, ID_EDIT_FIND, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
		{0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
		{7, ID_HELP_ABOUTHEXECUTE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0}
	};

LPSTR ToolTips[] =
	{
		TEXT("New"),
		TEXT("Open"),
		TEXT("Save"),
		TEXT("Cut"),
		TEXT("Copy"),
		TEXT("Paste"),
		TEXT("Help"),
		TEXT("Undo"),
		TEXT("Redo"),
		TEXT("Search")
	};

// a window handle for the status bar window, the MDI frame, and the MDI children
HWND StatusBar, hWndToolBar, hWndDataBar;
// hte data bar is a new thing I'm going to do, it'll be below the output window
// and will show the different data types from that offset