/*
 * Hexecute 3.0
 * hexecute_defines.h             
 * copyright 2000 Mike Walston
 *
 * This file contains all the globally used definitions
 * in hexecute, things like version number, build number
 * and other things that are all needed at compile time.
 * all of this should be platform independant
 */

// if we don't have the file included yet, let's include it
#ifndef _HEXECUTE_DEFINES
#define _HEXECUTE_DEFINES

#include "resource.h"
#include "afxres.h"

#ifndef _DEBUG
	#define PROGRAM_NAME TEXT("Hexacutie Pie v")
#else
	#define PROGRAM_NAME TEXT("Hexacutie Pie RC7 v3 - Debug")

#endif
#define PROGRAM_MAJOR 3
#define PROGRAM_MINOR 1
#define PROGRAM_BUILD 0
#define MAX_MDI_CHILDREN 4
#define STATUS_BAR 0xFF08
#define TOOLBAR 0xFF09

// custom message
#define HX_OPENFILE WM_USER
#define HX_CHAR WM_APP
#define HX_KEYDOWN 0x8001
#define HX_UNDO 0x8002
#define HX_REDO 0x8003
#define HX_IME_CHAR 0x8004
#define HX_IME_ENDCOMPOSITION 0x8040
#define NO 0
#define YES 1
#define HEX	01
#define DEC 02
#define TIMER_1_SEC 2
#define TIMER_SPLASH 8
#define UNICODE_CHARSET  1   

// History shtuff
#define FIRST_HALF_HEX 0x06
#define SECOND_HALF_HEX 0x07
#define ASCII_CHAR 0x08
#define WIDE_CHAR 0x09
#define SCRIPT_INSERTION 0x0A
#define TAB 0x800b
#define ADDRESS_VIEW_TYPECHANGE 0x800c
#define ARROW_UP 0x800d
#define ARROW_DOWN 0x800e
#define ARROW_LEFT 0x800f
#define ARROW_RIGHT 0x8010
#define VIEW_CHANGE 0x8011
#define HIROM 0x12
#define LOROM 0x13
#define BANK_OFFSET 0x14
#define HEXADECIMAL 0x15
#define DECIMAL 0x16

#define WHITE 0x00FFFFFF

#define IDM_RECENT_FILE0 0x8012
#define IDM_RECENT_FILE1 0x8013
#define IDM_RECENT_FILE2 0x8014
#define IDM_RECENT_FILE3 0x8015

#define IDM_BOOKMARK0 0x801D
#define IDM_BOOKMARK1 0x801E
#define IDM_BOOKMARK2 0x801F
#define IDM_BOOKMARK3 0x8020
#define IDM_BOOKMARK4 0x8021
#define IDM_BOOKMARK5 0x8022
#define IDM_BOOKMARK6 0x8023
#define IDM_BOOKMARK7 0x8024

#define IDM_CODEPAGE0 0x8016
#define IDM_CODEPAGE1 0x8017
#define IDM_CODEPAGE2 0x8018
#define IDM_CODEPAGE3 0x8019
#define IDM_CODEPAGE4 0x801A
#define IDM_CODEPAGE5 0x801B
#define IDM_CODEPAGE6 0x801C

//
#define __4KBANK 0x1000l
#define __8KBANK 0x2000l
#define __16KBANK 0x4000l
#define __32KBANK 0x8000l
#define __64KBANK 0x10000l

// subtable warnings
#define OVERWRITING_END_FLAG 0x01
#define OVERWRITING_START_FLAG 0x02
#define BEYOND_CURRENT_SUBTABLE_BOUNDS 0x04
#define NON_RANGED_SUBTABLES 0x08
#define FLAG_RELOCATION 0x10

//file open returns
#define FILE_NOT_FOUND 0x1212
#define MEM_ERROR 0x1213
#define FILE_OPENED 0x1214
#define FILE_CANCELLED 0x1215

// table file defines
#define TABLE_RUNLENGTH 0x01
#define TABLE_TERMINATING_VALUE 0x02
#define TABLE_FIXEDLENGTH 0x04

typedef struct COMBOBOXTEXT {
	char** Text;
	int iNumStrings;
} COMBOBOXTEXT, *LPCOMBOBOXTEXT;

#define GoToBookmark() \
	si.cbSize = sizeof(SCROLLINFO); \
	si.fMask = SIF_ALL; \
	GetScrollInfo(hWndData, SB_VERT, &si);\
	si.nPos = goToAddress / 16;\
	SetScrollInfo(hWndData, SB_VERT, &si, TRUE);\
	InvalidateRect(hWndData, NULL, FALSE);\
	CurrentPosition = goToAddress % 16;\
	RealPosition = CurrentPosition;\
	yMouse = 0;\
	SetCaretPos( Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar), yMouse * cyChar);\
	UpdateStatusBar(StatusBar, CurrentStartAddress + (yMouse * 16) + ( CurrentPosition % 16 ));

#endif // all done