/*
 * Hexecute 3.0
 * hexecute_globals.h
 * copyright 2000 Mike Walston
 *
 * All global variables are externed from this header
 * This is platform dependant
 */

#include <windows.h>
#include <fstream>
#include "commctrl.h"
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_types.h"
#include "fastmem.h"

// if we've not been here, let's do this
#ifndef _HEXECUTE_GLOBALS
#define _HEXECUTE_GLOBALS
extern WNDCLASS wndclass;
extern TCHAR AppName[];
extern TCHAR DataClass[];
extern TCHAR MainClass[];

// this history shiznit bizzatch, werd
extern historyStack History;
extern int Undo(const historyevent*,HWND);
extern int Redo(const historyevent*,HWND);

// the window processes, WinProc for the main window, and 
// DataWinProc for the child windows
extern LRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK DataWinProc(HWND, UINT, WPARAM, LPARAM);
extern void InitializeWndClassData(WNDCLASS*, HINSTANCE);
extern void InitializeWndClassMain(WNDCLASS*, HINSTANCE);
extern int SaveWork(HWND);
extern int OpenFile(HWND);
extern inline  unsigned char GetFileByte(int);
extern bool SetFileByte(int, unsigned char);
extern bool IncrementFileByte(int, unsigned char);
extern inline unsigned short GetUnicodeFileByte(int);
extern inline bool SetUnicodeFileByte(int, unsigned short);
extern int OpenFile(HWND, char*, char*);
extern int OpenTableFile(HWND);
extern int OpenTableFile(HWND, char*);
extern int CloseFiles(HWND);
extern void ResizeWindows(HWND, HWND, HWND, HWND, int, int);
extern int CalcPosition(int*, int);
extern int ResetPosition(int*);
extern int CheckValueAgainstTable(char, int);
extern int UnsavedTitle(HWND);
extern char* ConvertHexToString(char*);
extern void UpdateStatusBar(HWND, int);
extern void DrawLastLine(HWND, HDC, int&, unsigned long&, unsigned long&, int&, int&, int&, int&, int&, int&, int&, int&, SIZE&, int&);
extern void DrawLine(HWND, HDC, int&, unsigned long&, unsigned long&, int&, int&, int&, int&, int&, int&, int&, int&, SIZE&, int&);
extern void DrawLineUnicode(HWND, HDC, int&, unsigned long&, unsigned long&, int&, int&, int&, int&, int&, int&, int&, int&, SIZE&, int&);
extern void DrawLastLineUnicode(HWND, HDC, int&, unsigned long&, unsigned long&, int&, int&, int&, int&, int&, int&, int&, int&, SIZE&, int&);
//extern void __cdecl FindSubStringsThread(void*);
extern void ProcessText(char*);
extern int SafeMemCopy(unsigned char*, int, char*, int);
extern int SafeMemCopyW(unsigned char*, int, wchar_t*, int);

// dialog procs
extern void SetColors(HDC, int, int, int, int, int, int);
extern int CreatePropertySheet(HWND);
extern BOOL CALLBACK DisplayProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK FontProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK FindProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK InsertProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK ScriptInsertProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK DumpProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK BankSplitProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK ExpandFileProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK TableBasedDirectInputProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK CodePagesProc(LPTSTR);
extern BOOL CALLBACK TableEditorProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK NewSubTableProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK TableFileEditorEditWindowProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK FindingSubTablesProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK SubtableProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK AboutProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK SplashProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK GoToProc(HWND, UINT, WPARAM, LPARAM);
// Menu stuff
extern HMENU HexecuteMenu;
extern HMENU ContextMenu;
extern HANDLE hConsole;
extern void DefaultMenu();
extern void FileOpenedMenu();
extern void CutAndCopyEnableMenu();
extern void CutAndCopyDisableMenu();
extern void AddCodePagesToMenu(HMENU);
extern void CodePageMenu(HWND, int);

//Instance Handles
extern HINSTANCE hInst;
extern DumpStruct Dumpy;
// the file we're gonna open and other file related things
extern TCHAR Filename[MAX_PATH];
extern TCHAR Tablefilename[4][MAX_PATH];
extern TCHAR TitleName[MAX_PATH];
extern TCHAR TableTitleName[MAX_PATH];
extern std::fstream FileStream;
extern unsigned char* File;
extern wchar_t* UnicodeFile;
extern int FileOpen;
extern int Warnings, goToAddress, AllowPaging;
extern int TotalTables;
extern table* Table[4];
extern int ParseTable(std::fstream&, table*, char*);
extern int CurrentTable, HighlightOn, CurrentCodePage;
extern int IsNT4orHigher();
extern int BookMarks[8];
extern int BookmarkCounter;
extern HBITMAP EndLine,
		EndString,
		EndLineMask,
		EndStringMask;
extern DWORD NESOffset, NESPageSize;
extern int IsPagingOn;
extern TCHAR BookmarkStrings[8][256];
extern search_struct SearchData;
extern bool isValue[5], OverWrite;
extern int asteriskCounter;
extern char prevSearches[10][100];

// font stuff
extern long FontHeight, 
			HexFontHeight, 
			JapaneseFontHeight, 
			SimplifiedChineseFontHeight, 
			TraditionalChineseFontHeight,
			KoreanFontHeight, 
			ThaiFontHeight;
extern TCHAR FontName[], 
			HexFontName[], 
			JapaneseFontName[], 
			SimplifiedChineseFontName[], 
			TraditionalChineseFontName[],
			KoreanFontName[], 
			ThaiFontName[];

extern TCHAR UnicodeFontName[];
extern CHOOSEFONT cf;
extern HFONT tblFont[4],hFont,hFontHex, hFontJapanese, hFontUnicode;
extern LOGFONT Font;
extern LOGFONTW UnicodeFont;
extern TEXTMETRIC tm;
extern int RemakeFonts(const int&);
extern LOGFONT	kamaitachiLogFont;
extern HFONT	kamaitachiHFont;
// search stuff
extern int RelativeSearch(char*, int, int);
extern int ValueSearch(char*, int, int);
extern SCROLLINFO si;

//miscellaneous
extern TCHAR Filters[];
extern TCHAR TableFilter[];
extern long MaxAddress;
extern int NewFile;
extern bool Saved, BigEndian, InsideSubtable;
extern HWND SearchWindow, hWndData, hWndFont;
extern tableEntry emptyNode;
extern int cxChar, cyChar, LeftOverChars[100], 
		   ViewAsHiRom, ViewAsLoRom, ViewAsNES,
		   width, height, HexOrDec, mmhmm;
extern long CurrentStartAddress;
extern POINT CursorPoint;
extern int CurrentPosition, RealPosition, MouseRow;
extern int yMouse;
extern int **Positions, wasabi, Value, Relative, HorizontalOffset, NumPages;
extern char searching[100];
extern int Text, startHighlight, endHighlight;
extern char f00;
extern long CF_HEXECUTE;
extern int GroupSize;
extern int PositionInit[8][32], CleanUp;
extern CodePage CPages[20];
extern int InstalledPage;
extern int DumpPositions();
extern int GetCPIndex(unsigned int);
extern int GetCPIndex(char*);
extern int SavedTitle(HWND hWnd);
extern bool UnicodeOutput;
extern Page CurrentPage;
extern int* PagesAltered;

// color stuff for the output
extern long AddressColor, 
			AddressBGColor,
			OddColumnColor,
			EvenColumnColor,
			HexBGColor,
			HighlightColor,
			TextColor,
			TextBGColor,
			HighlightTextColor;

// this stuff is for the varying hex outputs
extern inline int HexOutputWord(HDC, int, int, int, int, int, int, int, int,int, int, int, int, int);
extern inline int HexOutputByte(HDC, int, int, int, int, int, int, int, int,int, int, int, int, int);
extern inline int HexOutputInt(HDC, int, int, int, int, int, int, int, int,int, int, int, int, int);
extern inline int HexOutputQWord(HDC, int, int, int, int, int, int, int, int,int, int, int, int, int);

//dialog stuff
extern LPCOMBOBOXTEXT cbtTextRelative, cbtTextValue, cbtDecimal;
extern void InitializeComboBoxArray(COMBOBOXTEXT[3]);
extern void CleanUpComboBoxArray(COMBOBOXTEXT[3]);
extern void SetComboBoxText(HWND, COMBOBOXTEXT*);
extern void SaveLastComboBoxText(HWND, char*, char*, char*, const int&, const int&, 
						  const int&, const int&, const int&);

//toolbar buttons
extern TBBUTTON tbButtons[];
extern LPSTR ToolTips[]; // tooltip messages

// clipboard stuff
extern void CopyAsText(HWND, HGLOBAL, PTSTR);
extern void CopyAsCharArray(HWND, HGLOBAL, PTSTR);
extern void CopyAsShortArray(HWND, HGLOBAL, PTSTR);
extern void CopyAsIntArray(HWND, HGLOBAL, PTSTR);
extern void CopyString(char*, int, int);

// registry shtuff
extern TCHAR HexecuteAppKey[];
extern TCHAR AddressColorKey[];
extern TCHAR AddressBGColorKey[];
extern TCHAR OddColumnColorKey[];
extern TCHAR EvenColumnColorKey[];
extern TCHAR HexBGColorKey[];
extern TCHAR HighlightColorKey[];
extern TCHAR TextColorKey[];
extern TCHAR TextBGColorKey[];
extern TCHAR CurrentCodePageKey[];
extern TCHAR HighlightTextColorKey[];
extern TCHAR* RecentFile0;
extern TCHAR* RecentFile1;
extern TCHAR* RecentFile2;
extern TCHAR* RecentFile3;
extern TCHAR* RecentFileTitle0;
extern TCHAR* RecentFileTitle1;
extern TCHAR* RecentFileTitle2;
extern TCHAR* RecentFileTitle3;
extern TCHAR RecentFile0Key[];
extern TCHAR RecentFile1Key[];
extern TCHAR RecentFile2Key[];
extern TCHAR RecentFile3Key[];
extern TCHAR RecentFileTitle0Key[];
extern TCHAR RecentFileTitle1Key[];
extern TCHAR RecentFileTitle2Key[];
extern TCHAR RecentFileTitle3Key[];
extern TCHAR NumRecentFilesKey[];
extern TCHAR CodePagesKey[];
extern TCHAR NumPagesKey[];
extern TCHAR *Pages;
extern TCHAR HexFontKey[];
extern TCHAR HexFont[];
extern TCHAR UnicodeFontKey[],
		CommandLine[1000],
		CommandLineTitle[1000],
		SizeKey[];
extern int NumRecentFiles;
extern int InitializeFromRegistry();
extern int SaveSettingsToRegistry();
extern TCHAR ShowSplashKey[];
extern int ShowSplash;
extern HIMAGELIST hImageList;
extern TCHAR AllowPagingKey[];

//conversions
extern inline DWORD SMCToLoROM(DWORD dwSMC);
extern inline DWORD LoROMToSMC(DWORD dwLoROM);
extern inline DWORD SMCToHiROM(DWORD dwSMC);
extern inline DWORD HiROMToSMC(DWORD dwHiROM);
extern inline WORD NEStoOffset(DWORD dwNES, DWORD PageSize, DWORD StartingOffset);
extern void DoInsertConversion(TCHAR* Convert);
extern inline int hex_lower(unsigned int, unsigned int);
extern inline int hex_upper(unsigned int, unsigned int);
extern inline unsigned char ReturnHex(unsigned char*, int);
extern inline int FindPosition(int);
extern int memcpyW(unsigned char*, wchar_t*, int);
extern wchar_t MakeUnicodeBigEndian(wchar_t);

// a window handle for the status bar window, the MDI frame, and the MDI children
extern HWND StatusBar, hWndToolBar, hWndDataBar;
#endif // we're done, let's quit