// Updated on 5/14/2012 by Nicolas Livaditis (AKA NightWolve)
// WWW:   http://www.ysutopia.net/
// Email: nlivadit@yahoo.com
// Version: 3.10 (crash fix version from original source)
/*
This software seems to have been abandoned by Mike Walston and is about 10
years old since this release. It used to work well enough, but I couldn't
open anything in S-JIS/932 mode without it crashing, so given that the source
was always included, I did the following:

 1) I first had to convert the source code to Visual C++ 2005 Express Edition!
    (Not so easy, many syntax changes going from the ole VC++ 6.0). BTW, DO
    NOT upgrade it to VC++ 201X! 2005 is the last version that compiles an EXE
    that'll work on Win98/ME/NT/2K, that's why I didn't use a newer version!
 2) Debugged for a day and managed to fix a couple of crash points
    manifested by the hex view not being loaded when anything other than
    the Unicode code page was selected. So, I think I fixed most crashes and
    a buffer overflow condition, lemme know if not.
 3) Commandline opening of a file: if you put a shortcut in the 'Send To'
    folder and whenever you right click a file and select Send To, it
    will now open the file.


 * Hexecute 3.0 rc7v2++
 * main.cpp
 * copyright 2000 Mike Walston
 * 
 * This is the main file, it will hold WinMain
 */
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

/*
 * OPTIONS FOR IDC_EDIT1:
 *	multiline
 *	auto-hscroll
 *	auto-vscroll
 *	want return
 *	visible
 *	tab stop
 */

// window class
WNDCLASS wndclass;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
				   LPSTR lpCmdLine, int iCmdShow)
{
	TCHAR szDrive[MAX_PATH], szDir[MAX_PATH], szName[MAX_PATH], szExt[MAX_PATH];

	if( lpCmdLine && *lpCmdLine ) {
		while ( *lpCmdLine == '"' )
			lpCmdLine++;
		fpstrlen(lpCmdLine);
		__asm dec EDI
		__asm dec EDI
		__asm CMP BYTE PTR [EDI], '"'
		__asm JNZ SKIP_NO_QUOTE
		__asm MOV BYTE PTR [EDI], 0
SKIP_NO_QUOTE:
		fmemcpy2(LEA, CommandLine, MOV, lpCmdLine, ECX);
		_splitpath(CommandLine, szDrive, szDir, szName, szExt);
		strcat(szName, szExt);
		fstrcpy(CommandLineTitle, szName);
	}
	fmemzero(SearchData, SIZE SearchData);
	fmemzero(prevSearches, SIZE prevSearches);
	// accelerator handles
	HACCEL hAccel;

	// window Handles
	HWND hWnd;

	// message
	MSG msg;

	// temporary character string
	char tempWindowName[128];

	// store the current instance in a global variable
	hInst = hInstance;

	Warnings = OVERWRITING_END_FLAG | OVERWRITING_START_FLAG;

	EndLine = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAPNEWLINE));
	EndString = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAPENDSTRING));
	EndLineMask = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAPNEWLINEMASK));
	EndStringMask = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAPENDSTRINGMASK));

	hImageList = ImageList_Create(16,16, ILC_COLOR8 | ILC_MASK, 2, 16);
	ImageList_AddMasked(hImageList, EndLine, 0x00FF00FF);
	ImageList_AddMasked(hImageList, EndString, 0x00FF00FF);

	DeleteObject(EndLine);
	DeleteObject(EndString);
	DeleteObject(EndLineMask);
	DeleteObject(EndStringMask);

	// we don't have an open file
	FileOpen = 0;
	CurrentTable = -1;
	// load the keyboard accelerators
	hAccel = LoadAccelerators(hInstance, TEXT("HEXECUTE"));
	HexecuteMenu = LoadMenu(hInstance, TEXT("HexecuteMenu"));

	// initialize empty table entry
	emptyNode.value = 0;
	emptyNode.string = (TCHAR*)GlobalAlloc(GHND, 10 * sizeof(TCHAR));
	emptyNode.string[0] = '.';
	emptyNode.string[1] = 0;

	//initialize and register the main window class
	InitializeWndClassMain(&wndclass, hInstance);
	if(!RegisterClass(&wndclass))
	{
		MessageBox(NULL, TEXT("Window Main Class Failed to Register"),
				   AppName, MB_ICONERROR);
		return 0;
	}

	//initialize and register the data window class
	InitializeWndClassData(&wndclass, hInstance);
	if(!RegisterClass(&wndclass))
	{
		MessageBox(NULL, TEXT("Window Frame Class Failed to Register"),
				   AppName, MB_ICONERROR);
		return 0;
	}

	// get the registry keys
	// this one gets the colors and stuff
	InitializeFromRegistry();
	if(ShowSplash)
		DialogBox(hInstance, MAKEINTRESOURCE(IDD_SPLASH), NULL, SplashProc);
	// This creates the window, without any other special features
	wsprintf(tempWindowName, "%s %d.%d.%d", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD);
	hWnd = CreateWindow(MainClass, tempWindowName,
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT,
					   NULL, NULL, hInstance, NULL);

	// show and update hWnd
	//DragAcceptFiles(hWnd, TRUE);
	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	// get the registry keys
	// this one puts the recent files on the menu
	InitializeFromRegistry();
	RemakeFonts(NULL);
	// Nicolas - Fix no grid crash bug
	SendMessage(hWnd, WM_DISPLAYCHANGE, NULL, NULL);

	// the main message loop, messages will be received, translated, and dispatched
	// in these few lines
	while(GetMessage(&msg, NULL, 0,0))
	{
		if( !IsDialogMessage(SearchWindow, &msg) )
		{
			if(!TranslateAccelerator(hWnd, (HACCEL)hAccel, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}

	return msg.wParam;
}
